package com.grendelscan.GUI;
import java.io.*;
import java.util.Date;
import java.util.regex.*;
import java.net.URI;
import java.net.URISyntaxException;

import org.apache.commons.configuration.ConfigurationException;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.CTabFolder;
import org.eclipse.swt.custom.CTabItem;
import org.eclipse.swt.custom.SashForm;
import org.eclipse.swt.custom.ScrolledComposite;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.*;

import com.cloudgarden.resource.SWTResourceManager;
import com.grendelscan.GrendelScan;
import com.grendelscan.GUI.Verifiers.EnforceIntegersOnly;
import com.grendelscan.GUI.customControls.*;
import com.grendelscan.requester.authentication.*;
import com.grendelscan.requester.http.factories.UriFactory;
import com.grendelscan.scan.ConfigurationManager;
import com.grendelscan.scan.Scan;
import com.grendelscan.scan.ScanSettings;
import com.grendelscan.scan.reporting.*;
import com.grendelscan.tests.testModules.TestModule;
import com.grendelscan.tests.testModules.settings.*;
import com.grendelscan.utils.*;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class ScanSettingsWindow extends org.eclipse.swt.widgets.Composite {

	{
		//Register as a resource user - SWTResourceManager will
		//handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}
	private String generalSettingsHelpText; 
	
	private CTabFolder tabFolder;
	private boolean scanStarted = false;
	private Composite testModuleTabComposite;
	private Label maxTotalConnectionsLabel;
	private Label maxConnectionsPerServerLabel;
	private Label maxRequestsPerSecondLabel;
	private Text maxProxyThreadTextBox;
	private ScrolledComposite testModuleSettingsScrolledComposite;
	private Label maxProxyThreadLabel;
	private Text maxCategorizerThreadTextBox;
	private Text maxTesterThreadTextBox;
	private Text maxRequesterThreadTextbox;
	private Group threadSettingsGroup;
	private Label maxRequesterThreadsLabel;
	private Label maxTesterThreadsLabel;
	private Group proxySettingsGroup;
	private Button upstreamProxyNTLMAuthenticationRadioButton;
	private Button upstreamProxyDigestAuthenticationRadioButton;
	private Button upstreamProxyBasicAuthenticationRadioButton;
	private Group upstreamProxyAuthenticationTypeGroup;
	private Text upstreamProxyPasswordTextBox;
	private Label upstreamProxyPasswordLabel;
	private Label upstreamProxyUsernameLabel;
	private Text upstreamProxyUsernameTextBox;
	private Text upstreamProxyPortTextBox;
	private Text upstreamProxyAddressTextBox;
	private AddRemoveListComposite knownSessionIDListComposite;
	private Group knownSessionIDsGroup;
	private Label experimentalLabel;
	private Button runAuthWizardButton;
	private Text socketReadTimeoutTextBox;
	private Label socketReadTimeoutLabel;
	private Text maxConsecutiveFailedRequestsTextBox;
	private Label maxConsecutiveFailedRequestsLabel;
	private Button outputDirectoryBrowseButton;
	private Text outputDirectoryTextBox;
	private Label outputDirectoryLabel;
	private Group outputGroup;
	private Label useragentLabel;
	private Combo useragentComboBox;
	private Group miscHttpClientGroup;
	private Button useAuthenticationCheckBox;
	private Text maxFailedRequestsPerServerTextBox;
	private Label maxFailedRequestsPerServerLabel;
	private Text maxTotalRequestsTextBox;
	private Label maxTotalRequestsLabel;
	private Button useUpstreamProxyCheckBox;
	private Label upstreamProxyPortLabel;
	private Label upstreamProxyAddressLabel;
	private Group upstreamProxyGroup;
	private Group httpClientLimitsGroup;
	private Button testEveryDirectoryCheckBox;
	private Label reportMinSeverityLabel;
	private Combo reportMinSeverityCombo;
	private Button reportFilenameBrowseButton;
	private Label reportFileNameLabel;
	private Text reportFileNameTextbox;
//	private Button xmlReportRadio;
//	private Button pdfReportRadio;
	private Button htmlReportRadio;
	private Button textReportRadio;
	private Group reportTypeGroup;
	private Group reportingGroup;
	private TableColumn domainColumn;
	private TableColumn passwordColumn;
	private Button accountRemoveButton;
	private Button accountAddButton;
	private Button showPasswordsCheckbox;
	private TableColumn usernameColumn;
	private Table accountsTable;
	private Group accountsGroup;
	private Label authenticationUrlLabel;
	private CTabItem authenticationTab;
	private CTabItem scanRestrictionsTab;
	private CTabItem httpClientTab;
	private CTabItem generalSettingsTab;
	private CTabItem testModuleSelectionTab;

	private TableColumn responseCodeRegexColumn;
	private TableColumn responseCodeCodeColumn;
	private Table responseCodeOverrideTable;
	private Text postQueryTextbox;
	private Label postQueryLabel;
	private Text authenticationUrlTextBox;
	private Button httpPostRadio;
	private Button httpGetRadio;
	private Group httpMethodGroup;
	private Text urlWhitelistTextBox;
	private Button urlWhitelistRemoveButton;
	private Button urlWhitelistAddButton;
	private Text domainFieldTextbox;
	private Button useDomainCheckbox;
	private Label domainFieldLabel;
	private Text passwordFieldTextbox;
	private Label passwordFieldLabel;
	private Label usernameFieldLabel;
	private Text usernameFieldTextbox;
	private Group formAuthenticationGroup;
	private Text domainTextBox;
	private Label domainLabel;
	private Button htmlFormAuthenticationRadio;
	private Button httpAuthenticationRadio;
	private Group authenticationTypeGroup;
	private Text passwordTextBox;
	private Label passwordLabel;
	private Text usernameTextBox;
	private Label usernameLabel;
	private Composite authenticationComposite;
	private Text baseUrlTextBox;
	private Button baseUrlRemoveButton;
	private Button baseUrlAddButton;
	private List baseUrlList;
	private Group baseUrlsGroup;
	private Composite httpClientComposite;
	private TreeItem allTestModulesTreeItem;
	private Text testModuleDescriptionTextArea;
	private Tree testModuleTree;
	private Composite testModuleSettingsComposite;
	private Composite testModuleDescriptionComposite;
	private SashForm testModuleDetailsSashForm;
	private Composite testModuleTreeComposit;
	private SashForm testModuleTabSashForm;
	private Button manualOverrideRemoveButton;
	private Button manualOverrideAddButton;
	private Text httpResponseCode;
	private Text regexOverrideTextbox;
	private Label manualOverrideRegexLabel;
	private Label manualOverrideCodeLabel;
	private Button useAutomaticOverridesCheckBox;
	private Group responseCodeGroup;
	private List urlWhitelistList;
	private Group urlWhitelistGroup;
	private Text urlBlacklistTextBox;
	private Button urlBlacklistRemoveButton;
	private Button urlBlacklistAddButton;
	private List urlBlacklistList;
	private Group urlBlacklistGroup;
	private Text forbiddenParamterTextBox;
	private Button forbiddenParameterRemoveButton;
	private Button forbiddenParameterAddButton;
	private List forbiddenParameterList;
	private Group forbiddenParamterGroup;
	private Text ignoredParameterTextBox;
	private Button ignoredParameterRemoveButton;
	private Button ignoredParameterAddButton;
	private List ignoredParameterList;
	private Group ignoredParameterGroup;
	private Composite scanRestrictionsComposite;
	private Button enableProxyCheckBox;
	private Text proxyBindPortTextBox;
	private Text proxyBindAddressTextBox;
	private Label proxyBindPortLabel;
	private Label proxyBindAddressLabel;
	private Text maxFileSizeTextBox;
	private Label maxFileSizeLabel;
	private Text maxTotalConnectionsTextBox;
	private Text maxConnectionsPerServerTextBox;
	private Text maxRequestsPerSecondTextBox;
	private Label maxCategorizerThreadsLabel;
	private Composite generalSettingsComposite;
	private ScanSettings scanSettings;
	private Scan scan;
	private static Shell shell;
	private String scanRestrictionsHelpText;
	private String authenticationHelpText;
	private String httpClientHelpText;
	private String moduleSelectionHelpText;
	private Menu menuBar;
	
	
	public static void showScanGUI(Scan scan)
	{
		Display display = Display.getDefault();
		shell = new Shell(display);
		shell.addListener (SWT.Close, new Listener () {
			public void handleEvent (Event event) 
			{
				event.doit = promptExit(shell);
			}
		});
		
//		MessageDialog m = new MessageDialog(shell);
//		m.open("Update me!", "This version of Grendel-Scan is out of date. \n" +
//				"You really should visit www.grendel-scan.com");
		ScanSettingsWindow scanSettingsWindow = new ScanSettingsWindow(shell, SWT.NULL, scan);
		scan.setScanSettingsWindow(scanSettingsWindow);
		Point size = scanSettingsWindow.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		shell.setText(GrendelScan.versionText + " - Scan Configuration");
		if(size.x == 0 && size.y == 0) 
		{
			scanSettingsWindow.pack();
			shell.pack();
			shell.setSize(645, 464);
		} 
		else 
		{
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		scanSettingsWindow.setScan(scan);
		scanSettingsWindow.populateModules();
		shell.open();
		while (!shell.isDisposed()) 
		{
			if (!display.readAndDispatch())
				display.sleep();
		}
		
		if (!scanSettingsWindow.isScanStarted())
		{
			System.exit(1);
		}
		
	}
		
	private void changeCheckChildren(TreeItem node, boolean checked)
	{
		node.setChecked(checked);
		for (TreeItem child: node.getItems())
		{
			changeCheckChildren(child, checked);
		}
		if (node.getData() instanceof TestModule)
		{
			TestModule module = (TestModule) node.getData();
			if (checked)
			{
				scanSettings.enableTestModule(module.getModuleNumber());
			}
			else
			{
				scanSettings.disableTestModule(module.getModuleNumber());
			}
		}
	}
	
	public void populateModules()
	{
		testModuleTree.removeAll();
		allTestModulesTreeItem = new TreeItem(testModuleTree, SWT.NONE);
		allTestModulesTreeItem.setText("All test modules");
		allTestModulesTreeItem.setExpanded(true);
		for (TestModule module: scanSettings.getMasterTestModuleCollection().getAllTestModules())
		{
			if (!module.hidden())
			{
				checkModuleTreeBranch(module);
			}
		}
		allTestModulesTreeItem.setExpanded(true);
	}
	
	
	private void checkModuleTreeBranch(TestModule module)
	{
		TreeItem currentNode = allTestModulesTreeItem;
		String path = module.getGUIDisplayPath().getText();
		for (String nodeName: path.split("\\\\"))
		{
			TreeItem nextNode = (TreeItem) currentNode.getData(nodeName);
			if (nextNode == null)
			{
				TreeItem newNode;
				newNode = new TreeItem((TreeItem)currentNode, SWT.NONE);
				newNode.setText(nodeName);
				newNode.setExpanded(true);
				currentNode.setData(nodeName, newNode);
				nextNode = newNode;
				
			}
			currentNode = nextNode;
		}

		TreeItem moduleTreeItem = new TreeItem((TreeItem)currentNode, SWT.CHECK);
		moduleTreeItem.setText((module.isExperimental() ? "* ": "") + module.getName());
		moduleTreeItem.setData(module);
		moduleTreeItem.setChecked(scanSettings.getMasterTestModuleCollection().isModuleEnabled(module));
		currentNode.setExpanded(true);
		
	}
	
	
	public ScanSettingsWindow(org.eclipse.swt.widgets.Composite parent, int style, Scan scan) 
	{
		super(parent, style);
		this.scan = scan;
		this.scanSettings = scan.getScanSettings();
		initGUI();
		displayScanSettings();
	}

	private void initGUI() 
	{

		EnforceIntegersOnly numbersOnlyVerifyer = new EnforceIntegersOnly();
		try 
		{
			Image icon = new Image(getDisplay(), GrendelScan.defaultConfigDirectory + File.separator + "icon.JPG");
			this.getShell().setImage(icon);
			FillLayout thisLayout = new FillLayout(org.eclipse.swt.SWT.HORIZONTAL);
			this.setLayout(thisLayout);
			this.setSize(878, 627);
			{
				menuBar = new Menu(shell, SWT.BAR);
				shell.setMenuBar(menuBar);
				{
					MenuItem scanItem = new MenuItem (menuBar, SWT.CASCADE);
					scanItem.setText ("&File");
					Menu scanSubmenu = new Menu (shell, SWT.DROP_DOWN);
					scanItem.setMenu(scanSubmenu);
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&New Scan Settings (Defaults)");
						item.addListener (SWT.Selection, new Listener () 
						{
							public void handleEvent (Event e) 
							{
								scanSettings.loadDefaultSettings(scan);
								displayScanSettings();
							}
						});
					}
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&Open Scan Settings");
						item.addListener (SWT.Selection, new Listener () 
						{
							public void handleEvent (Event e) 
							{
								FileDialog fd = new FileDialog(shell, SWT.OPEN);
								fd.setFilterPath("." + File.separator +GrendelScan.defaultConfigDirectory + File.separator + scanSettings.getScanConfigDir());
								fd.setFilterExtensions(new String[] {"*.scan"});
								fd.setText("Open settings file name");
								String filename = fd.open();
								if (filename != null)
								{
									try
                                    {
										scanSettings.loadScanSettings(scan, filename);
										displayScanSettings();
                                    }
                                    catch (ConfigurationException e1)
                                    {
	                                    MessageBox m = new MessageBox(shell);
	                                    m.setText("Error");
	                                    m.setMessage("Problem loading scan settings: \n" + e1.toString());
	                                    m.open();
                                    }
								}
							}
						});
					}
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&Save Scan Settings");
						item.addListener (SWT.Selection, new Listener () 
						{
							public void handleEvent (Event e) 
							{
								if (commitSettings(true))
								{
									FileDialog fd = new FileDialog(shell, SWT.SAVE);
									fd.setFilterPath("." + File.separator +GrendelScan.defaultConfigDirectory + File.separator + scanSettings.getScanConfigDir());
									fd.setFilterExtensions(new String[] {"*.scan"});
									fd.setText("Save settings file name");
									String filename = fd.open();
									if (filename != null)
									{
										try
	                                    {
		                                    scanSettings.saveScanSettings(filename);
	                                    }
	                                    catch (ConfigurationException e1)
	                                    {
		                                    MessageBox m = new MessageBox(shell);
		                                    m.setText("Error");
		                                    m.setMessage("Problem saving scan settings: \n" + e1.toString());
		                                    m.open();
	                                    }
									}
								}
							}
						});

					}
					{
						new MenuItem (scanSubmenu, SWT.SEPARATOR);
					}
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("E&xit");
						item.addListener (SWT.Selection, new Listener () {
							public void handleEvent (Event e) {
								if (promptExit(shell))
								{
									getParent().dispose();
									System.exit(0);
								}
							}
						});
					}
				}
				{
					MenuItem scanItem = new MenuItem (menuBar, SWT.CASCADE);
					scanItem.setText ("&Scan");
					Menu scanSubmenu = new Menu (shell, SWT.DROP_DOWN);
					scanItem.setMenu(scanSubmenu);
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&Start Scan");
						item.addListener (SWT.Selection, new Listener () 
						{
							public void handleEvent (Event e) 
							{
								scanSettings.setOutputDirectory(outputDirectoryTextBox.getText());
								scanSettings.setLoadDatabase(false);
								scanSettings.setProxyOnly(false);
								startScan();
							}
						});
					}
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&Run Proxy Only");
						item.addListener (SWT.Selection, new Listener () 
						{
							public void handleEvent (Event e) 
							{
								scanSettings.setOutputDirectory(outputDirectoryTextBox.getText());
								scanSettings.setLoadDatabase(false);
								scanSettings.setProxyOnly(true);
								startScan();
								
							}
						});
					}
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&Load Previous Scan");
						item.addListener (SWT.Selection, new Listener () 
						{
							public void handleEvent (Event e) 
							{
								scanSettings.setLoadDatabase(true);
								scanSettings.setProxyOnly(true);
								DirectoryDialog dd = new DirectoryDialog(shell);
								try
                                {
	                                dd.setFilterPath(new File(".").getCanonicalPath());
                                }
                                catch (IOException e1)
                                {
                                }
								dd.setText("Previous scan directory");
								String dirName = dd.open();
								if (dirName != null && !dirName.equals(""))
								{
									String fullDirName = dirName + File.separator + scanSettings.getTransactionRecordDirectory();
									if (!new File(fullDirName).exists())
									{
										displayInternalMessage("Error:", "The target directory has no \"" + scanSettings.getTransactionRecordDirectory() + "\" sub-directory.");
									}
									else 
									{
										scanSettings.setOutputDirectory(dirName);
										scanSettings.setLoadDatabase(true);
										scanSettings.setProxyOnly(true);
										startScan();
									}
								}
							}
						});
					}
				}
				{
					MenuItem scanItem = new MenuItem (menuBar, SWT.CASCADE);
					scanItem.setText ("&Help");
					Menu scanSubmenu = new Menu (shell, SWT.DROP_DOWN);
					scanItem.setMenu(scanSubmenu);
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&Help Contents");
						item.addListener (SWT.Selection, new Listener () {
							public void handleEvent (Event e) {
								showHelp("");
							}
						});
					}
					{
						MenuItem item = new MenuItem (scanSubmenu, SWT.PUSH);
						item.setText("&About");
						item.addListener (SWT.Selection, new Listener () {
							public void handleEvent (Event e) {
								MessageBox box = new MessageBox(shell);
								box.setText("About " + GrendelScan.versionText);
								box.setMessage(GrendelScan.versionText + "\n" +
										"\n" +
										"Grendel-Scan was created by David Byrne\n" +
										"with imporant contributions by Eric\n" +
										"Duprey. It is licensed under the GNU\n" +
										"Public License version 3 (GPLv3).\n" +
										"\n" +
										"Please visit our website at\n" +
										"www.grendel-scan.com for more information.");
								box.open();
							}
						});
					}
				}
			}
			{
				{
					tabFolder = new CTabFolder(this, SWT.BORDER);
					tabFolder.setSelection(0);
					{
						generalSettingsTab = new CTabItem(tabFolder, SWT.NONE);
						generalSettingsTab.setText(" General Settings ");
						{
							generalSettingsComposite = new Composite(tabFolder, SWT.NONE);
							generalSettingsComposite.setLayout(null);
							generalSettingsTab.setControl(generalSettingsComposite);
							generalSettingsComposite.setDragDetect(false);
							generalSettingsComposite.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
							{
								proxySettingsGroup = new Group(generalSettingsComposite, SWT.NONE);
								proxySettingsGroup.setLayout(null);
								proxySettingsGroup.setText("Internal Proxy Settings");
								proxySettingsGroup.setBounds(12, 6, 323, 169);
								proxySettingsGroup.setToolTipText("The built-in proxy server allows you to guide \nthe scan by navigating the website from your\nbrowser, while it's pointed at the proxy. This is\nan alternative to the spidering modules.");
								proxySettingsGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									enableProxyCheckBox = new Button(proxySettingsGroup, SWT.CHECK | SWT.LEFT);
									enableProxyCheckBox.setBounds(12, 27, 178, 30);
									enableProxyCheckBox.setText("Enable internal proxy");
									enableProxyCheckBox.setEnabled(true);
									enableProxyCheckBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									enableProxyCheckBox.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{ 
												updateProxyStatus();
											}
										}
									);
								}
								{
									proxyBindAddressLabel = new Label(proxySettingsGroup, SWT.NONE);
									proxyBindAddressLabel.setText("Proxy bind address:");
									proxyBindAddressLabel.setBounds(12, 63, 153, 25);
									proxyBindAddressLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									proxyBindAddressTextBox = new Text(proxySettingsGroup, SWT.BORDER);
									proxyBindAddressTextBox.setBounds(171, 63, 125, 25);
									proxyBindAddressTextBox.setToolTipText("this is a test");
									proxyBindAddressTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									proxyBindPortLabel = new Label(proxySettingsGroup, SWT.NONE);
									proxyBindPortLabel.setText("Proxy bind port:");
									proxyBindPortLabel.setBounds(12, 94, 135, 25);
									proxyBindPortLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									proxyBindPortTextBox = new Text(proxySettingsGroup, SWT.BORDER);
									proxyBindPortTextBox.setBounds(171, 94, 50, 25);
									proxyBindPortTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									proxyBindPortTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
								{
									maxProxyThreadLabel = new Label(proxySettingsGroup, SWT.NONE);
									maxProxyThreadLabel.setText("Max proxy threads:");
									maxProxyThreadLabel.setBounds(12, 125, 153, 25);
									maxProxyThreadLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxProxyThreadTextBox = new Text(proxySettingsGroup, SWT.BORDER);
									maxProxyThreadTextBox.setBounds(171, 125, 33, 25);
									maxProxyThreadTextBox.setTextLimit(2);
									maxProxyThreadTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									maxProxyThreadTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
								updateProxyStatus();
							}
							{
								threadSettingsGroup = new Group(generalSettingsComposite, SWT.NONE);
								threadSettingsGroup.setLayout(null);
								threadSettingsGroup.setText("Thread Settings");
								threadSettingsGroup.setBounds(362, 6, 263, 128);
								threadSettingsGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									maxRequesterThreadsLabel = new Label(threadSettingsGroup, SWT.NONE);
									maxRequesterThreadsLabel.setText("Max requester threads:");
									maxRequesterThreadsLabel.setBounds(12, 25, 153, 25);
									maxRequesterThreadsLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxCategorizerThreadsLabel = new Label(threadSettingsGroup, SWT.NONE);
									maxCategorizerThreadsLabel.setText("Max categorizer threads:");
									maxCategorizerThreadsLabel.setBounds(12, 86, 160, 25);
									maxCategorizerThreadsLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxTesterThreadsLabel = new Label(threadSettingsGroup, SWT.NONE);
									maxTesterThreadsLabel.setText("Max tester threads:");
									maxTesterThreadsLabel.setBounds(12, 56, 166, 18);
									maxTesterThreadsLabel.setSize(166, 25);
									maxTesterThreadsLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxRequesterThreadTextbox = new Text(threadSettingsGroup, SWT.BORDER);
									maxRequesterThreadTextbox.setBounds(202, 25, 33, 25);
									maxRequesterThreadTextbox.setTextLimit(2);
									maxRequesterThreadTextbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									maxRequesterThreadTextbox.addVerifyListener(numbersOnlyVerifyer);
								}
								{
									maxTesterThreadTextBox = new Text(threadSettingsGroup, SWT.BORDER);
									maxTesterThreadTextBox.setBounds(202, 56, 33, 25);
									maxTesterThreadTextBox.setTextLimit(2);
									maxTesterThreadTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									maxTesterThreadTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
								{
									maxCategorizerThreadTextBox = new Text(threadSettingsGroup, SWT.BORDER);
									maxCategorizerThreadTextBox.setBounds(202, 86, 33, 25);
									maxCategorizerThreadTextBox.setTextLimit(2);
									maxCategorizerThreadTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									maxCategorizerThreadTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
							}
							{
								baseUrlsGroup = new Group(generalSettingsComposite, SWT.NONE);
								baseUrlsGroup.setText("Base URLs");
								baseUrlsGroup.setBounds(13, 187, 840, 118);
								baseUrlsGroup.setLayout(null);
								baseUrlsGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									baseUrlTextBox = new Text(baseUrlsGroup, SWT.BORDER);
									baseUrlTextBox.setBounds(16, 36, 337, 25);
									baseUrlTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									baseUrlAddButton = new Button(baseUrlsGroup, SWT.PUSH | SWT.CENTER);
									baseUrlAddButton.setText("Add");
									baseUrlAddButton.setBounds(369, 32, 70, 30);
									baseUrlAddButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									baseUrlAddButton.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													if (!baseUrlTextBox.getText().equals(""))
													{
														if (!URIStringUtils.validateURISyntax(baseUrlTextBox.getText(), true))
														{
															displayInternalMessage("Error", "Invalid base URL format. Note that base URLs must be absolute.");
														}
														else
														{	
															baseUrlList.add(baseUrlTextBox.getText());
															baseUrlTextBox.setText("");
														}
													}
												}
											}
									);
								}
								{
									baseUrlRemoveButton = new Button(baseUrlsGroup, SWT.PUSH | SWT.CENTER);
									baseUrlRemoveButton.setText("Remove");
									baseUrlRemoveButton.setBounds(369, 74, 70, 30);
									baseUrlRemoveButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									baseUrlRemoveButton.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													for (String value: baseUrlList.getSelection())
													{
														baseUrlTextBox.setText(value);
														baseUrlList.remove(value);
													}
													
											}
											}		
									);
								}
								{
									baseUrlList = new List(baseUrlsGroup, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER | SWT.SINGLE);
									for(String uri: ConfigurationManager.getStringArray("defaults.base_uris"))
									{
										baseUrlList.add(uri);
									}
									baseUrlList.setBounds(459, 32, 374, 72);
									baseUrlList.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
							}
							{
								outputGroup = new Group(generalSettingsComposite, SWT.NONE);
								outputGroup.setLayout(null);
								outputGroup.setText("Scan Output");
								outputGroup.setBounds(13, 311, 840, 76);
								outputGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									outputDirectoryLabel = new Label(outputGroup, SWT.NONE);
									outputDirectoryLabel.setText("Output directory:");
									outputDirectoryLabel.setBounds(12, 24, 115, 30);
									outputDirectoryLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									outputDirectoryTextBox = new Text(outputGroup, SWT.BORDER);
									outputDirectoryTextBox.setBounds(139, 24, 362, 25);
									outputDirectoryTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									outputDirectoryBrowseButton = new Button(outputGroup, SWT.PUSH | SWT.CENTER);
									outputDirectoryBrowseButton.setText("Browse");
									outputDirectoryBrowseButton.setBounds(515, 24, 70, 30);
									outputDirectoryBrowseButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									outputDirectoryBrowseButton.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													DirectoryDialog dd = new DirectoryDialog(shell);
													dd.setText("Output directory name");
													try
					                                {
						                                dd.setFilterPath(new File(".").getCanonicalPath());
					                                }
					                                catch (IOException e1)
					                                {
					                                }
													String directory = dd.open();
													if (directory != null)
													{
														outputDirectoryTextBox.setText(directory);
													}
												}
											}
									);
								}
							}
							{
								reportingGroup = new Group(generalSettingsComposite, SWT.NONE);
								reportingGroup.setLayout(null);
								reportingGroup.setText("Reporting");
								reportingGroup.setBounds(12, 393, 842, 112);
								reportingGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									reportTypeGroup = new Group(reportingGroup, SWT.NONE);
									reportTypeGroup.setLayout(null);
									reportTypeGroup.setText("Report Type");
									reportTypeGroup.setBounds(8, 22, 125, 76);
									reportTypeGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									{
										textReportRadio = new Button(reportTypeGroup, SWT.RADIO | SWT.LEFT);
										textReportRadio.setText("Text");
										textReportRadio.setBounds(8, 22, 64, 19);
										textReportRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									}
									{
										htmlReportRadio = new Button(reportTypeGroup, SWT.RADIO | SWT.LEFT);
										htmlReportRadio.setText("HTML");
										htmlReportRadio.setBounds(8, 50, 60, 19);
										htmlReportRadio.setEnabled(true);
										htmlReportRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									}
//									{
//										pdfReportRadio = new Button(reportTypeGroup, SWT.RADIO | SWT.LEFT);
//										pdfReportRadio.setText("PDF");
//										pdfReportRadio.setBounds(8, 78, 60, 19);
//										pdfReportRadio.setEnabled(false);
//										pdfReportRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
//									}
//									{
//										xmlReportRadio = new Button(reportTypeGroup, SWT.RADIO | SWT.LEFT);
//										xmlReportRadio.setText("XML");
//										xmlReportRadio.setBounds(8, 106, 60, 19);
//										xmlReportRadio.setEnabled(false);
//										xmlReportRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
//									}
								}
								{
									reportFileNameTextbox = new Text(reportingGroup, SWT.BORDER);
									reportFileNameTextbox.setBounds(266, 36, 227, 25);
									reportFileNameTextbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									reportFileNameLabel = new Label(reportingGroup, SWT.NONE);
									reportFileNameLabel.setText("Filename:");
									reportFileNameLabel.setBounds(139, 36, 60, 30);
									reportFileNameLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									reportMinSeverityCombo = new Combo(reportingGroup, SWT.READ_ONLY);
									reportMinSeverityCombo.setBounds(266, 74, 117, 25);
									reportMinSeverityCombo.setItems(EventSeverity.getAllNames());
									reportMinSeverityCombo.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									reportMinSeverityCombo.setText(EventSeverity.INFO.getFullName());
								}
								{
									reportMinSeverityLabel = new Label(reportingGroup, SWT.NONE);
									reportMinSeverityLabel.setText("Minimum severity:");
									reportMinSeverityLabel.setBounds(139, 78, 121, 30);
									reportMinSeverityLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									reportFilenameBrowseButton = new Button(reportingGroup, SWT.PUSH | SWT.CENTER);
									reportFilenameBrowseButton.setText("Browse");
									reportFilenameBrowseButton.setBounds(516, 36, 70, 30);
									reportFilenameBrowseButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									reportFilenameBrowseButton.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													FileDialog fd = new FileDialog(shell, SWT.SAVE);
													fd.setText("Report file name");
													String filename = fd.open();
													if (filename != null)
													{
														reportFileNameTextbox.setText(filename);
													}
												}
											}
									);
								}
							}

						}
					}
					
					
					
					
					
					
					
					
					
					
/*
 * 
 * 
 * ***************************************************************************************************
 * HTTP CLIENT TAB
 * ***************************************************************************************************
 * 
 * 
 */					
					{
						httpClientTab = new CTabItem(tabFolder, SWT.NONE);
						httpClientTab.setText(" HTTP Client ");
						{
							httpClientComposite = new Composite(tabFolder, SWT.NONE);
							httpClientComposite.setLayout(null);
							httpClientTab.setControl(httpClientComposite);
							{
								upstreamProxyGroup = new Group(httpClientComposite, SWT.NONE);
								upstreamProxyGroup.setLayout(null);
								upstreamProxyGroup.setText("Upstream Proxy");
								upstreamProxyGroup.setBounds(12, 12, 471, 216);
								upstreamProxyGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									useUpstreamProxyCheckBox = new Button(upstreamProxyGroup, SWT.CHECK | SWT.LEFT);
									useUpstreamProxyCheckBox.setText("Use upstream proxy");
									useUpstreamProxyCheckBox.setBounds(12, 19, 200, 30);
									useUpstreamProxyCheckBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									useUpstreamProxyCheckBox.addSelectionListener
									(
										new SelectionAdapter()
										{
											@Override
											public void widgetSelected(SelectionEvent e)
											{
												updateUpstreamProxyStatus();
											}
										}
									);
								}
								{
									upstreamProxyAddressLabel = new Label(upstreamProxyGroup, SWT.NONE);
									upstreamProxyAddressLabel.setText("Address:");
									upstreamProxyAddressLabel.setBounds(10, 53, 66, 23);
									upstreamProxyAddressLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									upstreamProxyPortLabel = new Label(upstreamProxyGroup, SWT.NONE);
									upstreamProxyPortLabel.setText("Port:");
									upstreamProxyPortLabel.setBounds(10, 89, 60, 25);
									upstreamProxyPortLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									upstreamProxyAddressTextBox = new Text(upstreamProxyGroup, SWT.BORDER);
									upstreamProxyAddressTextBox.setBounds(86, 52, 200, 25);
									upstreamProxyAddressTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									upstreamProxyPortTextBox = new Text(upstreamProxyGroup, SWT.BORDER);
									upstreamProxyPortTextBox.setBounds(86, 87, 69, 25);
									upstreamProxyPortTextBox.setTextLimit(5);
									upstreamProxyPortTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									upstreamProxyPortTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
								{
									upstreamProxyUsernameTextBox = new Text(upstreamProxyGroup, SWT.BORDER);
									upstreamProxyUsernameTextBox.setBounds(86, 122, 111, 25);
									upstreamProxyUsernameTextBox.setEnabled(false);
									upstreamProxyUsernameTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									upstreamProxyUsernameLabel = new Label(upstreamProxyGroup, SWT.NONE);
									upstreamProxyUsernameLabel.setText("Username:");
									upstreamProxyUsernameLabel.setBounds(10, 127, 74, 25);
									upstreamProxyUsernameLabel.setEnabled(false);
									upstreamProxyUsernameLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									upstreamProxyPasswordLabel = new Label(upstreamProxyGroup, SWT.NONE);
									upstreamProxyPasswordLabel.setText("Password:");
									upstreamProxyPasswordLabel.setBounds(10, 160, 74, 25);
									upstreamProxyPasswordLabel.setEnabled(false);
									upstreamProxyPasswordLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									upstreamProxyPasswordTextBox = new Text(upstreamProxyGroup, SWT.BORDER | SWT.PASSWORD);
									upstreamProxyPasswordTextBox.setBounds(86, 158, 113, 25);
									upstreamProxyPasswordTextBox.setEnabled(false);
									upstreamProxyPasswordTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									upstreamProxyAuthenticationTypeGroup = new Group(upstreamProxyGroup, SWT.NONE);
									upstreamProxyAuthenticationTypeGroup.setLayout(null);
									upstreamProxyAuthenticationTypeGroup.setText("Authentication Type");
									upstreamProxyAuthenticationTypeGroup.setBounds(309, 74, 147, 107);
									upstreamProxyAuthenticationTypeGroup.setEnabled(false);
									upstreamProxyAuthenticationTypeGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									{
										upstreamProxyBasicAuthenticationRadioButton = new Button(upstreamProxyAuthenticationTypeGroup, SWT.RADIO | SWT.LEFT);
										upstreamProxyBasicAuthenticationRadioButton.setText("Basic");
										upstreamProxyBasicAuthenticationRadioButton.setBounds(8, 22, 85, 25);
										upstreamProxyBasicAuthenticationRadioButton.setEnabled(false);
										upstreamProxyBasicAuthenticationRadioButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									}
									{
										upstreamProxyDigestAuthenticationRadioButton = new Button(upstreamProxyAuthenticationTypeGroup, SWT.RADIO | SWT.LEFT);
										upstreamProxyDigestAuthenticationRadioButton.setText("Digest");
										upstreamProxyDigestAuthenticationRadioButton.setBounds(8, 47, 60, 25);
										upstreamProxyDigestAuthenticationRadioButton.setEnabled(false);
										upstreamProxyDigestAuthenticationRadioButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									}
									{
										upstreamProxyNTLMAuthenticationRadioButton = new Button(upstreamProxyAuthenticationTypeGroup, SWT.RADIO | SWT.LEFT);
										upstreamProxyNTLMAuthenticationRadioButton.setText("NTLM");
										upstreamProxyNTLMAuthenticationRadioButton.setBounds(8, 72, 60, 25);
										upstreamProxyNTLMAuthenticationRadioButton.setEnabled(false);
										upstreamProxyNTLMAuthenticationRadioButton.setEnabled(false);
										upstreamProxyNTLMAuthenticationRadioButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									}
								}
								updateUpstreamProxyStatus();
							}
							{
								httpClientLimitsGroup = new Group(httpClientComposite, SWT.NONE);
								httpClientLimitsGroup.setLayout(null);
								httpClientLimitsGroup.setText("Limits");
								httpClientLimitsGroup.setBounds(495, 12, 347, 291);
								httpClientLimitsGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									maxRequestsPerSecondLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									maxRequestsPerSecondLabel.setText("Max requests per second:");
									maxRequestsPerSecondLabel.setBounds(12, 25, 160, 17);
									maxRequestsPerSecondLabel.setEnabled(true);
									maxRequestsPerSecondLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxRequestsPerSecondTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									maxRequestsPerSecondTextBox.setBounds(219, 23, 45, 25);
									maxRequestsPerSecondTextBox.setEnabled(true);
									maxRequestsPerSecondTextBox.setTextLimit(4);
									maxRequestsPerSecondTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									maxRequestsPerSecondTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
								{
									maxConnectionsPerServerLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									maxConnectionsPerServerLabel.setText("Max connections per server:");
									maxConnectionsPerServerLabel.setBounds(12, 57, 176, 17);
									maxConnectionsPerServerLabel.setEnabled(true);
									maxConnectionsPerServerLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxTotalConnectionsLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									maxTotalConnectionsLabel.setText("Max total connections:");
									maxTotalConnectionsLabel.setBounds(12, 90, 169, 25);
									maxTotalConnectionsLabel.setEnabled(true);
									maxTotalConnectionsLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxConnectionsPerServerTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									maxConnectionsPerServerTextBox.setBounds(219, 55, 45, 25);
									maxConnectionsPerServerTextBox.addVerifyListener(numbersOnlyVerifyer);
									maxConnectionsPerServerTextBox.setEnabled(true);
									maxConnectionsPerServerTextBox.setTextLimit(3);
									maxConnectionsPerServerTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxTotalConnectionsTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									maxTotalConnectionsTextBox.setBounds(219, 88, 45, 25);
									maxTotalConnectionsTextBox.setEnabled(true);
									maxTotalConnectionsTextBox.setTextLimit(3);
									maxTotalConnectionsTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									maxTotalConnectionsTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
								{
									maxConsecutiveFailedRequestsLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									maxConsecutiveFailedRequestsLabel.setText("Max consecutive failed requests:");
									maxConsecutiveFailedRequestsLabel.setBounds(12, 122, 199, 30);
									maxConsecutiveFailedRequestsLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxConsecutiveFailedRequestsTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									maxConsecutiveFailedRequestsTextBox.setBounds(219, 120, 45, 25);
									maxConsecutiveFailedRequestsTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxFailedRequestsPerServerLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									maxFailedRequestsPerServerLabel.setText("Max failed requests per server:");
									maxFailedRequestsPerServerLabel.setBounds(12, 153, 193, 30);
									maxFailedRequestsPerServerLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxFailedRequestsPerServerTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									maxFailedRequestsPerServerTextBox.setBounds(219, 153, 45, 25);
									maxFailedRequestsPerServerTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									socketReadTimeoutLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									socketReadTimeoutLabel.setText("Socket read timeout (seconds):");
									socketReadTimeoutLabel.setBounds(12, 185, 199, 30);
									socketReadTimeoutLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									socketReadTimeoutTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									socketReadTimeoutTextBox.setBounds(219, 185, 45, 25);
									socketReadTimeoutTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxTotalRequestsLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									maxTotalRequestsLabel.setText("Max total requests:");
									maxTotalRequestsLabel.setBounds(12, 217, 132, 30);
									maxTotalRequestsLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxTotalRequestsTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									maxTotalRequestsTextBox.setBounds(219, 218, 80, 25);
									maxTotalRequestsTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxFileSizeLabel = new Label(httpClientLimitsGroup, SWT.NONE);
									maxFileSizeLabel.setText("Max response size (kilobytes):");
									maxFileSizeLabel.setBounds(12, 253, 193, 25);
									maxFileSizeLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									maxFileSizeTextBox = new Text(httpClientLimitsGroup, SWT.BORDER);
									maxFileSizeTextBox.setBounds(219, 253, 80, 25);
									maxFileSizeTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									maxFileSizeTextBox.addVerifyListener(numbersOnlyVerifyer);
								}
							}
							{
								miscHttpClientGroup = new Group(httpClientComposite, SWT.NONE);
								miscHttpClientGroup.setLayout(null);
								miscHttpClientGroup.setText("Miscellaneous Settings");
								miscHttpClientGroup.setBounds(12, 303, 830, 82);
								miscHttpClientGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									useragentComboBox = new Combo(miscHttpClientGroup, SWT.NONE);
									useragentComboBox.setBounds(138, 22, 680, 25);
									useragentComboBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									useragentComboBox.setItems(ConfigurationManager.getStringArray("http_client.optional_user_agents"));
								}
								{
									useragentLabel = new Label(miscHttpClientGroup, SWT.NONE);
									useragentLabel.setText("User agent string:");
									useragentLabel.setBounds(12, 22, 114, 30);
									useragentLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
							}
							{
								responseCodeGroup = new Group(httpClientComposite, SWT.NONE);
								responseCodeGroup.setLayout(null);
								responseCodeGroup.setText("Response Code Overrides");
								responseCodeGroup.setBounds(12, 391, 830, 188);
								responseCodeGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									useAutomaticOverridesCheckBox = new Button(responseCodeGroup, SWT.CHECK | SWT.LEFT);
									useAutomaticOverridesCheckBox.setText("Use automatic response code overrides");
									useAutomaticOverridesCheckBox.setBounds(12, 29, 306, 30);
									useAutomaticOverridesCheckBox.setToolTipText("Some websites will respond to a bad file name \nwith a \"200 OK\" or a redirect. Enabling this \noption causes Grendel-Scan to build a profile of \nlogical file-not-found error messages, \nsignificantly improving accuracy. If you know \nthat the website will always respond with a \nproper 404, disabling this option will speed up \nthe scan.");
									useAutomaticOverridesCheckBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									useAutomaticOverridesCheckBox.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													updateAutomaticResponseCodes();
												}
											}
									);
								}
								{
									testEveryDirectoryCheckBox = new Button(responseCodeGroup, SWT.CHECK | SWT.LEFT);
									testEveryDirectoryCheckBox.setEnabled(useAutomaticOverridesCheckBox.getSelection());
									testEveryDirectoryCheckBox.setText("Test every directory");
									testEveryDirectoryCheckBox.setBounds(12, 59, 248, 30);
									testEveryDirectoryCheckBox.setToolTipText("Some websites have different error messages\nfrom directory to directory. This will cause the \nautomatic file-not-found profile to be updated\nfor every directory that Grendel-Scan \nencounters. If you know that the file-not-found\nresponse is consistent across directories, \ndisabling this option will improve performance.");
									testEveryDirectoryCheckBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									manualOverrideCodeLabel = new Label(responseCodeGroup, SWT.NONE);
									manualOverrideCodeLabel.setText("HTTP response code:");
									manualOverrideCodeLabel.setBounds(12, 101, 135, 25);
									manualOverrideCodeLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									manualOverrideRegexLabel = new Label(responseCodeGroup, SWT.NONE);
									manualOverrideRegexLabel.setText("Regex override:");
									manualOverrideRegexLabel.setBounds(12, 140, 127, 25);
									manualOverrideRegexLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									httpResponseCode = new Text(responseCodeGroup, SWT.BORDER);
									httpResponseCode.setBounds(157, 105, 41, 25);
									httpResponseCode.addVerifyListener(numbersOnlyVerifyer);
									httpResponseCode.setTextLimit(3);
									httpResponseCode.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									regexOverrideTextbox = new Text(responseCodeGroup, SWT.BORDER);
									regexOverrideTextbox.setBounds(159, 146, 181, 25);
									regexOverrideTextbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									manualOverrideAddButton = new Button(responseCodeGroup, SWT.PUSH | SWT.CENTER);
									manualOverrideAddButton.setText("Add");
									manualOverrideAddButton.setBounds(352, 103, 70, 30);
									manualOverrideAddButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									manualOverrideAddButton.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													if (!httpResponseCode.getText().equals("") && !regexOverrideTextbox.getText().equals("") &&
															httpResponseCode.getText().matches("[1-5]\\d{2}"))
													{
														if (!RegexUtils.validateRegex(regexOverrideTextbox.getText()))
														{
															displayInternalMessage("Error", "Invalid response code regular expression.");
														}
														else
														{
															addResponseCodeOverride(httpResponseCode.getText(), regexOverrideTextbox.getText());
															httpResponseCode.setText("");
															regexOverrideTextbox.setText("");
														}
													}
													
												}
											}
									);
								}
								{
									manualOverrideRemoveButton = new Button(responseCodeGroup, SWT.PUSH | SWT.CENTER);
									manualOverrideRemoveButton.setText("Remove");
									manualOverrideRemoveButton.setBounds(352, 145, 70, 30);
									manualOverrideRemoveButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									manualOverrideRemoveButton.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													for (TableItem item: responseCodeOverrideTable.getSelection())
													{
														httpResponseCode.setText(item.getText(0));
														regexOverrideTextbox.setText(item.getText(1));
														item.dispose();
														break;
													}
												}
											}
									);
								}
								{
									responseCodeOverrideTable = new Table(responseCodeGroup, SWT.SINGLE | SWT.BORDER);
									responseCodeOverrideTable.setBounds(448, 31, 370, 147);
									responseCodeOverrideTable.setHeaderVisible(true);
									responseCodeOverrideTable.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									{
										responseCodeCodeColumn = new TableColumn(responseCodeOverrideTable, SWT.NONE);
										responseCodeCodeColumn.setText("HTTP Code");
										responseCodeCodeColumn.setWidth(100);
									}
									{
										responseCodeRegexColumn = new TableColumn(responseCodeOverrideTable, SWT.NONE);
										responseCodeRegexColumn.setText("Regex");
										responseCodeRegexColumn.setWidth(250);
									}
								}
							}

						}
					}

					
					
					
					
					
					
/*
 * 
 * 
 * ***************************************************************************************************
 * AUTHENTICATION TAB
 * ***************************************************************************************************
 * 
 * 
 */					
					{
						authenticationTab = new CTabItem(tabFolder, SWT.NONE);
						authenticationTab.setText(" Authentication ");
						{
							authenticationComposite = new Composite(tabFolder, SWT.NONE);
							authenticationComposite.setLayout(null);
							authenticationTab.setControl(authenticationComposite);
							{
								useAuthenticationCheckBox = new Button(authenticationComposite, SWT.CHECK | SWT.LEFT);
								useAuthenticationCheckBox.setText("Use authentication");
								useAuthenticationCheckBox.setBounds(24, 26, 151, 30);
								useAuthenticationCheckBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								useAuthenticationCheckBox.addSelectionListener
								(
									new SelectionAdapter()
									{
										public void widgetSelected(SelectionEvent e)
										{
											updateAuthenticationTab();
										}
									}
								);
							}
							{
								useDomainCheckbox = new Button(authenticationComposite, SWT.CHECK | SWT.LEFT);
								useDomainCheckbox.setText("Use domain");
								useDomainCheckbox.setBounds(24, 62, 142, 27);
								useDomainCheckbox.setEnabled(false);
								useDomainCheckbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								useDomainCheckbox.addSelectionListener
								(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
//												domainTextBox.setEnabled(useDomainCheckbox.getSelection());
//												domainLabel.setEnabled(useDomainCheckbox.getSelection());
												
												if (htmlFormAuthenticationRadio.getSelection())
												{
//													domainFieldTextbox.setEnabled(useDomainCheckbox.getSelection());
//													domainFieldLabel.setEnabled(useDomainCheckbox.getSelection());
												}
												if (!useDomainCheckbox.getSelection())
												{
													domainColumn.setResizable(false);
													domainColumn.setWidth(0);
													domainTextBox.setText("");
												}
												else
												{
													domainColumn.setResizable(true);
													domainColumn.setWidth(120);
												}
											}
										}
								);
							}
							{
								authenticationTypeGroup = new Group(authenticationComposite, SWT.NONE);
								GridLayout authenticationTypeGroupLayout = new GridLayout();
								authenticationTypeGroupLayout.makeColumnsEqualWidth = true;
								authenticationTypeGroup.setLayout(authenticationTypeGroupLayout);
								authenticationTypeGroup.setText("Authentication Type");
								authenticationTypeGroup.setBounds(17, 95, 169, 72);
								authenticationTypeGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									httpAuthenticationRadio = new Button(authenticationTypeGroup, SWT.RADIO | SWT.LEFT);
									httpAuthenticationRadio.setText("HTTP Authentication");
									httpAuthenticationRadio.setEnabled(false);
									httpAuthenticationRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									htmlFormAuthenticationRadio = new Button(authenticationTypeGroup, SWT.RADIO | SWT.LEFT);
									htmlFormAuthenticationRadio.setText("HTML Form-Based");
									htmlFormAuthenticationRadio.setSelection(true);
									htmlFormAuthenticationRadio.setVisible(true);
									htmlFormAuthenticationRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									htmlFormAuthenticationRadio.addSelectionListener
									(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
													htmlFormAuthenticationButtonSelectAction();
												}
											}											
									);
								}
								authenticationTypeGroup.layout();
							}
							{
								accountsGroup = new Group(authenticationComposite, SWT.NONE);
								accountsGroup.setLayout(null);
								accountsGroup.setText("User Accounts");
								accountsGroup.setBounds(192, 12, 640, 194);
								accountsGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									showPasswordsCheckbox = new Button(accountsGroup, SWT.CHECK | SWT.LEFT);
									showPasswordsCheckbox.setText("Show passwords");
									showPasswordsCheckbox.setBounds(12, 148, 149, 30);
									showPasswordsCheckbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									showPasswordsCheckbox.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												createPasswordTextBox(showPasswordsCheckbox.getSelection());
												for(TableItem item: accountsTable.getItems())
												{
													String pass;
													if (showPasswordsCheckbox.getSelection())
													{
														pass = (String) item.getData("password");
													}
													else
													{
														pass = "********";
													}
													item.setText(1, pass);
												}
											}
										}
									);
								}
								{
									usernameLabel = new Label(accountsGroup, SWT.NONE);
									usernameLabel.setText("Username:");
									usernameLabel.setBounds(12, 28, 69, 20);
									usernameLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									usernameTextBox = new Text(accountsGroup, SWT.BORDER);
									usernameTextBox.setBounds(83, 26, 111, 25);
									usernameTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									passwordLabel = new Label(accountsGroup, SWT.NONE);
									passwordLabel.setText("Password:");
									passwordLabel.setBounds(12, 63, 67, 30);
									passwordLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									createPasswordTextBox(false);
								}
								{
									domainLabel = new Label(accountsGroup, SWT.NONE);
									domainLabel.setText("Domain:");
									domainLabel.setBounds(14, 98, 60, 30);
									domainLabel.setEnabled(false);
									domainLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									domainTextBox = new Text(accountsGroup, SWT.BORDER);
									domainTextBox.setBounds(83, 96, 111, 25);
									domainTextBox.setEnabled(false);
									domainTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									accountAddButton = new Button(accountsGroup, SWT.PUSH | SWT.CENTER);
									accountAddButton.setText("Add");
									accountAddButton.setBounds(214, 158, 70, 30);
									accountAddButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									accountAddButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												if (!usernameTextBox.getText().equals(""))
												{
													addCredentials(usernameTextBox.getText(), passwordTextBox.getText());
													passwordTextBox.setText("");
													usernameTextBox.setText("");
												}
											}
										}
									);
								}
								{
									accountRemoveButton = new Button(accountsGroup, SWT.PUSH | SWT.CENTER);
									accountRemoveButton.setText("Remove");
									accountRemoveButton.setBounds(292, 158, 70, 30);
									accountRemoveButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									accountRemoveButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												for (TableItem item: accountsTable.getSelection())
												{
													usernameTextBox.setText(item.getText(0));
													passwordTextBox.setText((String) item.getData("password"));
													if (useDomainCheckbox.getSelection())
													{
														domainTextBox.setText(item.getText(2));
													}
													item.dispose();
													break;
												}
											}
										}
									);
								}
								{
									accountsTable = new Table(accountsGroup, SWT.BORDER);
									accountsTable.setBounds(214, 28, 408, 117);
									accountsTable.setHeaderVisible(true);
									accountsTable.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									{
										usernameColumn = new TableColumn(accountsTable, SWT.NONE);
										usernameColumn.setText("Username");
										usernameColumn.setWidth(120);
									}
									{
										passwordColumn = new TableColumn(accountsTable, SWT.NONE);
										passwordColumn.setText("Password");
										passwordColumn.setWidth(120);
									}
									{
										domainColumn = new TableColumn(accountsTable, SWT.NONE);
										domainColumn.setText("Domain");
										domainColumn.setResizable(false);
									}
								}
							}
							{
								formAuthenticationGroup = new Group(authenticationComposite, SWT.NONE);
								formAuthenticationGroup.setLayout(null);
								formAuthenticationGroup.setText("HTML Form Authentication Settings");
								formAuthenticationGroup.setBounds(12, 218, 820, 234);
								formAuthenticationGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									runAuthWizardButton = new Button(formAuthenticationGroup, SWT.PUSH | SWT.CENTER);
									runAuthWizardButton.setText("Run Wizard");
									runAuthWizardButton.setBounds(12, 23, 98, 30);
									runAuthWizardButton.addSelectionListener(new SelectionAdapter() {
										public void widgetSelected(SelectionEvent e)
										{
											runAuthWizard();
										}
									}
									);
								}
								{
									authenticationUrlTextBox = new Text(formAuthenticationGroup, SWT.BORDER);
									authenticationUrlTextBox.setBounds(55, 67, 747, 25);
									authenticationUrlTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									httpMethodGroup = new Group(formAuthenticationGroup, SWT.NONE);
									GridLayout httpMethodGroupLayout = new GridLayout();
									httpMethodGroupLayout.makeColumnsEqualWidth = true;
									httpMethodGroup.setLayout(httpMethodGroupLayout);
									httpMethodGroup.setText("HTTP Method");
									httpMethodGroup.setBounds(12, 102, 105, 73);
									httpMethodGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									{
										httpGetRadio = new Button(httpMethodGroup, SWT.RADIO | SWT.LEFT);
										httpGetRadio.setText("GET");
										httpGetRadio.setSelection(true);
										httpGetRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									}
									{
										httpPostRadio = new Button(httpMethodGroup, SWT.RADIO | SWT.LEFT);
										httpPostRadio.setText("POST");
										httpPostRadio.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
										httpPostRadio.addSelectionListener
										(
												new SelectionAdapter()
												{
													public void widgetSelected(SelectionEvent event)
													{
														httpPostButtonSelectAction();
													}
												}	
										);
									}
									httpMethodGroup.layout();
								}
								{
									usernameFieldTextbox = new Text(formAuthenticationGroup, SWT.BORDER);
									usernameFieldTextbox.setBounds(234, 113, 125, 25);
									usernameFieldTextbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									usernameFieldLabel = new Label(formAuthenticationGroup, SWT.NONE);
									usernameFieldLabel.setText("Username field:");
									usernameFieldLabel.setBounds(129, 107, 95, 25);
									usernameFieldLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									passwordFieldLabel = new Label(formAuthenticationGroup, SWT.NONE);
									passwordFieldLabel.setText("Password field:");
									passwordFieldLabel.setBounds(129, 138, 89, 25);
									passwordFieldLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									passwordFieldTextbox = new Text(formAuthenticationGroup, SWT.BORDER);
									passwordFieldTextbox.setBounds(234, 144, 125, 25);
									passwordFieldTextbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									domainFieldLabel = new Label(formAuthenticationGroup, SWT.NONE);
									domainFieldLabel.setText("Domain field:");
									domainFieldLabel.setBounds(408, 109, 80, 30);
									domainFieldLabel.setEnabled(false);
									domainFieldLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));

								}
								{
									domainFieldTextbox = new Text(formAuthenticationGroup, SWT.BORDER);
									domainFieldTextbox.setBounds(499, 113, 113, 25);
									domainFieldTextbox.setEnabled(false);
									domainFieldTextbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									postQueryLabel = new Label(formAuthenticationGroup, SWT.NONE);
									postQueryLabel.setText("POST Query");
									postQueryLabel.setBounds(12, 194, 80, 28);
									postQueryLabel.setEnabled(false);
									postQueryLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									postQueryTextbox = new Text(formAuthenticationGroup, SWT.BORDER);
									postQueryTextbox.setBounds(115, 194, 667, 25);
									postQueryTextbox.setEnabled(false);
									postQueryTextbox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									authenticationUrlLabel = new Label(formAuthenticationGroup, SWT.NONE);
									authenticationUrlLabel.setText("URL:");
									authenticationUrlLabel.setBounds(12, 65, 35, 25);
									authenticationUrlLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
							}
						}
					}
					updateAuthenticationTab();
					
					
					
					
					
					
/*
 * 
 * 
 * ***************************************************************************************************
 * SCAN RESTRICTIONS TAB
 * ***************************************************************************************************
 * 
 * 
 */					
					{
						scanRestrictionsTab = new CTabItem(tabFolder, SWT.NONE);
						scanRestrictionsTab.setText(" Target Details / Scan Restrictions ");
						{
							scanRestrictionsComposite = new Composite(tabFolder, SWT.NONE);
							FormLayout scanRestrictionsCompositeLayout = new FormLayout();
							scanRestrictionsComposite.setLayout(scanRestrictionsCompositeLayout);
							scanRestrictionsTab.setControl(scanRestrictionsComposite);
							{
								knownSessionIDsGroup = new Group(scanRestrictionsComposite, SWT.NONE);
								FillLayout knownSessionIDsGroupLayout = new FillLayout(org.eclipse.swt.SWT.HORIZONTAL);
								knownSessionIDsGroup.setLayout(knownSessionIDsGroupLayout);
								FormData knownSessionIDsGroupLData = new FormData();
								knownSessionIDsGroupLData.width = 384;
								knownSessionIDsGroupLData.height = 116;
								knownSessionIDsGroupLData.left =  new FormAttachment(0, 1000, 12);
								knownSessionIDsGroupLData.top =  new FormAttachment(0, 1000, 165);
								knownSessionIDsGroup.setLayoutData(knownSessionIDsGroupLData);
								knownSessionIDsGroup.setText("Known Session ID Patterns");
								{
									knownSessionIDListComposite = new AddRemoveListComposite(knownSessionIDsGroup, SWT.NONE);
									knownSessionIDListComposite.setBounds(8, 23, 425, 84);
									knownSessionIDListComposite.addDataValidator(new RegexValidator());
								}
							}
							{
								ignoredParameterGroup = new Group(scanRestrictionsComposite, SWT.NONE);
								FormLayout ignoredParameterGroupLayout = new FormLayout();
								ignoredParameterGroup.setLayout(ignoredParameterGroupLayout);
								ignoredParameterGroup.setText("Ignored Query Parameters");
								FormData ignoredParameterGroupLData = new FormData();
								ignoredParameterGroupLData.width = 384;
								ignoredParameterGroupLData.height = 123;
								ignoredParameterGroupLData.left =  new FormAttachment(0, 1000, 12);
								ignoredParameterGroupLData.top =  new FormAttachment(0, 1000, 11);
								ignoredParameterGroup.setLayoutData(ignoredParameterGroupLData);
								ignoredParameterGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									ignoredParameterTextBox = new Text(ignoredParameterGroup, SWT.BORDER);
									FormData ignoredParameterTextBoxLData = new FormData();
									ignoredParameterTextBoxLData.width = 100;
									ignoredParameterTextBoxLData.height = 19;
									ignoredParameterTextBoxLData.left =  new FormAttachment(0, 1000, 5);
									ignoredParameterTextBoxLData.top =  new FormAttachment(0, 1000, 5);
									ignoredParameterTextBox.setLayoutData(ignoredParameterTextBoxLData);
									ignoredParameterTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									ignoredParameterAddButton = new Button(ignoredParameterGroup, SWT.PUSH | SWT.CENTER);
									ignoredParameterAddButton.setText("Add");
									FormData ignoredParameterAddButtonLData = new FormData();
									ignoredParameterAddButtonLData.width = 70;
									ignoredParameterAddButtonLData.height = 30;
									ignoredParameterAddButtonLData.left =  new FormAttachment(0, 1000, 123);
									ignoredParameterAddButtonLData.top =  new FormAttachment(0, 1000, 5);
									ignoredParameterAddButton.setLayoutData(ignoredParameterAddButtonLData);
									ignoredParameterAddButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									ignoredParameterAddButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												if(!ignoredParameterTextBox.getText().equals(""))
												{
													ignoredParameterList.add(ignoredParameterTextBox.getText());
													ignoredParameterTextBox.setText("");
												}
											}
										}		
									);
									
								}
								{
									ignoredParameterRemoveButton = new Button(ignoredParameterGroup, SWT.PUSH | SWT.CENTER);
									ignoredParameterRemoveButton.setText("Remove");
									FormData ignoredParameterRemoveButtonLData = new FormData();
									ignoredParameterRemoveButtonLData.width = 70;
									ignoredParameterRemoveButtonLData.height = 30;
									ignoredParameterRemoveButtonLData.left =  new FormAttachment(0, 1000, 124);
									ignoredParameterRemoveButtonLData.top =  new FormAttachment(0, 1000, 45);
									ignoredParameterRemoveButton.setLayoutData(ignoredParameterRemoveButtonLData);
									ignoredParameterRemoveButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									ignoredParameterRemoveButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												for(String value: ignoredParameterList.getSelection())
												{
													ignoredParameterList.remove(value);
													ignoredParameterTextBox.setText(value);
													break;
												}
											}
										}	
									);
								}
								{
									ignoredParameterList = new List(ignoredParameterGroup, SWT.V_SCROLL | SWT.BORDER | SWT.SINGLE);
									FormData ignoredParameterListLData = new FormData();
									ignoredParameterListLData.width = 134;
									ignoredParameterListLData.height = 107;
									ignoredParameterListLData.left =  new FormAttachment(0, 1000, 204);
									ignoredParameterListLData.top =  new FormAttachment(0, 1000, 5);
									ignoredParameterList.setLayoutData(ignoredParameterListLData);
									ignoredParameterList.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
							}
							{
								forbiddenParamterGroup = new Group(scanRestrictionsComposite, SWT.NONE);
								FormLayout forbiddenParamterGroupLayout = new FormLayout();
								forbiddenParamterGroup.setText("Forbidden Query Parameters");
								forbiddenParamterGroup.setLayout(forbiddenParamterGroupLayout);
								FormData forbiddenParamterGroupLData = new FormData();
								forbiddenParamterGroupLData.width = 384;
								forbiddenParamterGroupLData.height = 129;
								forbiddenParamterGroupLData.left =  new FormAttachment(0, 1000, 413);
								forbiddenParamterGroupLData.top =  new FormAttachment(0, 1000, 5);
								forbiddenParamterGroup.setLayoutData(forbiddenParamterGroupLData);
								forbiddenParamterGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									forbiddenParamterTextBox = new Text(forbiddenParamterGroup, SWT.BORDER);
									FormData forbiddenParamterTextBoxLData = new FormData();
									forbiddenParamterTextBoxLData.width = 100;
									forbiddenParamterTextBoxLData.height = 19;
									forbiddenParamterTextBoxLData.left =  new FormAttachment(0, 1000, 5);
									forbiddenParamterTextBoxLData.top =  new FormAttachment(0, 1000, 5);
									forbiddenParamterTextBox.setLayoutData(forbiddenParamterTextBoxLData);
									forbiddenParamterTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									forbiddenParameterAddButton = new Button(forbiddenParamterGroup, SWT.PUSH | SWT.CENTER);
									forbiddenParameterAddButton.setText("Add");
									FormData forbiddenParameterAddButtonLData = new FormData();
									forbiddenParameterAddButtonLData.width = 70;
									forbiddenParameterAddButtonLData.height = 30;
									forbiddenParameterAddButtonLData.left =  new FormAttachment(0, 1000, 123);
									forbiddenParameterAddButtonLData.top =  new FormAttachment(0, 1000, 5);
									forbiddenParameterAddButton.setLayoutData(forbiddenParameterAddButtonLData);
									forbiddenParameterAddButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									forbiddenParameterAddButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												if (!forbiddenParamterTextBox.getText().equals(""))
												{
													forbiddenParameterList.add(forbiddenParamterTextBox.getText());
													forbiddenParamterTextBox.setText("");
												}
											}
										}	
									);
								}
								{
									forbiddenParameterRemoveButton = new Button(forbiddenParamterGroup, SWT.PUSH | SWT.CENTER);
									forbiddenParameterRemoveButton.setText("Remove");
									FormData forbiddenParameterRemoveButtonLData = new FormData();
									forbiddenParameterRemoveButtonLData.width = 70;
									forbiddenParameterRemoveButtonLData.height = 30;
									forbiddenParameterRemoveButtonLData.left =  new FormAttachment(0, 1000, 123);
									forbiddenParameterRemoveButtonLData.top =  new FormAttachment(0, 1000, 45);
									forbiddenParameterRemoveButton.setLayoutData(forbiddenParameterRemoveButtonLData);
									forbiddenParameterRemoveButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									forbiddenParameterRemoveButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												for(String value: forbiddenParameterList.getSelection())
												{
													forbiddenParameterList.remove(value);
													forbiddenParamterTextBox.setText(value);
													break;
												}
											}
										}	
									);
									
								}
								{
									forbiddenParameterList = new List(forbiddenParamterGroup, SWT.V_SCROLL | SWT.BORDER | SWT.SINGLE);
									forbiddenParameterList.setItems(new java.lang.String[] {});
									FormData forbiddenParameterListLData = new FormData();
									forbiddenParameterListLData.width = 134;
									forbiddenParameterListLData.height = 108;
									forbiddenParameterListLData.left =  new FormAttachment(0, 1000, 206);
									forbiddenParameterListLData.top =  new FormAttachment(0, 1000, 5);
									forbiddenParameterList.setLayoutData(forbiddenParameterListLData);
									forbiddenParameterList.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
							}
							{
								urlBlacklistGroup = new Group(scanRestrictionsComposite, SWT.NONE);
								FormLayout urlBlacklistGroupLayout = new FormLayout();
								urlBlacklistGroup.setText("URL Blacklist Regexs");
								urlBlacklistGroup.setLayout(urlBlacklistGroupLayout);
								FormData urlBlacklistGroupLData = new FormData();
								urlBlacklistGroupLData.width = 786;
								urlBlacklistGroupLData.height = 86;
								urlBlacklistGroupLData.left =  new FormAttachment(0, 1000, 12);
								urlBlacklistGroupLData.top =  new FormAttachment(0, 1000, 339);
								urlBlacklistGroup.setLayoutData(urlBlacklistGroupLData);
								urlBlacklistGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									urlBlacklistTextBox = new Text(urlBlacklistGroup, SWT.BORDER);
									FormData urlBlacklistTextBoxLData = new FormData();
									urlBlacklistTextBoxLData.width = 316;
									urlBlacklistTextBoxLData.height = 19;
									urlBlacklistTextBoxLData.left =  new FormAttachment(0, 1000, 5);
									urlBlacklistTextBoxLData.top =  new FormAttachment(0, 1000, 5);
									urlBlacklistTextBox.setLayoutData(urlBlacklistTextBoxLData);
									urlBlacklistTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									urlBlacklistAddButton = new Button(urlBlacklistGroup, SWT.PUSH | SWT.CENTER);
									urlBlacklistAddButton.setText("Add");
									FormData urlBlacklistAddButtonLData = new FormData();
									urlBlacklistAddButtonLData.width = 70;
									urlBlacklistAddButtonLData.height = 30;
									urlBlacklistAddButtonLData.left =  new FormAttachment(0, 1000, 352);
									urlBlacklistAddButtonLData.top =  new FormAttachment(0, 1000, 5);
									urlBlacklistAddButton.setLayoutData(urlBlacklistAddButtonLData);
									urlBlacklistAddButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									urlBlacklistAddButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												if (!urlBlacklistTextBox.getText().equals(""))
												{
													if (RegexUtils.validateRegex(urlBlacklistTextBox.getText()))
													{
														urlBlacklistList.add(urlBlacklistTextBox.getText());
														urlBlacklistTextBox.setText("");
													}
													else
													{
														displayInternalMessage("Error", "Invalid URL blacklist regular expression.");
													}
												}
											}
										}	
									);
								}
								{
									urlBlacklistRemoveButton = new Button(urlBlacklistGroup, SWT.PUSH | SWT.CENTER);
									urlBlacklistRemoveButton.setText("Remove");
									FormData urlBlacklistRemoveButtonLData = new FormData();
									urlBlacklistRemoveButtonLData.width = 70;
									urlBlacklistRemoveButtonLData.height = 30;
									urlBlacklistRemoveButtonLData.left =  new FormAttachment(0, 1000, 352);
									urlBlacklistRemoveButtonLData.top =  new FormAttachment(0, 1000, 45);
									urlBlacklistRemoveButton.setLayoutData(urlBlacklistRemoveButtonLData);
									urlBlacklistRemoveButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									urlBlacklistRemoveButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												for(String value: urlBlacklistList.getSelection())
												{
													urlBlacklistList.remove(value);
													urlBlacklistTextBox.setText(value);
													break;
												}
											}
										}	
									);
								}
								{
									urlBlacklistList = new List(urlBlacklistGroup, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER | SWT.SINGLE);
									FormData urlBlacklistListLData = new FormData();
									urlBlacklistListLData.width = 313;
									urlBlacklistListLData.height = 39;
									urlBlacklistListLData.left =  new FormAttachment(0, 1000, 435);
									urlBlacklistListLData.top =  new FormAttachment(0, 1000, 7);
									urlBlacklistList.setLayoutData(urlBlacklistListLData);
									urlBlacklistList.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									
								}
							}
							{
								urlWhitelistGroup = new Group(scanRestrictionsComposite, SWT.NONE);
								FormLayout urlWhitelistGroupLayout = new FormLayout();
								urlWhitelistGroup.setText("URL Whitelist Regexs");
								urlWhitelistGroup.setLayout(urlWhitelistGroupLayout);
								FormData urlWhitelistGroupLData = new FormData();
								urlWhitelistGroupLData.width = 786;
								urlWhitelistGroupLData.height = 89;
								urlWhitelistGroupLData.left =  new FormAttachment(0, 1000, 12);
								urlWhitelistGroupLData.top =  new FormAttachment(0, 1000, 444);
								urlWhitelistGroup.setLayoutData(urlWhitelistGroupLData);
								urlWhitelistGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								{
									urlWhitelistTextBox = new Text(urlWhitelistGroup, SWT.BORDER);
									FormData urlWhitelistTextBoxLData = new FormData();
									urlWhitelistTextBoxLData.width = 316;
									urlWhitelistTextBoxLData.height = 19;
									urlWhitelistTextBoxLData.left =  new FormAttachment(0, 1000, 5);
									urlWhitelistTextBoxLData.top =  new FormAttachment(0, 1000, 5);
									urlWhitelistTextBox.setLayoutData(urlWhitelistTextBoxLData);
									urlWhitelistTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
								{
									urlWhitelistAddButton = new Button(urlWhitelistGroup, SWT.PUSH | SWT.CENTER);
									urlWhitelistAddButton.setText("Add");
									FormData urlWhitelistAddButtonLData = new FormData();
									urlWhitelistAddButtonLData.width = 70;
									urlWhitelistAddButtonLData.height = 30;
									urlWhitelistAddButtonLData.left =  new FormAttachment(0, 1000, 352);
									urlWhitelistAddButtonLData.top =  new FormAttachment(0, 1000, 5);
									urlWhitelistAddButton.setLayoutData(urlWhitelistAddButtonLData);
									urlWhitelistAddButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									urlWhitelistAddButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												if (!urlWhitelistTextBox.getText().equals(""))
												{
													if (RegexUtils.validateRegex(urlWhitelistTextBox.getText()))
													{
														urlWhitelistList.add(urlWhitelistTextBox.getText());
														urlWhitelistTextBox.setText("");
													}
													else
													{
														displayInternalMessage("Error", "Invalid URL whitelist regular expression.");
													}
												}
											}
										}	
									);

								}
								{
									urlWhitelistRemoveButton = new Button(urlWhitelistGroup, SWT.PUSH | SWT.CENTER);
									urlWhitelistRemoveButton.setText("Remove");
									FormData urlWhitelistRemoveButtonLData = new FormData();
									urlWhitelistRemoveButtonLData.width = 70;
									urlWhitelistRemoveButtonLData.height = 30;
									urlWhitelistRemoveButtonLData.left =  new FormAttachment(0, 1000, 352);
									urlWhitelistRemoveButtonLData.top =  new FormAttachment(0, 1000, 45);
									urlWhitelistRemoveButton.setLayoutData(urlWhitelistRemoveButtonLData);
									urlWhitelistRemoveButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
									urlWhitelistRemoveButton.addSelectionListener
									(
										new SelectionAdapter()
										{
											public void widgetSelected(SelectionEvent event)
											{
												for(String value: urlWhitelistList.getSelection())
												{
													urlWhitelistList.remove(value);
													urlWhitelistTextBox.setText(value);
													break;
												}
											}
										}	
									);

								}
								{
									urlWhitelistList = new List(urlWhitelistGroup, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
									FormData urlWhitelistListLData = new FormData();
									urlWhitelistListLData.width = 313;
									urlWhitelistListLData.height = 45;
									urlWhitelistListLData.left =  new FormAttachment(0, 1000, 436);
									urlWhitelistListLData.top =  new FormAttachment(0, 1000, 5);
									urlWhitelistList.setLayoutData(urlWhitelistListLData);
									urlWhitelistList.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
								}
							}
						}
					}

					
					
					
					
					
					
/*
 * 
 * 
 * ***************************************************************************************************
 * TEST MODULE SELECTION TAB
 * ***************************************************************************************************
 * 
 * 
 */					
					{
						testModuleSelectionTab = new CTabItem(tabFolder, SWT.NONE);
						testModuleSelectionTab.setText(" Test Module Selection ");
						{
							testModuleTabComposite = new Composite(tabFolder, SWT.NONE);
							GridLayout testModuleTabCompositeLayout = new GridLayout();
							testModuleTabCompositeLayout.makeColumnsEqualWidth = true;
							testModuleTabComposite.setLayout(testModuleTabCompositeLayout);
							testModuleSelectionTab.setControl(testModuleTabComposite);
							{
								testModuleTabSashForm = new SashForm(testModuleTabComposite, SWT.HORIZONTAL | SWT.H_SCROLL);
								testModuleTabSashForm.SASH_WIDTH = 10;
								GridData testModuleTabSashFormLData = new GridData();
								testModuleTabSashFormLData.grabExcessVerticalSpace = true;
								testModuleTabSashFormLData.horizontalAlignment = GridData.FILL;
								testModuleTabSashFormLData.grabExcessHorizontalSpace = true;
								testModuleTabSashFormLData.verticalAlignment = GridData.FILL;
								testModuleTabSashForm.setLayoutData(testModuleTabSashFormLData);
								testModuleTabSashForm.setBounds(0, 0, 875, 557);
								{
									testModuleTreeComposit = new Composite(testModuleTabSashForm, SWT.NONE);
									FormLayout testModuleTreeCompositLayout = new FormLayout();
									testModuleTreeComposit.setLayout(testModuleTreeCompositLayout);
									{
										experimentalLabel = new Label(testModuleTreeComposit, SWT.NONE);
										FormData experimentalLabelLData = new FormData();
										experimentalLabelLData.width = 171;
										experimentalLabelLData.height = 17;
										experimentalLabelLData.left =  new FormAttachment(0, 1000, 9);
										experimentalLabelLData.bottom =  new FormAttachment(1000, 1000, -5);
										experimentalLabel.setLayoutData(experimentalLabelLData);
										experimentalLabel.setText("* Experimental test module");
									}
									{
										FormData testModuleTreeLData = new FormData();
										testModuleTreeLData.width = 509;
										testModuleTreeLData.height = 515;
										testModuleTreeLData.top =  new FormAttachment(0, 1000, 5);
										testModuleTreeLData.left =  new FormAttachment(0, 1000, 5);
										testModuleTreeLData.bottom =  new FormAttachment(1000, 1000, -30);
										testModuleTreeLData.right =  new FormAttachment(1000, 1000, -5);
										testModuleTree = new Tree(testModuleTreeComposit, SWT.BORDER | SWT.V_SCROLL | SWT.H_SCROLL | SWT.CHECK);
										testModuleTree.setLayoutData(testModuleTreeLData);
										testModuleTree.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
										testModuleTree.addSelectionListener
										(
											new SelectionAdapter()
											{
												public void widgetSelected(SelectionEvent event)
												{
//													Debug.debug("event id " + event.detail);
													TreeItem item = (TreeItem) event.item;
													if (event.detail == SWT.CHECK)
													{
														changeCheckChildren(item, item.getChecked());
														if (!(item.getData() instanceof TestModule))
														{
															item.setExpanded(true);
														}
													}
													// I would think that SWT.SELECTED would make more sense, but it's returning
													// a 0
													else if (event.detail == 0)
													{
														if (item.getData() instanceof TestModule)
														{
															TestModule module = (TestModule) item.getData();
															testModuleDescriptionTextArea.setText(module.getDescription());
															populateTestModuleSettings(module);
														}
														else
														{
															testModuleDescriptionTextArea.setText("");
															populateTestModuleSettings(null);
															item.setExpanded(true);
														}
													}
												}
											}
										);
									}
								}
								{
									testModuleDetailsSashForm = new SashForm(testModuleTabSashForm, SWT.VERTICAL);
									testModuleDetailsSashForm.SASH_WIDTH = 0;
									testModuleDetailsSashForm.setSize(60, 30);
									{
										testModuleDescriptionComposite = new Composite(testModuleDetailsSashForm, SWT.NONE);
										GridLayout testModuleDescriptionCompositeLayout = new GridLayout();
										testModuleDescriptionCompositeLayout.makeColumnsEqualWidth = true;
										testModuleDescriptionComposite.setLayout(testModuleDescriptionCompositeLayout);
										{
											testModuleDescriptionTextArea = new Text(testModuleDescriptionComposite, SWT.MULTI | SWT.WRAP | SWT.V_SCROLL | SWT.BORDER);
											GridData testModuleDescriptionTextAreaLData = new GridData();
											testModuleDescriptionTextAreaLData.verticalAlignment = GridData.FILL;
											testModuleDescriptionTextAreaLData.horizontalAlignment = GridData.FILL;
											testModuleDescriptionTextAreaLData.grabExcessVerticalSpace = true;
											testModuleDescriptionTextAreaLData.grabExcessHorizontalSpace = true;
											testModuleDescriptionTextArea.setLayoutData(testModuleDescriptionTextAreaLData);
											testModuleDescriptionTextArea.setEditable(false);
											testModuleDescriptionTextArea.setBackground(SWTResourceManager.getColor(255, 255, 255));
											testModuleDescriptionTextArea.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
										}
									}
									{
										testModuleSettingsScrolledComposite = new ScrolledComposite(testModuleDetailsSashForm, SWT.V_SCROLL);
										{
											testModuleSettingsComposite = new Composite(testModuleSettingsScrolledComposite, SWT.NONE);
											testModuleSettingsScrolledComposite.setContent(testModuleSettingsComposite);
//											testModuleSettingsComposite = new Composite(testModuleDetailsSashForm, SWT.NONE);
											GridLayout testModuleSettingsCompositeLayout = new GridLayout();
											testModuleSettingsCompositeLayout.makeColumnsEqualWidth = true;
											testModuleSettingsComposite.setLayout(testModuleSettingsCompositeLayout);
											testModuleSettingsComposite.setBounds(0, 0, 525, 30);
										}
									}
									testModuleDetailsSashForm.setWeights(new int[] {20,80});
								}
								testModuleTabSashForm.setWeights(new int[] {35,65});

							}
						}
					}
				}
			}
			this.layout();
		} 
		catch (Exception e) 
		{
			Debug.errDebug("Problem constructing GUI: " + e.toString(), e);
			System.exit(1);
		}
	}
	
	public void setHttpMethod(final String httpMethod)
	{
		
		this.getDisplay().asyncExec
		(
			new Runnable()
			{
				public void run()
				{
					boolean post = false;
					if (httpMethod.equalsIgnoreCase("POST"))
					{
						post = true;
					}
					httpPostRadio.setSelection(post);
					httpGetRadio.setSelection(!post);
					httpPostButtonSelectAction();
				}
		});
		
	}
	public void setUri(final String uri)
	{
		this.getDisplay().asyncExec
		(
			new Runnable()
			{
				public void run()
				{
					authenticationUrlTextBox.setText(uri);
				}
		});		
	}


	public void setPasswordField(final String passwordField)
	{
		this.getDisplay().asyncExec
		(
			new Runnable()
			{
				public void run()
				{
					passwordFieldTextbox.setText(passwordField);
				}
		});		
	}

	public void setPostQuery(final String postQuery)
	{
		this.getDisplay().asyncExec
		(
			new Runnable()
			{
				public void run()
				{
					postQueryTextbox.setText(postQuery);
				}
		});		
	}

	public void setUsernameField(final String usernameField)
	{
		this.getDisplay().asyncExec
		(
			new Runnable()
			{
				public void run()
				{
					usernameFieldTextbox.setText(usernameField);
				}
		});		
	}



	private void runAuthWizard()
	{
		AuthWizardDialog wizardDialog = new AuthWizardDialog(shell, this, scan); 
		wizardDialog.open();
	}


	private void clearModuleSettingsArea()
	{
		for (Control child: testModuleSettingsComposite.getChildren())
		{
			child.dispose();
		}
		testModuleSettingsComposite.setBounds(0, 0, 525, 30);
		
	}
	
	private void populateTestModuleSettings(TestModule module)
	{
		clearModuleSettingsArea();

		if (module != null)
		{
			if (module.isExperimental())
			{
				makeExperimentalText(module.getExperimentalText(), testModuleSettingsComposite);
			}
			
			if (module.getConfigurationOptions().size() == 0)
			{
				Label defaultLabel = new Label(testModuleSettingsComposite, SWT.NONE);
				defaultLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
				defaultLabel.setText("No configurable options for " + module.getName());

				Rectangle b = testModuleSettingsComposite.getBounds();
				b.height += defaultLabel.getBounds().height;
				testModuleSettingsComposite.setBounds(b);
				testModuleSettingsComposite.layout();
			}
			else
			{
				for(ConfigurationOption option: module.getConfigurationOptions())
				{
					
					if (option instanceof OptionGroup)
					{
						makeGroupOptionGUI((OptionGroup) option, testModuleSettingsComposite);
					}
					else if (option instanceof FileNameOption)
					{
						makeFileNameOption((FileNameOption) option, testModuleSettingsComposite);
					}
					else if (option instanceof IntegerOption)
					{
						makeIntegerOptionGUI((IntegerOption) option, testModuleSettingsComposite);
					}
					else if (option instanceof TextOption)
					{
						makeTextOptionGUI((TextOption) option, testModuleSettingsComposite);
					}
					else if (option instanceof SelectableOption)
					{
						makeSelectableOptionGUI((SelectableOption) option, testModuleSettingsComposite, true);
					}
				}
			}
		}

		testModuleSettingsComposite.getParent().layout();
		testModuleSettingsComposite.layout();
	}
	
	private void makeExperimentalText(String statusText, Composite parent)
	{
		
		Label label = new Label(parent, SWT.NONE);
		label.setText("Experimental status:");
		label.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += label.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}
		
		int style = SWT.BORDER | SWT.MULTI | SWT.WRAP | SWT.READ_ONLY | SWT.V_SCROLL;
		Text textBox = new Text(parent, style);
		textBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
		textBox.setText(statusText);
		GridData text1LData = new GridData();
		text1LData.widthHint = 400;
		text1LData.heightHint = 100;
		textBox.setLayoutData(text1LData);

		
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += textBox.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}

	}
	
	private void makeIntegerOptionGUI(IntegerOption option, Composite parent)
	{
		makeOptionLabel(option, parent);
		
		Text textBox = new Text(parent, SWT.BORDER);
		textBox.addModifyListener(new integerModifyListener(option, textBox));
		textBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
		
		GridData text1LData = new GridData();
		text1LData.widthHint = 300;
		text1LData.heightHint = 25;
		textBox.setLayoutData(text1LData);

		textBox.setText(String.valueOf(option.getValue()));
		
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += textBox.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}
	}

	private class integerModifyListener implements ModifyListener
	{
		IntegerOption innerOption;
		Text t;

		public integerModifyListener(IntegerOption innerOption, Text text)
        {
	        this.innerOption = innerOption;
	        this.t = text;
        }

        public void modifyText(ModifyEvent e)
        {
			String value = t.getText();
			if (value == null)
			{
				value = "0";
			}
			innerOption.setValue(Integer.valueOf(value));
        }
	}

	private class textModifyListener implements ModifyListener
	{
		TextOption innerOption;
		Text t;

		public textModifyListener(TextOption innerOption, Text text)
        {
	        this.innerOption = innerOption;
	        this.t = text;
        }

        public void modifyText(ModifyEvent e)
        {
			String value = t.getText();
			if (value == null)
			{
				value = "";
			}
			innerOption.setValue(value);
        }
	}
	
	private void makeTextOptionGUI(TextOption option, Composite parent)
	{
		makeOptionLabel(option, parent);
		
		int style = SWT.BORDER | (option.isMultiLine() ? SWT.MULTI | SWT.H_SCROLL | SWT.V_SCROLL : 0);
		Text textBox = new Text(parent, style);
		textBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
		textBox.addModifyListener(new textModifyListener(option, textBox));
		
		GridData text1LData = new GridData();
		text1LData.widthHint = 300;
		text1LData.heightHint = option.isMultiLine() ? 100 : 25;
		textBox.setLayoutData(text1LData);

		textBox.setText(option.getValue());
		
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += textBox.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}
	}
	
	
	private void makeGroupOptionGUI(OptionGroup option, Composite parent)
	{
		Group group = new Group(parent, SWT.NONE);
		group.setText(((ConfigurationOption) option).getName());
		group.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));

		GridLayout groupLayout = new GridLayout();
		groupLayout.makeColumnsEqualWidth = true;
		group.setLayout(groupLayout);
		
		if (option instanceof MultiSelectOptionGroup)
		{
			MultiSelectOptionGroup mgroup = (MultiSelectOptionGroup) option;
			for (SelectableOption soption: mgroup.getAllOptions())
			{
				makeSelectableOptionGUI(soption, group, true);
			}
		}
		else if (option instanceof SingleSelectOptionGroup)
		{
			SingleSelectOptionGroup sgroup = (SingleSelectOptionGroup) option;
			for (SelectableOption soption: sgroup.getAllOptions())
			{
				makeSelectableOptionGUI(soption, group, false);
			}
		}
		
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += group.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}
	}

	
	
	private void makeOptionLabel(ConfigurationOption option, Composite parent)
	{
		Label label = new Label(parent, SWT.NONE);
		label.setText(option.getName());
		label.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += label.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}
	}
	
	/**
	 * 
	 * @param option
	 * @param parent
	 * @param checkBox If false, then a radio button will be created
	 */
	private void makeSelectableOptionGUI(SelectableOption option, Composite parent, boolean checkBox)
	{
		int style = SWT.LEFT;
		if (checkBox)
		{
			style |= SWT.CHECK;
		}
		else
		{
			style |= SWT.RADIO;
		}
			
		Button button = new Button(parent, style);
		button.setData(option);
		button.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
		button.setText(option.getName());
		button.setSelection(option.isSelected());
		button.addSelectionListener(
			new SelectionAdapter()
			{
				public void widgetSelected(SelectionEvent event)
				{
					Button b = (Button) event.getSource();
					SelectableOption so = (SelectableOption) b.getData();
					so.setSelected(b.getSelection());
				}
			}
		);
				
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += button.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}
	}

	private class FileNameBrowseButtonListener extends SelectionAdapter
	{
		private FileNameOption internalOption;
		private Text internalFilenameTextBox;
		
		public void widgetSelected(SelectionEvent event)
		{
			String filename = null; 
			if (internalOption.isDirectory())
			{
				DirectoryDialog dd = new DirectoryDialog(shell);
				try
                {
                    dd.setFilterPath(new File(".").getCanonicalPath());
                }
                catch (IOException e1)
                {
                }
				dd.setText(internalOption.getName());
				filename = dd.open();
			}
			else
			{
				FileDialog fd = new FileDialog(shell, SWT.SAVE);
				fd.setText(internalOption.getName());
				filename = fd.open();
			}
			if (filename != null)
			{
				internalFilenameTextBox.setText(filename);
				internalOption.setValue(filename);
			}
		}

		public FileNameBrowseButtonListener(FileNameOption internalOption, Text internalFilenameTextBox)
        {
	        this.internalOption = internalOption;
	        this.internalFilenameTextBox = internalFilenameTextBox;
        }
	}
	
	private void makeFileNameOption(FileNameOption option, Composite parent)
	{
		makeOptionLabel(option, parent);
		Text filenameTextBox = new Text(parent, SWT.BORDER);
		filenameTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
		filenameTextBox.addModifyListener(new textModifyListener(option, filenameTextBox));
		filenameTextBox.setSize(300, 25);
		GridData text1LData = new GridData();
		text1LData.widthHint = 300;
		text1LData.heightHint = 25;
		filenameTextBox.setLayoutData(text1LData);
		filenameTextBox.setText(option.getValue());

		Button filenameBrowseButton = new Button(parent, SWT.PUSH | SWT.CENTER);
		filenameBrowseButton.setText("Browse");
		filenameBrowseButton.setSize(100, 25);
		filenameBrowseButton.addSelectionListener(new FileNameBrowseButtonListener(option, filenameTextBox));
		filenameBrowseButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));

		
		parent.layout();
		if (parent == testModuleSettingsComposite)
		{
			Rectangle b = parent.getBounds();
			b.height += filenameTextBox.getBounds().height;
			b.height += filenameBrowseButton.getBounds().height;
			parent.setBounds(b);
			parent.layout();
		}

	}
	
	private void updateAuthenticationTab()
	{
		htmlFormAuthenticationButtonSelectAction();
		httpPostButtonSelectAction();
		authenticationTypeGroup.setEnabled(useAuthenticationCheckBox.getSelection());
//		httpAuthenticationRadio.setEnabled(useAuthenticationCheckBox.getSelection());
		htmlFormAuthenticationRadio.setEnabled(useAuthenticationCheckBox.getSelection());
		accountsGroup.setEnabled(useAuthenticationCheckBox.getSelection());
		usernameLabel.setEnabled(useAuthenticationCheckBox.getSelection());
		usernameTextBox.setEnabled(useAuthenticationCheckBox.getSelection());
		passwordLabel.setEnabled(useAuthenticationCheckBox.getSelection());
//		domainLabel.setEnabled(useAuthenticationCheckBox.getSelection());
//		domainTextBox.setEnabled(useAuthenticationCheckBox.getSelection());
		accountsTable.setEnabled(useAuthenticationCheckBox.getSelection());
		showPasswordsCheckbox.setEnabled(useAuthenticationCheckBox.getSelection());
		accountAddButton.setEnabled(useAuthenticationCheckBox.getSelection());
		accountRemoveButton.setEnabled(useAuthenticationCheckBox.getSelection());
		passwordTextBox.setEnabled(useAuthenticationCheckBox.getSelection());

	}
	
	private String makeAuthenticationPackage(boolean forSave)
	{
		String message = "";
		scanSettings.setUseAuthentication(useAuthenticationCheckBox.getSelection());
		if (useAuthenticationCheckBox.getSelection())
		{
			AuthenticationPackage authPackage = null;
			if (accountsTable.getItemCount() == 0 && !forSave)
			{
				message += "- At least one username must be defined.\n";
			}
			if (htmlFormAuthenticationRadio.getSelection())
			{
				if (!forSave && (usernameFieldTextbox.getText().equals("") || passwordFieldTextbox.getText().equals("")))
				{
					message += "- Username and password field names must be provided for HTML form authentication.\n";
				}
				if (!forSave && authenticationUrlTextBox.getText().equals(""))
				{
					message += "- A URI must be provided for HTML form authentication.\n";
				}
				else
				{
					String method;
					if (httpGetRadio.getSelection())
					{
						method = "GET";
					}
					else
					{
						method = "POST";
					}
					
					URI uri;
					String rawUri = authenticationUrlTextBox.getText();
					if (!rawUri.equals(""))
					{
		                try
		                {
		                    uri = UriFactory.makeUri(rawUri, true);
		                    if (message.equals(""))
		                    {
								authPackage = new FormBasedAuthentication
								(scan, uri, method, postQueryTextbox.getText(), usernameFieldTextbox.getText(), passwordFieldTextbox.getText());
		                    }
		                }
		                catch (URISyntaxException e)
		                {
							message += "- Invalid authentication URI syntax. Note that authentication URLs must be absolute.\n";
		                }
					}
				}
			}
			else if (message.equals(""))
			{
				authPackage = new HttpBasedAuthentication(scan);
			}
			
			if (authPackage != null)
			{
				for (TableItem item: accountsTable.getItems())
				{
					authPackage.addCredentialSet(item.getText(0), (String) item.getData("password"));
				}
				scanSettings.setAuthenticationPackage(authPackage);
			}
		}
		else
		{
			scanSettings.setAuthenticationPackage(null);
		}
		return message;
	}
	
	private void updateUpstreamProxyStatus()
	{
		upstreamProxyAddressLabel.setEnabled(useUpstreamProxyCheckBox.getSelection());
		upstreamProxyPortLabel.setEnabled(useUpstreamProxyCheckBox.getSelection());
		upstreamProxyAddressTextBox.setEnabled(useUpstreamProxyCheckBox.getSelection());
		upstreamProxyPortTextBox.setEnabled(useUpstreamProxyCheckBox.getSelection());
//		upstreamProxyUsernameTextBox.setEnabled(useUpstreamProxyCheckBox.getSelection());
//		upstreamProxyUsernameLabel.setEnabled(useUpstreamProxyCheckBox.getSelection());
//		upstreamProxyPasswordLabel.setEnabled(useUpstreamProxyCheckBox.getSelection());
//		upstreamProxyPasswordTextBox.setEnabled(useUpstreamProxyCheckBox.getSelection());
//		upstreamProxyDigestAuthenticationRadioButton.setEnabled(useUpstreamProxyCheckBox.getSelection());
//		upstreamProxyBasicAuthenticationRadioButton.setEnabled(useUpstreamProxyCheckBox.getSelection());
//		upstreamProxyAuthenticationTypeGroup.setEnabled(useUpstreamProxyCheckBox.getSelection());
	}
	

	public void setScan(Scan scan)
    {
    	this.scan = scan;
    }
	
	private void createPasswordTextBox(boolean readable)
	{
		int style = SWT.BORDER;
		if (!readable)
		{
			style |= SWT.PASSWORD;
		}
		String value = "";
		if (passwordTextBox != null)
		{
			value = passwordTextBox.getText();
			passwordTextBox.dispose();
		}
		passwordTextBox = new Text(accountsGroup, style);
		passwordTextBox.setBounds(83, 61, 111, 25);
		passwordTextBox.setText(value);
		passwordTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));

	}
	
	
	private void htmlFormAuthenticationButtonSelectAction()
	{
		formAuthenticationGroup.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		runAuthWizardButton.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		usernameFieldTextbox.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		usernameFieldLabel.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		passwordFieldLabel.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		passwordFieldTextbox.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		
		httpMethodGroup.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		httpGetRadio.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		httpPostRadio.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		
		authenticationUrlLabel.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		authenticationUrlTextBox.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		
//		if (useDomainCheckbox.getSelection())
//		{
//			domainFieldLabel.setEnabled(false);
//			domainFieldTextbox.setEnabled(false);
//		}
		if (httpPostRadio.getSelection())
		{
			postQueryLabel.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
			postQueryTextbox.setEnabled(htmlFormAuthenticationRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		}
	}
	
	private void httpPostButtonSelectAction()
	{
		postQueryTextbox.setEnabled(htmlFormAuthenticationRadio.getSelection() && httpPostRadio.getSelection() && useAuthenticationCheckBox.getSelection());
		postQueryLabel.setEnabled(htmlFormAuthenticationRadio.getSelection() && httpPostRadio.getSelection() && useAuthenticationCheckBox.getSelection());
	}

	private void updateProxyStatus()
	{
		proxyBindAddressLabel.setEnabled(enableProxyCheckBox.getSelection());
		proxyBindPortLabel.setEnabled(enableProxyCheckBox.getSelection());
		proxyBindAddressTextBox.setEnabled(enableProxyCheckBox.getSelection());
		proxyBindPortTextBox.setEnabled(enableProxyCheckBox.getSelection());
		maxProxyThreadLabel.setEnabled(enableProxyCheckBox.getSelection());
		maxProxyThreadTextBox.setEnabled(enableProxyCheckBox.getSelection());
	}

	private boolean commitSettings(boolean forSave)
	{
		boolean proxyOnly = scanSettings.isProxyOnly();
		String message = "";
		if (!proxyOnly)
		{
			message += makeAuthenticationPackage(forSave);
			
			if (baseUrlList.getItems().length == 0 && ! enableProxyCheckBox.getSelection() && !forSave)
			{
				message += "- If the proxy server isn't enabled, at least one base URL must be provided\n";
			}
	
			if (baseUrlList.getItems().length == 0 && urlWhitelistList.getItems().length == 0 && !forSave)
			{
				message += "- A base URL, or a URL whitelist must be provided\n";
			}
	
			if (this.reportFileNameTextbox.getText().equals("") && !forSave)
			{
				message += "- No report filename set\n";
			}
		}
			
		if (message.equals(""))
		{
			if (forSave)
			{
				scanSettings.setOutputDirectory(outputDirectoryTextBox.getText());
			}
			
			scanSettings.setProxyEnabled(enableProxyCheckBox.getSelection());
			scanSettings.setProxyIPAddress(proxyBindAddressTextBox.getText());
			scanSettings.setProxyPort(Integer.valueOf(proxyBindPortTextBox.getText()));
			scanSettings.setMaxProxyThreads(Integer.valueOf(maxProxyThreadTextBox.getText()));
			scanSettings.setUseUpstreamProxy(this.useUpstreamProxyCheckBox.getSelection());

			if (scanSettings.getUseUpstreamProxy())
			{
				scanSettings.setUpstreamProxyAddress(this.upstreamProxyAddressTextBox.getText());
				scanSettings.setUpstreamProxyPort(Integer.valueOf(this.upstreamProxyPortTextBox.getText()));
				scanSettings.setUpstreamProxyUsername(this.upstreamProxyUsernameTextBox.getText());
				scanSettings.setUpstreamProxyPassword(this.upstreamProxyPasswordTextBox.getText());
				HttpAuthenticationType authType;
				if (this.upstreamProxyNTLMAuthenticationRadioButton.getSelection())
				{
					authType = HttpAuthenticationType.NTLM;
				}
				else if (this.upstreamProxyDigestAuthenticationRadioButton.getSelection())
				{
					authType = HttpAuthenticationType.DIGEST;
				}
				else
				{
					authType = HttpAuthenticationType.BASIC;
				}
				scanSettings.setUpstreamProxyAuthenticationType(authType);
			}
			
			scanSettings.setMaxRequestsPerSecond(Integer.valueOf(this.maxRequestsPerSecondTextBox.getText()));
			scanSettings.setMaxConnectionsPerServer(Integer.valueOf(this.maxConnectionsPerServerTextBox.getText()));
			scanSettings.setSocketReadTimeout(Integer.valueOf(socketReadTimeoutTextBox.getText()));
			scanSettings.setMaxTotalConnections(Integer.valueOf(this.maxTotalConnectionsTextBox.getText()));
			scanSettings.setMaxFileSizeKiloBytes(1024 * Integer.valueOf(this.maxFileSizeTextBox.getText()));


			if (!proxyOnly)
			{
				scanSettings.setMaxRequestCount(Integer.valueOf(maxTotalRequestsTextBox.getText()));
				scanSettings.setMaxFailedRequestsPerHost(Integer.valueOf(maxFailedRequestsPerServerTextBox.getText()));
				scanSettings.setMaxConsecutiveFailedRequests(Integer.valueOf(maxConsecutiveFailedRequestsTextBox.getText()));
				scanSettings.setUserAgentString(useragentComboBox.getText());
				

				scanSettings.setMaxRequesterThreads(Integer.valueOf(this.maxRequesterThreadTextbox.getText()));
				scanSettings.setMaxCategorizerThreads(Integer.valueOf(this.maxCategorizerThreadTextBox.getText()));
				scanSettings.setMaxTesterThreads(Integer.valueOf(this.maxTesterThreadTextBox.getText()));
			
				scanSettings.setUseAutomaticResponseCodeOverrides(this.useAutomaticOverridesCheckBox.getSelection());
				scanSettings.setTestAllDirectoriesForResponseCodeOverrides(this.testEveryDirectoryCheckBox.getSelection());
				
				scanSettings.getManualResponseCodeOverrides().clear();
				for(TableItem item: this.responseCodeOverrideTable.getItems())
				{
					scanSettings.getManualResponseCodeOverrides().put(item.getText(1), Integer.valueOf(item.getText(0)));
				}
				
				ReportGenerator report = null;
				if (textReportRadio.getSelection())
				{
					report = new TextReportGenerator(scan, reportFileNameTextbox.getText(), EventSeverity.getSeverityByName(reportMinSeverityCombo.getText()));
				}
				else if (htmlReportRadio.getSelection())
				{
					report = new HtmlReportGenerator(scan, reportFileNameTextbox.getText(), EventSeverity.getSeverityByName(reportMinSeverityCombo.getText()));
				}
				scanSettings.setReportGenerator(report);
				
				scanSettings.getIrrelevantQueryParameters().clear();
				for (String param: ignoredParameterList.getItems())
				{
					scanSettings.getIrrelevantQueryParameters().add(param);
				}
				
				scanSettings.getForbiddenQueryParameters().clear();
				for (String param: forbiddenParameterList.getItems())
				{
					scanSettings.getForbiddenQueryParameters().add(param);
				}
				
				scanSettings.getUrlFilters().clearUrlBlacklists();
				for (String regex: this.urlBlacklistList.getItems())
				{
					scanSettings.getUrlFilters().addUrlBlacklist(regex);
				}
				
				scanSettings.getUrlFilters().clearUrlWhitelists();
				for (String regex: this.urlWhitelistList.getItems())
				{
					scanSettings.getUrlFilters().addUrlWhitelist(regex);
				}
				
				scanSettings.getKnownSessionIDRegexs().clear();
				for (String regex: this.knownSessionIDListComposite.getListText())
				{
					// All of these should be valid because they were already checked
					scanSettings.getKnownSessionIDRegexs().add(Pattern.compile(regex, Pattern.CASE_INSENSITIVE));
				}
				
				scanSettings.getBaseURIs().clear();
				for(String url: this.baseUrlList.getItems())
				{
					URI baseURI = URI.create(url);
					scanSettings.getBaseURIs().add(baseURI);
				}
			}
			else
			{
				scanSettings.getUrlFilters().addUrlWhitelist(".");
			}
			
			return true;
		}
		else
		{
			displayInternalMessage("Error", message);
			return false;
		}
	}
	
	private boolean isOutputDirStatusGood()
	{
		boolean exists = new File(this.outputDirectoryTextBox.getText()).exists();
		if (exists)
		{
			MessageBox m = new MessageBox(shell, SWT.OK);
			m.setMessage("The output directory already exists. Please pick a new location,\n" +
						"delete its contents, or clear the field to use a default location.");
			m.setText("Error:");
			m.open();
		}
		return ! exists;
	}
	
	private void startScan()
	{
		if (scanSettings.getOutputDirectory().equals(""))
		{
			String dirname = "";
            try
            {
	            dirname = new File(".").getCanonicalPath() + File.separator + scanSettings.generateDefaultOutputDirectory();
            }
            catch (IOException e)
            {
            }
			MessageBox m = new MessageBox(getShell(), SWT.YES | SWT.NO);
			m.setText("No output directory");
			m.setMessage("No output directory was defined. Use the default of\n" + dirname + "?");
			if (m.open() == SWT.YES)
			{
				scanSettings.setOutputDirectory(dirname);
			}
			else
			{
				return;
			}
		}
		
		if (scanSettings.isLoadDatabase() || isOutputDirStatusGood())
		{
			if (!scan.initDatabase(scanSettings.getOutputDirectory() + File.separator + "transaction-record", !scanSettings.isLoadDatabase()))
			{
				displayInternalMessage("Error:", "Error " + (scanSettings.isLoadDatabase() ? "loading existing" : "creating") + " scan database.");
			}
			else if (commitSettings(false))
			{
				getParent().dispose();
				scanStarted = true;
			}
		}
	}
	
	private void displayInternalMessage(String title, String message)
	{
		MessageBox m = new MessageBox(getShell(), SWT.OK);
		m.setMessage(message);
		m.setText(title);
		m.open();
	}

	public void displayMessage(final String title, final String message)
	{
		displayMessage(title, message, true);
	}
	
	public void displayMessage(final String title, final String message, boolean wait)
	{
		if (!getDisplay().isDisposed())
		{
			Runnable r = new Runnable()
			{
				public void run()
				{
					MessageBox m = new MessageBox(getShell(), SWT.OK);
					m.setMessage(message);
					m.setText(title);
					m.open();
				}
			};
			if (wait)
			{
				getDisplay().syncExec(r);
			}
			else
			{
				getDisplay().asyncExec(r);
			}
		}
	}
	
	public boolean isScanStarted()
    {
    	return scanStarted;
    }
	
	private void showHelp(String selectedSection)
	{
		if (selectedSection == null || selectedSection.equals(""))
		{
			selectedSection = tabFolder.getSelection().getText();
		}
		if (generalSettingsHelpText == null)
		{
			String path = ConfigurationManager.getString("help.directory");
			generalSettingsHelpText = getHelpText(path, "help.general_settings_help");
			scanRestrictionsHelpText = getHelpText(path, "help.scan_restrictions_help");
			authenticationHelpText = getHelpText(path, "help.authentication_help");
			httpClientHelpText = getHelpText(path, "help.http_client_help");
			moduleSelectionHelpText = getHelpText(path, "help.module_selection_help");
			
		}
		HelpViewer viewer = new HelpViewer(Display.getCurrent());
		viewer.addHelpSection(generalSettingsTab.getText(), generalSettingsHelpText);
		viewer.addHelpSection(httpClientTab.getText(), httpClientHelpText);
		viewer.addHelpSection(authenticationTab.getText(), authenticationHelpText);
		viewer.addHelpSection(scanRestrictionsTab.getText(), scanRestrictionsHelpText);
		viewer.addHelpSection(testModuleSelectionTab.getText(), moduleSelectionHelpText);
		viewer.setFirstSelectionName(selectedSection);
		viewer.showGUI();
	}
	
	private String getHelpText(String path, String name)
	{
		String fileName = ConfigurationManager.getString(name);
		return FileUtils.readFile(path + File.separator + fileName);
	}

	static private boolean promptExit(Shell shell)
	{
		int style = SWT.APPLICATION_MODAL | SWT.YES | SWT.NO;
		MessageBox messageBox = new MessageBox (shell, style);
		messageBox.setText ("Exit?");
		messageBox.setMessage ("Are you sure you want to exit?");
		return messageBox.open() == SWT.YES;
	}

	private void displayScanSettings()
	{
		enableProxyCheckBox.setSelection(scanSettings.isProxyEnabled());
		proxyBindAddressTextBox.setText(scanSettings.getProxyIPAddress());
		proxyBindPortTextBox.setText(String.valueOf(scanSettings.getProxyPort()));
		maxProxyThreadTextBox.setText(String.valueOf(scanSettings.getMaxProxyThreads()));
		maxRequesterThreadTextbox.setText(String.valueOf(scanSettings.getMaxRequesterThreads()));
		maxTesterThreadTextBox.setText(String.valueOf(scanSettings.getMaxTesterThreads()));
		maxCategorizerThreadTextBox.setText(String.valueOf(scanSettings.getMaxCategorizerThreads()));
		useUpstreamProxyCheckBox.setSelection(scanSettings.getUseUpstreamProxy());
		upstreamProxyAddressTextBox.setText(scanSettings.getUpstreamProxyAddress());
		upstreamProxyPortTextBox.setText(String.valueOf(scanSettings.getUpstreamProxyPort()));
		upstreamProxyUsernameTextBox.setText(scanSettings.getUpstreamProxyUsername());
		upstreamProxyPasswordTextBox.setText(scanSettings.getUpstreamProxyPassword());
		if (scanSettings.getUpstreamProxyAuthenticationType() == null)
		{
			upstreamProxyDigestAuthenticationRadioButton.setSelection(true);
		}
		else
		{
			switch(scanSettings.getUpstreamProxyAuthenticationType())
			{
				case DIGEST: upstreamProxyDigestAuthenticationRadioButton.setSelection(true); break;
				case BASIC: upstreamProxyBasicAuthenticationRadioButton.setSelection(true); break;
				case NTLM: upstreamProxyNTLMAuthenticationRadioButton.setSelection(true); break;
			}
		}
		maxRequestsPerSecondTextBox.setText(String.valueOf(scanSettings.getMaxRequestsPerSecond()));
		maxConnectionsPerServerTextBox.setText(String.valueOf(scanSettings.getMaxConnectionsPerServer()));
		maxTotalConnectionsTextBox.setText(String.valueOf(scanSettings.getMaxTotalConnections()));
		maxConsecutiveFailedRequestsTextBox.setText(String.valueOf(scanSettings.getMaxConsecutiveFailedRequests()));
		maxFailedRequestsPerServerTextBox.setText(String.valueOf(scanSettings.getMaxFailedRequestsPerHost()));
		socketReadTimeoutTextBox.setText(String.valueOf(scanSettings.getSocketReadTimeout()));
		maxTotalRequestsTextBox.setText(String.valueOf(scanSettings.getMaxRequestCount()));
		maxFileSizeTextBox.setText(String.valueOf(scanSettings.getMaxFileSizeBytes()));
		useragentComboBox.setText(scanSettings.getUserAgentString());
		useAutomaticOverridesCheckBox.setSelection(scanSettings.getUseAutomaticResponseCodeOverrides());
		testEveryDirectoryCheckBox.setSelection(scanSettings.getTestAllDirectoriesForResponseCodeOverrides());
		ignoredParameterList.setItems(CollectionUtils.toStringArray(scanSettings.getIrrelevantQueryParameters()));
		forbiddenParameterList.setItems(CollectionUtils.toStringArray(scanSettings.getForbiddenQueryParameters()));
		urlBlacklistList.setItems(CollectionUtils.toStringArray(scanSettings.getUrlFilters().getBlacklistsAsString()));
		urlWhitelistList.setItems(CollectionUtils.toStringArray(scanSettings.getUrlFilters().getWhitelistsAsString()));
		outputDirectoryTextBox.setText(scanSettings.getOutputDirectory());
		reportFileNameTextbox.setText(scanSettings.getReportGenerator().getReportFilename());
		htmlReportRadio.setSelection(scanSettings.getReportGenerator() instanceof HtmlReportGenerator ? true : false);
		textReportRadio.setSelection(scanSettings.getReportGenerator() instanceof TextReportGenerator ? true : false);
		reportMinSeverityCombo.setText(scanSettings.getReportGenerator().getMinSeverity().getFullName());
		
		baseUrlList.removeAll();
		for (URI baseUri: scanSettings.getBaseURIs())
		{
			baseUrlList.add(baseUri.toASCIIString());
		}
		
		accountsTable.removeAll();
		useAuthenticationCheckBox.setSelection(scanSettings.isUseAuthentication());
		AuthenticationPackage auth = scanSettings.getAuthenticationPackage();
		authenticationUrlTextBox.setText("");
		usernameFieldTextbox.setText("");
		passwordFieldTextbox.setText("");
		postQueryTextbox.setText("");
		if (auth != null)
		{
//			httpAuthenticationRadio.setSelection(auth instanceof HttpBasedAuthentication ? true: false);
			htmlFormAuthenticationRadio.setSelection(auth instanceof FormBasedAuthentication ? true: false);
			for(String user: auth.getCredentials().keySet())
			{
				addCredentials(user, auth.getCredentials().get(user));
			}
			
			if (auth instanceof FormBasedAuthentication)
			{
				FormBasedAuthentication h = (FormBasedAuthentication) auth;
				authenticationUrlTextBox.setText(h.getUri().toASCIIString());
				httpPostRadio.setSelection(h.getMethod().equalsIgnoreCase("POST") ? true : false);
				httpGetRadio.setSelection(h.getMethod().equalsIgnoreCase("GET") ? true : false);
				postQueryTextbox.setText(h.getPostQuery());
				passwordFieldTextbox.setText(h.getPasswordParameterName());
				usernameFieldTextbox.setText(h.getUserParameterName());
			}
		}
		
		updateAuthenticationTab();
		updateUpstreamProxyStatus();
		updateProxyStatus();
		updateAutomaticResponseCodes();

		{
			knownSessionIDListComposite.removeAll();
			String patterns[] = new String[scanSettings.getKnownSessionIDRegexs().size()];
			int index = 0;
			for (Pattern p: scan.getScanSettings().getKnownSessionIDRegexs())
			{
				patterns[index++] = p.pattern();
			}
			knownSessionIDListComposite.addItems(patterns);
		}
		
		{
			responseCodeOverrideTable.removeAll();
			for (String pattern: scan.getScanSettings().getManualResponseCodeOverrides().keySet())
			{
				addResponseCodeOverride(pattern, String.valueOf(scan.getScanSettings().getManualResponseCodeOverrides().get(pattern)));
			}
		}
		
		populateModules();
		clearModuleSettingsArea();
	}
	

	private void updateAutomaticResponseCodes()
	{
		testEveryDirectoryCheckBox.setEnabled(useAutomaticOverridesCheckBox.getSelection());
	}

	private void addCredentials(String userName, String password)
	{
		TableItem item = new TableItem(accountsTable, SWT.NONE);
		item.setData("password", password);
		item.setText(0, userName);
		String pass;
		if (showPasswordsCheckbox.getSelection())
		{
			pass = password;
		}
		else
		{
			pass = "********";
		}
		
//		if (useDomainCheckbox.getSelection())
//		{
//			item.setText(2, domainTextBox.getText());
//			domainTextBox.setText("");
//		}
		item.setText(1, pass);
	}

	private void addResponseCodeOverride(String code, String pattern)
	{
		TableItem item = new TableItem(responseCodeOverrideTable, SWT.NONE);
		item.setText(new String[] {code, pattern});
	}
}
