package com.grendelscan.GUI;
import com.grendelscan.fuzzing.FuzzVector;
import com.grendelscan.fuzzing.Fuzzer;
import com.grendelscan.requester.http.factories.*;

import java.io.File;
import java.util.ArrayList;
import java.util.List;

import org.apache.http.NameValuePair;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.*;
import org.eclipse.swt.widgets.*;

import com.cloudgarden.resource.SWTResourceManager;
import com.grendelscan.GrendelScan;
import com.grendelscan.requester.TransactionSource;
import com.grendelscan.requester.http.transactions.*;
import com.grendelscan.scan.*;
import com.grendelscan.utils.*;
import com.grendelscan.GUI.Verifiers.EnforceIntegersOnly;
import com.grendelscan.GUI.fuzzing.FuzzCriteriaDialog;
import com.grendelscan.GUI.fuzzing.FuzzTemplateComposite;
import com.grendelscan.GUI.fuzzing.FuzzVectorChoiceDialog;
import com.grendelscan.GUI.http.*;
import com.grendelscan.GUI.http.interception.*;
/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class ScanStatusWindow extends org.eclipse.swt.widgets.Composite
{
	
	private static boolean closed = false;
	private String scanStatusHelpText;
	private String transactionsHelpText;
	private String manualRequestHelpText;
	private String proxySettingsHelpText;
	private String interceptionSettingsHelpText;
	private String fuzzerHelpText;

	private static Shell shell;
	private Group proxySettingsGroup;
	private Button clearTableButton;
	private Button stopFuzzButton;
	private Button startFuzzButton;
	private Text maxFuzzRequestsTextbox;
	private Label maxFuzzRequestsLabel;
	private TransactionTable fuzzResultsTable;
	private Button fuzzCriteriaButton;
	private Button restartProxyButton;
	private Button fuzzVectorButton;
	private Button fuzzTemplateButton;
	private Button waitOnProxyCheckbox;
	private Button startProxyButton;
	private Text maxProxyThreadTextBox;
	private Label maxProxyThreadLabel;
	private Text proxyBindPortTextBox;
	private Label proxyBindPortLabel;
	private Text proxyBindAddressTextBox;
	private Label proxyBindAddressLabel;
	private Button testIntecptedRequestsCheckbox;
	private Button testProxyRequestsCheckbox;
	private Button testManualRequestsCheckbox;
	private Button allowAllProxyRequests;
	private Button revealHiddenFieldsButton;
	private Button executeRequestButton;
	private Composite manualRequestComposite;
	private Button helpButton;
	private Button pauseScanButton;
	private TransactionTable transactionTable;
	private Label categorizerQueueLabel;
	private Label requesterQueueLabel;
	private Text requesterQueueSizeTextBox;
	private Text categorizerQueueSizeTextBox;
	private Label testQueueLabel;
	private Group queueSizeGroup;
	private Text testerQueueSizeTextBox;
	private Scan scan;
	private Text scanStatusTextArea;
	private Button terminateScanButton;
	private int maxStatusSize = 100000;
	private Composite interceptionSettingsComposite;
	private TabFolder scanTabs;
	private TabItem scanStatusTab;
	private TabItem transactionsTab;
	private TabItem manualRequestTab;
	private TabItem proxySettingsTab;
	private TabItem intecreptionSettingsTab;
	private TabItem fuzzerTab;
	private final List<InterceptFilter> fuzzFilters;
	private InterceptionSettingsComposite requestInterceptFilters;
	private Button enableInterceptRequestCheck;
	private Group requestInterceptionGroup;

	private InterceptionSettingsComposite responseInterceptFilters;
	private Button enableInterceptResponseCheck;

	private Group responseInterceptionGroup;
	private Button testIntecptedRequestsCheckbox2;
	static private boolean proxyOnly;
	private ScanSettings scanSettings;
	private FuzzVector fuzzVector;
	private TransactionComposite transactionComposite;
	private Fuzzer fuzzer;
	private boolean usePlatformErrors = true;
	private boolean exiting = false;
	
	public static final int SCAN_STATUS_TAB = 0;
	public static final int TRANSACTIONS_TAB = 1;
	public static final int MANUAL_REQUEST_TAB = 2;
	public static final int PROXY_SETTINGS_TAB = 3;
	public static final int INTERCEPTION_SETTINGS_TAB = 4;
	public static final int FUZZER_TAB = 5;
	
	
	{
		// Register as a resource user - SWTResourceManager will
		// handle the obtaining and disposing of resources
		SWTResourceManager.registerResourceUser(this);
	}

	public ScanStatusWindow(final Scan scan, org.eclipse.swt.widgets.Composite parent, int style)
	{
		super(parent, style);
		shell.addListener (SWT.Close, new Listener () 
		{
			public void handleEvent (Event event) 
			{
				event.doit = false;
				if (promptExit(shell, scan))
				{	
					exiting = true;
					scan.stopProxy();
					if (!proxyOnly && scan.getScanPhase() != ScanPhase.COMPLETE)
					{
						scan.terminateScan("");
					}
					synchronized(this)
					{
						while (scan.getScanPhase() != ScanPhase.COMPLETE)
						{
							try
                            {
	                            this.wait(100);
                            }
                            catch (InterruptedException e)
                            {
                            }
						}
					}
					event.doit = true;
				}
			}
		});

		fuzzFilters = new ArrayList<InterceptFilter>();
		this.scan = scan;
		this.scanSettings = scan.getScanSettings();
		proxyOnly = scanSettings.isProxyOnly();
		initGUI();
		scan.setScanStatusWindow(this);
		if (proxyOnly)
		{
			disableNonScanElements();
			this.allowAllProxyRequests.setEnabled(false);
			if (scan.getScanSettings().isLoadDatabase())
			{
				transactionTable.refreshTable();
			}
		}
		else
		{
			Debug.setScanStatusWindow(this);
			updateQueueText();
		}
	}
	
	/**
	 * Auto-generated method to display this org.eclipse.swt.widgets.Composite
	 * inside a new Shell.
	 */
	public static void showGUI(final Scan scan)
	{
		Display display = Display.getDefault();
		shell = new Shell(display);
		ScanStatusWindow scanStatusWindow = new ScanStatusWindow(scan, shell, SWT.NULL);
		Point size = scanStatusWindow.getSize();
		shell.setText(GrendelScan.versionText + " - Scan Status");
		shell.setLayout(new FillLayout());
		shell.layout();
		if ((size.x == 0) && (size.y == 0))
		{
			scanStatusWindow.pack();
			shell.pack();
		}
		else
		{
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		if (scan.getScanSettings().isProxyOnly())
		{
			scan.startProxyOnly();
		}
		else
		{
			scan.startScan();
		}
		
		while (!closed && !shell.isDisposed())
		{
			if (!closed && !display.isDisposed() && !display.readAndDispatch())
			{
				display.sleep();
			}
		}
	}
	
	private void updateQueueText()
	{
		if (!closed)
		{
			getDisplay().timerExec(250, new Runnable()
			{
				public void run()
				{
					try
					{
						if (scan.getRequesterQueue() != null)
						{
							transactionTable.setTransactionCount(AbstractHttpTransaction.getTotalExecutions());
							testerQueueSizeTextBox.setText(String.valueOf(scan.getTesterQueue().queueLength()));
							categorizerQueueSizeTextBox.setText(String.valueOf(scan.getCategorizerQueue().queueLength()));
							requesterQueueSizeTextBox.setText(String.valueOf(scan.getRequesterQueue().queueLength()));
						}
					}
					catch (Exception e) {}
					updateQueueText();
						
				}
			});
		}
	}
	
	public synchronized void appendStatusText(final String text)
	{
		if (!closed)
		{
			getDisplay().asyncExec(new Runnable()
			{
				public void run()
				{
					scanStatusTextArea.append(text);
					String newText = scanStatusTextArea.getText();
					if (newText.length() > maxStatusSize * 1.25)
					{
						int startPosition = newText.length() - maxStatusSize;
						scanStatusTextArea.setText(newText.substring(startPosition));
					}
				}
			});
		}
	}
	
	public void close()
	{
		closed = true;
		getDisplay().wake();
	}

	public void displayMessage(final String title, final String message)
	{
		displayMessage(title, message, true);
	}
	
	public void displayMessage(final String title, final String message, boolean wait)
	{
		if (!closed && !getDisplay().isDisposed())
		{
			Runnable r = new Runnable()
			{
				public void run()
				{
					MessageBox m = new MessageBox(getShell(), SWT.OK);
					m.setMessage(message);
					m.setText(title);
					m.open();
				}
			};
			if (wait)
			{
				getDisplay().syncExec(r);
			}
			else
			{
				getDisplay().asyncExec(r);
			}
		}
	}
	
	private void initGUI()
	{
		try
		{
			Image icon = new Image(getDisplay(), GrendelScan.defaultConfigDirectory + File.separator + "icon.JPG");
			this.getShell().setImage(icon);
			EnforceIntegersOnly integersOnlyVerifyer = new EnforceIntegersOnly();
			FormLayout thisLayout = new FormLayout();
			this.setLayout(thisLayout);
			this.setSize(829, 706);
			{
				{
					pauseScanButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData pauseScanButtonLData = new FormData();
					pauseScanButtonLData.width = 101;
					pauseScanButtonLData.height = 27;
					pauseScanButtonLData.left =  new FormAttachment(0, 1000, 229);
					pauseScanButtonLData.bottom =  new FormAttachment(1000, 1000, -12);
					pauseScanButton.setLayoutData(pauseScanButtonLData);
					pauseScanButton.setText("Pause Scan");
					pauseScanButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
					pauseScanButton.addSelectionListener(new SelectionAdapter()
					{
						@Override
						public void widgetSelected(SelectionEvent event)
						{
							if (scan.isPaused())
							{
								pauseScanButton.setText("Pause Scan");
								scan.setPaused(false);
							}
							else
							{
								pauseScanButton.setText("Resume Scan");
								scan.setPaused(true);
							}
						}
					});
				}
				{
					helpButton = new Button(this, SWT.PUSH | SWT.CENTER);
					helpButton.setText("Help");
					FormData helpButtonLData = new FormData();
					helpButtonLData.width = 86;
					helpButtonLData.height = 27;
					helpButtonLData.left =  new FormAttachment(0, 1000, 12);
					helpButtonLData.bottom =  new FormAttachment(1000, 1000, -12);
					helpButton.setLayoutData(helpButtonLData);
					helpButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
					helpButton.addSelectionListener(new SelectionAdapter() 
					{
						public void widgetSelected(SelectionEvent event) 
						{
							showHelp("");
						}
					});
				}
				{
					terminateScanButton = new Button(this, SWT.PUSH | SWT.CENTER);
					terminateScanButton.setText("Terminate Scan");
					FormData terminateScanButtonLData = new FormData();
					terminateScanButtonLData.width = 107;
					terminateScanButtonLData.height = 27;
					terminateScanButtonLData.left =  new FormAttachment(0, 1000, 110);
					terminateScanButtonLData.bottom =  new FormAttachment(1000, 1000, -12);
					terminateScanButton.setLayoutData(terminateScanButtonLData);
					terminateScanButton.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
					terminateScanButton.addSelectionListener(new SelectionAdapter()
					{
						@Override
						public void widgetSelected(SelectionEvent event)
						{
							if (promptTerminate())
							{	
								terminateScanButton.setEnabled(false);
								scan.terminateScan("");
							}
						}
					});
				}

				
				
				scanTabs = new TabFolder(this, SWT.NONE);
/**
 * 
 * 
 * SCAN STATUS TAB
 * 
 * 
 */				
				{
					scanStatusTab = new TabItem(scanTabs, SWT.NONE);
				    scanStatusTab.setText("Status");

					Composite scanStatusComposite = new Composite(scanTabs, SWT.NONE);
					FormLayout scanStatusTabLayout = new FormLayout();
					scanStatusComposite.setLayout(scanStatusTabLayout);
					scanStatusTab.setControl(scanStatusComposite);
					if (!proxyOnly)
					{
						queueSizeGroup = new Group(scanStatusComposite, SWT.NONE);
						queueSizeGroup.setLayout(null);
						FormData queueSizeGroupLData = new FormData();
						queueSizeGroupLData.width = 471;
						queueSizeGroupLData.height = 51;
						queueSizeGroupLData.left =  new FormAttachment(0, 1000, 5);
						queueSizeGroupLData.bottom =  new FormAttachment(1000, 1000, -5);
						queueSizeGroup.setLayoutData(queueSizeGroupLData);
						queueSizeGroup.setText("Queue Sizes");
						queueSizeGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
						{
							testerQueueSizeTextBox = new Text(queueSizeGroup, SWT.READ_ONLY | SWT.BORDER);
							testerQueueSizeTextBox.setBounds(73, 31, 75, 25);
							testerQueueSizeTextBox.setBackground(SWTResourceManager.getColor(255, 255, 255));
							testerQueueSizeTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
						}
						{
							testQueueLabel = new Label(queueSizeGroup, SWT.NONE);
							testQueueLabel.setText("Tester:");
							testQueueLabel.setBounds(14, 31, 51, 25);
							testQueueLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
						}
						{
							categorizerQueueSizeTextBox = new Text(queueSizeGroup, SWT.READ_ONLY | SWT.BORDER);
							categorizerQueueSizeTextBox.setBounds(247, 31, 55, 25);
							categorizerQueueSizeTextBox.setBackground(SWTResourceManager.getColor(255, 255, 255));
							categorizerQueueSizeTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
						}
						{
							requesterQueueSizeTextBox = new Text(queueSizeGroup, SWT.READ_ONLY | SWT.BORDER);
							requesterQueueSizeTextBox.setBounds(398, 31, 55, 25);
							requesterQueueSizeTextBox.setBackground(SWTResourceManager.getColor(255, 255, 255));
							requesterQueueSizeTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
						}
						{
							requesterQueueLabel = new Label(queueSizeGroup, SWT.NONE);
							requesterQueueLabel.setText("Categorizer:");
							requesterQueueLabel.setBounds(160, 31, 73, 25);
							requesterQueueLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
						}
						{
							categorizerQueueLabel = new Label(queueSizeGroup, SWT.NONE);
							categorizerQueueLabel.setText("Requester:");
							categorizerQueueLabel.setBounds(314, 31, 81, 25);
							categorizerQueueLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
						}
					}
					{
						scanStatusTextArea =
						        new Text(scanStatusComposite, SWT.MULTI | SWT.READ_ONLY | SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER);
						FormData scanStatusTextAreaLData = new FormData();
						scanStatusTextAreaLData.width = 706;
						scanStatusTextAreaLData.height = 282;
						scanStatusTextAreaLData.left =  new FormAttachment(0, 1000, 13);
						scanStatusTextAreaLData.right =  new FormAttachment(1000, 1000, 0);
						scanStatusTextAreaLData.bottom =  new FormAttachment(1000, 1000, -80);
						scanStatusTextAreaLData.top =  new FormAttachment(0, 1000, 16);
						scanStatusTextArea.setLayoutData(scanStatusTextAreaLData);
						scanStatusTextArea.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
					}
				}
				
				
				
				
				
				
				
				
				
				
				

/**
 * 
 * 
 * TRANSACTIONS TAB
 * 
 * 
 */				
				
				{
					transactionsTab = new TabItem(scanTabs, SWT.NONE);
					transactionsTab.setText("Transactions");
					transactionTable = new TransactionTable(scanTabs, SWT.NONE, scan, this, true);
					transactionsTab.setControl(transactionTable);
				}

		
				
				
				
				
				
				
				
				
/**
 * 
 * 
 * MANUAL REQUEST TAB
 * 
 * 
 */				
				
				{
					manualRequestTab = new TabItem(scanTabs, SWT.NONE);
					manualRequestTab.setText("Manual Request");
					manualRequestComposite = new Composite(scanTabs, SWT.NONE);
					FormLayout manualRequestCompositeLayout = new FormLayout();
					manualRequestComposite.setLayout(manualRequestCompositeLayout);
					manualRequestTab.setControl(manualRequestComposite);
//					{
//						fixContentLengthCheckbox = new Button(manualRequestComposite, SWT.CHECK | SWT.LEFT);
//						FormData fixContentLengthCheckboxLData = new FormData();
//						fixContentLengthCheckboxLData.width = 136;
//						fixContentLengthCheckboxLData.height = 19;
//						fixContentLengthCheckboxLData.left =  new FormAttachment(0, 1000, 255);
//						fixContentLengthCheckboxLData.bottom =  new FormAttachment(1000, 1000, -21);
//						fixContentLengthCheckbox.setLayoutData(fixContentLengthCheckboxLData);
//						fixContentLengthCheckbox.setText("Fix content-length");
//					}
//					{
//						abortRequestButton = new Button(manualRequestComposite, SWT.PUSH | SWT.CENTER);
//						FormData abortRequestButtonLData = new FormData();
//						abortRequestButtonLData.width = 71;
//						abortRequestButtonLData.height = 27;
//						abortRequestButtonLData.left =  new FormAttachment(0, 1000, 93);
//						abortRequestButtonLData.bottom =  new FormAttachment(1000, 1000, -13);
//						abortRequestButton.setLayoutData(abortRequestButtonLData);
//						abortRequestButton.setText("Abort");
//					}
					{
						executeRequestButton = new Button(manualRequestComposite, SWT.PUSH | SWT.CENTER);
						FormData executeRequestButtonLData = new FormData();
						executeRequestButtonLData.width = 69;
						executeRequestButtonLData.height = 27;
						executeRequestButtonLData.left =  new FormAttachment(0, 1000, 12);
						executeRequestButtonLData.bottom =  new FormAttachment(1000, 1000, -10);
						executeRequestButton.setLayoutData(executeRequestButtonLData);
						executeRequestButton.setText("Execute");
						executeRequestButton.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								executeRequestButtonWidgetSelected(evt);
							}
						});
					}
					{
						testManualRequestsCheckbox = new Button(manualRequestComposite, SWT.CHECK | SWT.LEFT);
						FormData testManualRequestsCheckboxLData = new FormData();
						testManualRequestsCheckboxLData.width = 161;
						testManualRequestsCheckboxLData.height = 19;
						testManualRequestsCheckboxLData.left =  new FormAttachment(0, 1000, 99);
						testManualRequestsCheckboxLData.bottom =  new FormAttachment(1000, 1000, -13);
						testManualRequestsCheckbox.setLayoutData(testManualRequestsCheckboxLData);
						testManualRequestsCheckbox.setText("Test manual requests");
					}
					{
						FormData transactionCompositeLData = new FormData();
						transactionCompositeLData.width = 803;
						transactionCompositeLData.height = 619;
						transactionCompositeLData.left =  new FormAttachment(0, 1000, 0);
						transactionCompositeLData.top =  new FormAttachment(0, 1000, 0);
						transactionCompositeLData.bottom =  new FormAttachment(1000, 1000, -60);
						transactionCompositeLData.right =  new FormAttachment(1000, 1000, 0);
						transactionComposite = new TransactionComposite(manualRequestComposite, SWT.BORDER, true, false, true, false);
						transactionComposite.setLayoutData(transactionCompositeLData);
					}
				}

				
				
				
				
				
				
				
				
				
				
				

/**
 * 
 * 
 * PROXY SETTINGS TAB
 * 
 * 
 */				
				
				{
					proxySettingsTab = new TabItem(scanTabs, SWT.NONE);
					proxySettingsTab.setText("Proxy settings");
					interceptionSettingsComposite = new Composite(scanTabs, SWT.NONE);
					FormLayout proxySettingsCompositeLayout = new FormLayout();
					interceptionSettingsComposite.setLayout(proxySettingsCompositeLayout);
					proxySettingsTab.setControl(interceptionSettingsComposite);
					{
						revealHiddenFieldsButton = new Button(interceptionSettingsComposite, SWT.CHECK | SWT.LEFT);
						revealHiddenFieldsButton.setText("Reveal hidden HTML form fields");
						revealHiddenFieldsButton.setSelection(true);
						FormData revealHiddenFieldsButtonLData = new FormData();
						revealHiddenFieldsButtonLData.width = 246;
						revealHiddenFieldsButtonLData.height = 21;
						revealHiddenFieldsButtonLData.left =  new FormAttachment(0, 1000, 10);
						revealHiddenFieldsButtonLData.top =  new FormAttachment(0, 1000, 10);
						revealHiddenFieldsButton.setLayoutData(revealHiddenFieldsButtonLData);
						revealHiddenFieldsButton.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								revealHiddenFieldsButtonWidgetSelected(evt);
							}
						});
					}
					{
						testProxyRequestsCheckbox = new Button(interceptionSettingsComposite, SWT.CHECK | SWT.LEFT);
						testProxyRequestsCheckbox.setSelection(scanSettings.isTestProxyRequests());
						FormData testProxyRequestsCheckboxLData = new FormData();
						testProxyRequestsCheckboxLData.width = 149;
						testProxyRequestsCheckboxLData.height = 19;
						testProxyRequestsCheckboxLData.left =  new FormAttachment(0, 1000, 279);
						testProxyRequestsCheckboxLData.top =  new FormAttachment(0, 1000, 10);
						testProxyRequestsCheckbox.setLayoutData(testProxyRequestsCheckboxLData);
						testProxyRequestsCheckbox.setText("Test proxy requests");
						testProxyRequestsCheckbox.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								scanSettings.setTestProxyRequests(testProxyRequestsCheckbox.getSelection());
							}
						});
					}
					{
						allowAllProxyRequests = new Button(interceptionSettingsComposite, SWT.CHECK | SWT.LEFT);
						allowAllProxyRequests.setText("Allow all proxy requests");
						FormData allowAllProxyRequestsLData = new FormData();
						allowAllProxyRequestsLData.width = 240;
						allowAllProxyRequestsLData.height = 23;
						allowAllProxyRequestsLData.left =  new FormAttachment(0, 1000, 10);
						allowAllProxyRequestsLData.top =  new FormAttachment(0, 1000, 35);
						allowAllProxyRequests.setLayoutData(allowAllProxyRequestsLData);
						allowAllProxyRequests.setSelection(true);
						allowAllProxyRequests.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) {
								allowAllProxyRequestsWidgetSelected(evt);
							}
						});
					}
					{
						testIntecptedRequestsCheckbox = new Button(interceptionSettingsComposite, SWT.CHECK | SWT.LEFT);
						FormData testIntecptedRequestsCheckboxLData = new FormData();
						testIntecptedRequestsCheckboxLData.width = 186;
						testIntecptedRequestsCheckboxLData.height = 19;
						testIntecptedRequestsCheckboxLData.left =  new FormAttachment(0, 1000, 279);
						testIntecptedRequestsCheckboxLData.top =  new FormAttachment(0, 1000, 35);
						testIntecptedRequestsCheckbox.setLayoutData(testIntecptedRequestsCheckboxLData);
						testIntecptedRequestsCheckbox.setText("Test intercepted requests");
						testIntecptedRequestsCheckbox.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								scanSettings.setTestManualRequests(testIntecptedRequestsCheckbox.getSelection());
							}
						});
					}
					{
						waitOnProxyCheckbox = new Button(interceptionSettingsComposite, SWT.CHECK | SWT.LEFT);
						FormData waitOnProxyCheckboxLData = new FormData();
						waitOnProxyCheckboxLData.width = 197;
						waitOnProxyCheckboxLData.height = 19;
						waitOnProxyCheckboxLData.left =  new FormAttachment(0, 1000, 12);
						waitOnProxyCheckboxLData.top =  new FormAttachment(0, 1000, 61);
						waitOnProxyCheckbox.setLayoutData(waitOnProxyCheckboxLData);
						waitOnProxyCheckbox.setText("Wait on proxy to finish scan");
						waitOnProxyCheckbox.setSelection(scanSettings.isWaitOnProxy());
						waitOnProxyCheckbox.setToolTipText("When checked, the scan will not complete until the proxy is stopped.");
						waitOnProxyCheckbox.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								scanSettings.setWaitOnProxy(waitOnProxyCheckbox.getSelection());
							}
						});
					}
					{
						proxySettingsGroup = new Group(interceptionSettingsComposite, SWT.NONE);
						proxySettingsGroup.setText("Internal Proxy Settings");
						proxySettingsGroup.setFont(SWTResourceManager.getFont(GUIConstants.fontName,GUIConstants.fontSize,0,false,false));
						proxySettingsGroup.setToolTipText("The built-in proxy server allows you to guide \nthe scan by navigating the website from your\nbrowser, while it's pointed at the proxy. This is\nan alternative to the spidering modules.");
						FormData proxySettingsGroupLData = new FormData();
						proxySettingsGroupLData.width = 310;
						proxySettingsGroupLData.height = 143;
						proxySettingsGroupLData.left =  new FormAttachment(15, 1000, 0);
						proxySettingsGroupLData.right =  new FormAttachment(400, 1000, 0);
						proxySettingsGroupLData.top =  new FormAttachment(140, 1000, 0);
						proxySettingsGroupLData.bottom =  new FormAttachment(398, 1000, 0);
						proxySettingsGroup.setLayoutData(proxySettingsGroupLData);
						proxySettingsGroup.setLayout(null);
						{
							proxyBindAddressLabel = new Label(proxySettingsGroup, SWT.NONE);
							proxyBindAddressLabel.setText("Proxy bind address:");
							proxyBindAddressLabel.setBounds(12, 63, 153, 25);
							proxyBindAddressLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName,GUIConstants.fontSize,0,false,false));
						}
						{
							proxyBindAddressTextBox = new Text(proxySettingsGroup, SWT.BORDER);
							proxyBindAddressTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName,GUIConstants.fontSize,0,false,false));
							proxyBindAddressTextBox.setBounds(171, 63, 125, 25);
							proxyBindAddressTextBox.setText(scanSettings.getProxyIPAddress());
							proxyBindAddressTextBox.setToolTipText("this is a test");
						}
						{
							proxyBindPortLabel = new Label(proxySettingsGroup, SWT.NONE);
							proxyBindPortLabel.setText("Proxy bind port:");
							proxyBindPortLabel.setBounds(12, 94, 135, 25);
							proxyBindPortLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName,GUIConstants.fontSize,0,false,false));
						}
						{
							proxyBindPortTextBox = new Text(proxySettingsGroup, SWT.BORDER);
							proxyBindPortTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName,GUIConstants.fontSize,0,false,false));
							proxyBindPortTextBox.setBounds(171, 94, 50, 25);
							proxyBindPortTextBox.setText(String.valueOf(scanSettings.getProxyPort()));
							proxyBindPortTextBox.addVerifyListener(integersOnlyVerifyer);
						}
						{
							maxProxyThreadLabel = new Label(proxySettingsGroup, SWT.NONE);
							maxProxyThreadLabel.setText("Max proxy threads:");
							maxProxyThreadLabel.setBounds(12, 125, 153, 25);
							maxProxyThreadLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName,GUIConstants.fontSize,0,false,false));
						}
						{
							maxProxyThreadTextBox = new Text(proxySettingsGroup, SWT.BORDER);
							maxProxyThreadTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName,GUIConstants.fontSize,0,false,false));
							maxProxyThreadTextBox.setTextLimit(2);
							maxProxyThreadTextBox.setText(String.valueOf(scanSettings.getMaxProxyThreads()));
							maxProxyThreadTextBox.setBounds(171, 125, 33, 25);
							maxProxyThreadTextBox.addVerifyListener(integersOnlyVerifyer);
						}
						{
							startProxyButton = new Button(proxySettingsGroup, SWT.PUSH | SWT.CENTER);
							startProxyButton.setBounds(12, 25, 60, 26);
							startProxyButton.setEnabled(false);
							startProxyButton.setText("Start");
							startProxyButton.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent evt) 
								{
									commitProxySettings();
									if ((Boolean) startProxyButton.getData(PROXY_START))
									{
										scan.startProxy();
									}
									else
									{
										scan.stopProxy();
									}
									updateProxyStatus();
								}
							});
						}
						{
							restartProxyButton = new Button(proxySettingsGroup, SWT.PUSH | SWT.CENTER);
							restartProxyButton.setText("Restart");
							restartProxyButton.setBounds(81, 25, 60, 26);
							restartProxyButton.setEnabled(false);
							restartProxyButton.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent evt) 
								{
									commitProxySettings();
									scan.restartProxy();
									updateProxyStatus();
								}
							});
						}
					}
				}

		
				
				
				
				
				
				
				
				
				
				

				
				
				
				
				
/**
 * 
 * 
 * INTERCEPTION SETTINGS TAB
 * 
 * 
 */				

				{
					intecreptionSettingsTab = new TabItem(scanTabs, SWT.NONE);
					intecreptionSettingsTab.setText("Interception settings");
					interceptionSettingsComposite = new Composite(scanTabs, SWT.NONE);
					FormLayout proxySettingsCompositeLayout = new FormLayout();
					interceptionSettingsComposite.setLayout(proxySettingsCompositeLayout);
					intecreptionSettingsTab.setControl(interceptionSettingsComposite);
					{
						testIntecptedRequestsCheckbox2 = new Button(interceptionSettingsComposite, SWT.CHECK | SWT.LEFT);
						FormData testIntecptedRequestsCheckboxLData = new FormData();
						testIntecptedRequestsCheckboxLData.width = 186;
						testIntecptedRequestsCheckboxLData.height = 19;
						testIntecptedRequestsCheckboxLData.left =  new FormAttachment(0, 1000, 10);
						testIntecptedRequestsCheckboxLData.top =  new FormAttachment(0, 1000, 10);
						testIntecptedRequestsCheckbox2.setLayoutData(testIntecptedRequestsCheckboxLData);
						testIntecptedRequestsCheckbox2.setText("Test intercepted requests");
						testIntecptedRequestsCheckbox2.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								testIntecptedRequestsCheckbox.setSelection(testIntecptedRequestsCheckbox2.getSelection());
								scanSettings.setTestInterceptedRequests(testIntecptedRequestsCheckbox2.getSelection());
							}
						});
					}
					{
						requestInterceptionGroup = new Group(interceptionSettingsComposite, SWT.NONE);
						FormLayout requestInterceptionGroupLayout = new FormLayout();
						requestInterceptionGroup.setLayout(requestInterceptionGroupLayout);
						FormData requestInterceptionGroupLData = new FormData();
						requestInterceptionGroupLData.width = 791;
						requestInterceptionGroupLData.height = 214;
						requestInterceptionGroupLData.left =  new FormAttachment(0, 1000, 5);
						requestInterceptionGroupLData.top =  new FormAttachment(0, 1000, 35);
						requestInterceptionGroupLData.right =  new FormAttachment(1000, 1000, -5);
						requestInterceptionGroupLData.bottom =  new FormAttachment(530, 1000, 0);
						requestInterceptionGroup.setLayoutData(requestInterceptionGroupLData);
						requestInterceptionGroup.setText("Request Interception");
						{
							enableInterceptRequestCheck = new Button(requestInterceptionGroup, SWT.CHECK | SWT.LEFT);
							FormData enableRequestCheckLData = new FormData();
							enableRequestCheckLData.width = 198;
							enableRequestCheckLData.height = 19;
							enableRequestCheckLData.left =  new FormAttachment(0, 1000, 5);
							enableRequestCheckLData.top =  new FormAttachment(0, 1000, 5);
							enableInterceptRequestCheck.setLayoutData(enableRequestCheckLData);
							enableInterceptRequestCheck.setText("Enable request interception");
							enableInterceptRequestCheck.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent evt) 
								{
									updateInterceptRequestComposite(enableInterceptRequestCheck.getSelection());
								}
							});
						}
						{
							FormData requestInterceptFiltersLData = new FormData();
							requestInterceptFiltersLData.width = 767;
							requestInterceptFiltersLData.height = 145;
							requestInterceptFiltersLData.left =  new FormAttachment(0, 1000, 0);
							requestInterceptFiltersLData.top =  new FormAttachment(0, 1000, 30);
							requestInterceptFiltersLData.right =  new FormAttachment(1000, 1000, 0);
							requestInterceptFiltersLData.bottom =  new FormAttachment(1000, 1000, 0);
							requestInterceptFilters = new InterceptionSettingsComposite(
									requestInterceptionGroup, SWT.NONE, InterceptFilterLocation.getRequestLocations(), 
									scanSettings.getRequestInterceptFilters()); 
							requestInterceptFilters.setLayoutData(requestInterceptFiltersLData);
							requestInterceptFilters.setEnabled(false);
							requestInterceptFilters.addFilter(InterceptFilterLocation.METHOD, "GET|POST", true, true);
							requestInterceptFilters.addFilter(InterceptFilterLocation.PATH, 
									"\\.(?:bmp|jpe?g|gif|tiff?|png|swf|mpe?g|mov|avi|wmv|mp3|wma|wav|docx?|xlsx?|mdb|rtf|pptx?|pdf)$", true, false);
							requestInterceptFilters.addFilter(InterceptFilterLocation.PATH, "\\.(?:css|js|vbs)$", true, false);
							
						}
					}
					{
						responseInterceptionGroup = new Group(interceptionSettingsComposite, SWT.NONE);
						FormLayout requestInterceptionGroupLayout = new FormLayout();
						responseInterceptionGroup.setLayout(requestInterceptionGroupLayout);
						FormData responseInterceptionGroupLData = new FormData();
						responseInterceptionGroupLData.width = 805;
						responseInterceptionGroupLData.height = 214;
						responseInterceptionGroupLData.left =  new FormAttachment(0, 1000, 5);
						responseInterceptionGroupLData.top =  new FormAttachment(540, 1000, 0);
						responseInterceptionGroupLData.right =  new FormAttachment(1000, 1000, -5);
						responseInterceptionGroupLData.bottom =  new FormAttachment(1000, 1000, -5);
						responseInterceptionGroup.setLayoutData(responseInterceptionGroupLData);
						responseInterceptionGroup.setText("Response Interception");
						{
							enableInterceptResponseCheck = new Button(responseInterceptionGroup, SWT.CHECK | SWT.LEFT);
							FormData enableResponseCheckLData = new FormData();
							enableResponseCheckLData.width = 215;
							enableResponseCheckLData.height = 19;
							enableResponseCheckLData.left =  new FormAttachment(0, 1000, 5);
							enableResponseCheckLData.top =  new FormAttachment(0, 1000, 5);
							enableInterceptResponseCheck.setLayoutData(enableResponseCheckLData);
							enableInterceptResponseCheck.setText("Enable response interception");
							enableInterceptResponseCheck.addSelectionListener(new SelectionAdapter() {
								public void widgetSelected(SelectionEvent evt) 
								{
									updateInterceptResponseComposite(enableInterceptResponseCheck.getSelection());
								}
							});
						}
						{
							FormData responseInterceptFiltersLData = new FormData();
							responseInterceptFiltersLData.width = 767;
							responseInterceptFiltersLData.height = 145;
							responseInterceptFiltersLData.left =  new FormAttachment(0, 1000, 0);
							responseInterceptFiltersLData.top =  new FormAttachment(0, 1000, 30);
							responseInterceptFiltersLData.right =  new FormAttachment(1000, 1000, 0);
							responseInterceptFiltersLData.bottom =  new FormAttachment(1000, 1000, 0);
							responseInterceptFilters = new InterceptionSettingsComposite(
									responseInterceptionGroup, SWT.NONE, InterceptFilterLocation.getAllLocations(), 
									scanSettings.getResponseInterceptFilters()); 
							responseInterceptFilters.setLayoutData(responseInterceptFiltersLData);
							responseInterceptFilters.setEnabled(false);
							responseInterceptFilters.addFilter(InterceptFilterLocation.RESPONSE_MIME_TYPE, "text/.*", true, true);
						}
					}
				
				}
				


				
				
				
				
				
				
				
				
/**
 * 
 * 
 * FUZZER TAB
 * 
 * 
 */				
				
				{
					fuzzerTab = new TabItem(scanTabs, SWT.NONE);
					fuzzerTab.setText("Fuzzer");
					Composite fuzzerTabComposite = new Composite(scanTabs, SWT.NONE);
					FormLayout fuzzerTabCompositeLayout = new FormLayout();
					fuzzerTabComposite.setLayout(fuzzerTabCompositeLayout);
					fuzzerTab.setControl(fuzzerTabComposite);
					{
						fuzzTemplateButton = new Button(fuzzerTabComposite, SWT.PUSH | SWT.CENTER);
						fuzzTemplateButton.setText("Fuzz Template");
						FormData fuzzTemplateButtonLData = new FormData();
						fuzzTemplateButtonLData.width = 111;
						fuzzTemplateButtonLData.height = 27;
						fuzzTemplateButtonLData.top =  new FormAttachment(0, 1000, 11);
						fuzzTemplateButtonLData.left =  new FormAttachment(0, 1000, 12);
						fuzzTemplateButton.setLayoutData(fuzzTemplateButtonLData);
						fuzzTemplateButton.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								FuzzTemplateComposite.getFuzzTemplate(getShell());
							}
						});
					}
					{
						fuzzVectorButton = new Button(fuzzerTabComposite, SWT.PUSH | SWT.CENTER);
						fuzzVectorButton.setText("Fuzz Vector");
						FormData fuzzVectorButtonLData = new FormData();
						fuzzVectorButtonLData.width = 111;
						fuzzVectorButtonLData.height = 27;
						fuzzVectorButtonLData.top =  new FormAttachment(0, 1000, 11);
						fuzzVectorButtonLData.left =  new FormAttachment(0, 1000, 149);
						fuzzVectorButton.setLayoutData(fuzzVectorButtonLData);
						fuzzVectorButton.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								fuzzVector = FuzzVectorChoiceDialog.getFuzzVector(getShell(), fuzzVector);
							}
						});
					}
					{
						fuzzCriteriaButton = new Button(fuzzerTabComposite, SWT.PUSH | SWT.CENTER);
						fuzzCriteriaButton.setText("Fuzz Criteria");
						FormData fuzzCriteriaButtonLData = new FormData();
						fuzzCriteriaButtonLData.width = 110;
						fuzzCriteriaButtonLData.height = 27;
						fuzzCriteriaButtonLData.top =  new FormAttachment(0, 1000, 11);
						fuzzCriteriaButtonLData.left =  new FormAttachment(0, 1000, 288);
						fuzzCriteriaButton.setLayoutData(fuzzCriteriaButtonLData);
						fuzzCriteriaButton.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								usePlatformErrors = FuzzCriteriaDialog.showGUI(getShell(), fuzzFilters, usePlatformErrors);
							}
						});
					}
					{
						maxFuzzRequestsLabel = new Label(fuzzerTabComposite, SWT.NONE);
						FormData maxFuzzRequestsLData = new FormData();
						maxFuzzRequestsLData.width = 158;
						maxFuzzRequestsLData.height = 17;
						maxFuzzRequestsLData.left =  new FormAttachment(0, 1000, 12);
						maxFuzzRequestsLData.top =  new FormAttachment(0, 1000, 54);
						maxFuzzRequestsLabel.setLayoutData(maxFuzzRequestsLData);
						maxFuzzRequestsLabel.setText("Max requests per vector:");
					}
					{
						maxFuzzRequestsTextbox = new Text(fuzzerTabComposite, SWT.BORDER);
						FormData text1LData = new FormData();
						text1LData.width = 54;
						text1LData.height = 19;
						text1LData.left =  new FormAttachment(0, 1000, 176);
						text1LData.top =  new FormAttachment(0, 1000, 50);
						maxFuzzRequestsTextbox.setLayoutData(text1LData);
						maxFuzzRequestsTextbox.setText("0");
						maxFuzzRequestsTextbox.addVerifyListener(integersOnlyVerifyer);
					}
					{
						startFuzzButton = new Button(fuzzerTabComposite, SWT.PUSH | SWT.CENTER);
						FormData startFuzzButtonLData = new FormData();
						startFuzzButtonLData.width = 67;
						startFuzzButtonLData.height = 27;
						startFuzzButtonLData.left =  new FormAttachment(0, 1000, 260);
						startFuzzButtonLData.top =  new FormAttachment(0, 1000, 52);
						startFuzzButton.setLayoutData(startFuzzButtonLData);
						startFuzzButton.setText(START);
						startFuzzButton.addSelectionListener(new SelectionAdapter() 
						{
							public void widgetSelected(SelectionEvent evt) 
							{
								if (startFuzzButton.getText().equals(START))
								{
									startFuzzer();
								}
								else if (startFuzzButton.getText().equals(PAUSE))
								{
									fuzzer.setPaused(true);
									startFuzzButton.setText(RESUME);
								}
								else if (startFuzzButton.getText().equals(RESUME))
								{
									fuzzer.setPaused(false);
									startFuzzButton.setText(PAUSE);
								}
							}
						});
					}
					{
						stopFuzzButton = new Button(fuzzerTabComposite, SWT.PUSH | SWT.CENTER);
						FormData stopFuzzButtonLData = new FormData();
						stopFuzzButtonLData.width = 55;
						stopFuzzButtonLData.height = 27;
						stopFuzzButtonLData.left =  new FormAttachment(0, 1000, 333);
						stopFuzzButtonLData.top =  new FormAttachment(0, 1000, 52);
						stopFuzzButton.setLayoutData(stopFuzzButtonLData);
						stopFuzzButton.setEnabled(false);
						stopFuzzButton.setText("Stop");
						stopFuzzButton.addSelectionListener(new SelectionAdapter() {
							public void widgetSelected(SelectionEvent evt) 
							{
								if (fuzzer != null)
								{
									fuzzer.stop();
								}
							}
						});
					}
					{
						clearTableButton = new Button(fuzzerTabComposite, SWT.PUSH | SWT.CENTER);
						FormData clearTableButtonLData = new FormData();
						clearTableButtonLData.width = 85;
						clearTableButtonLData.height = 27;
						clearTableButtonLData.left =  new FormAttachment(0, 1000, 394);
						clearTableButtonLData.top =  new FormAttachment(0, 1000, 52);
						clearTableButton.setLayoutData(clearTableButtonLData);
						clearTableButton.setText("Clear Table");
						clearTableButton.addSelectionListener(new SelectionAdapter() 
						{
							public void widgetSelected(SelectionEvent evt) 
							{
								fuzzResultsTable.clearTable();
							}
						});
					}
					{
						fuzzResultsTable = new TransactionTable(fuzzerTabComposite, SWT.NONE, scan, this, false);
						FormData fuzzResultsTableLData = new FormData();
						fuzzResultsTableLData.width = 805;
						fuzzResultsTableLData.height = 511;
						fuzzResultsTableLData.right =  new FormAttachment(1000, 1000, -5);
						fuzzResultsTableLData.bottom =  new FormAttachment(1000, 1000, -5);
						fuzzResultsTableLData.left =  new FormAttachment(0, 1000, 5);
						fuzzResultsTableLData.top =  new FormAttachment(0, 1000, 92);
						fuzzResultsTable.setLayoutData(fuzzResultsTableLData);
					}
				}
								
				
				
				
				
				
				
				
				
				FormData scanTabsLData = new FormData();
				scanTabsLData.width = 821;
				scanTabsLData.height = 628;
				scanTabsLData.left =  new FormAttachment(0, 1000, 0);
				scanTabsLData.right =  new FormAttachment(1000, 1000, 0);
				scanTabsLData.top =  new FormAttachment(0, 1000, 0);
				scanTabsLData.bottom =  new FormAttachment(1000, 1000, -48);
				scanTabs.setLayoutData(scanTabsLData);
								
								

			}
		}
		catch (Exception e) 
		{
			Debug.errDebug(e.toString());
		}
	}
	
	
	
	public TransactionTable getFuzzResultsTable()
    {
    	return fuzzResultsTable;
    }

	private void showHelp(String selectedSection)
	{
		if (selectedSection == null || selectedSection.equals(""))
		{
			selectedSection = scanTabs.getSelection()[0].getText();
		}
		if (scanStatusHelpText == null)
		{
			String path = ConfigurationManager.getString("help.directory");
			scanStatusHelpText = getHelpText(path, "help.scan_status_help");
			transactionsHelpText = getHelpText(path, "help.transactions_help");
			manualRequestHelpText = getHelpText(path, "help.manual_request_help");
			proxySettingsHelpText = getHelpText(path, "help.proxy_settings_help");
			interceptionSettingsHelpText = getHelpText(path, "help.interceptions_settings_help");
			fuzzerHelpText = getHelpText(path, "help.fuzzer_help");	
		}
		HelpViewer viewer = new HelpViewer(Display.getCurrent());
		viewer.addHelpSection(scanStatusTab.getText(), scanStatusHelpText);
		viewer.addHelpSection(transactionsTab.getText(), transactionsHelpText);
		viewer.addHelpSection(manualRequestTab.getText(), manualRequestHelpText);
		viewer.addHelpSection(proxySettingsTab.getText(), proxySettingsHelpText);
		viewer.addHelpSection(intecreptionSettingsTab.getText(), interceptionSettingsHelpText);
		viewer.addHelpSection(fuzzerTab.getText(), fuzzerHelpText);
		viewer.setFirstSelectionName(selectedSection);
        viewer.showGUI();
	}
	
	private String getHelpText(String path, String name)
	{
		String fileName = ConfigurationManager.getString(name);
		return FileUtils.readFile(path + File.separator + fileName);
	}

	private void executeRequestButtonWidgetSelected(SelectionEvent evt) 
	{
		try
        {
	        AbstractHttpTransaction transaction = new UnvalidatedHttpTransaction(scan, 0, TransactionSource.MANUAL_REQUEST, transactionComposite.getRequestBody(), transactionComposite.makeHttpRequest(scan));
	        transaction.execute("Manual request", scanSettings.isTestManualRequests());
	        if (transaction.isSuccessfullExecution())
	        {
	        	transactionComposite.updateResponseData(transaction.getResponseWrapper().toString().getBytes());
	        }
        }
        catch (HttpFormatException e)
        {
	        MessageBox m = new MessageBox(getShell(), SWT.OK | SWT.WRAP);
	        m.setText("Invalid request format");
	        m.setMessage("The format of the HTTP request is invalid. Future versions of Grendel-Scan will support " +
	        		"arbitrary request formats. For now, please use a format that resembles RFC 2616.\n" +
	        		"\n" +
	        		"The error message was: " + e.toString());
	        m.open();
        }
	}
	
	public void displayTransactionInManualRequest(int transactionID)
	{
		AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(transactionID);
		transactionComposite.clearResponseData();
		
		transactionComposite.updateRequestData(transaction.requestToString());
	}
	
	private void allowAllProxyRequestsWidgetSelected(SelectionEvent evt) 
	{
		scanSettings.setAllowAllProxyRequests(allowAllProxyRequests.getSelection());
		
	}

	private void revealHiddenFieldsButtonWidgetSelected(SelectionEvent evt) 
	{
		scanSettings.setRevealHiddenFields(revealHiddenFieldsButton.getSelection());
	}

//	private class YesNoPrompt implements Runnable
//	{
//		boolean result;
//		boolean done = false;
//		String title;
//		String message;
//		public void run()
//		{
//			MessageBox m = new MessageBox(getShell(), SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);
//			m.setMessage(message);
//			m.setText(title);
//			result =  m.open() == SWT.YES;
//		}
//	}

	
	public boolean promptTerminate()
	{
		return yesNoPrompt("Terminate scan?", "Are you sure you want to terminate the scan?\nThe report will still be generated.");
	}

	static public boolean promptExit(Shell shell, Scan scan)
	{
		String message;
		String title;
		if (scan.getScanPhase() == ScanPhase.COMPLETE)
		{
			title = "Exit?";
			message = "Are you sure you want to exit?";
		}
		else
		{
			title = "Terminate scan and exit?";
			message = "Are you sure you want to terminate the scan and exit?\nThe report will still be generated, which will cause a\nsmall delay.";
		}
		MessageBox m = new MessageBox(shell, SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);
		m.setMessage(message);
		m.setText(title);
		return m.open() == SWT.YES;
	}

	public boolean yesNoPrompt(String title, String message) throws IllegalStateException
	{
//		YesNoPrompt data = new YesNoPrompt();
//		data.title = title;
//		data.message = message;
		boolean result = true;
		if (!closed)
		{
			MessageBox m = new MessageBox(getShell(), SWT.APPLICATION_MODAL | SWT.YES | SWT.NO);
			m.setMessage(message);
			m.setText(title);
			result =  m.open() == SWT.YES;
		}
		
//		if (!data.done)
//		{
//			throw new IllegalStateException("Message box failed to process correctly.");
//		}
		return result;
	}


	public void changeEnableInterceptRequestCheck(boolean enabled)
    {
		updateInterceptRequestComposite(enabled);
		enableInterceptRequestCheck.setSelection(enabled);
    }

	private void updateInterceptRequestComposite(boolean enabled)
	{
		scanSettings.setInterceptRequests(enabled);
		requestInterceptFilters.setEnabled(enabled);
	}
	
	public void changeEnableInterceptResponseCheck(boolean enabled)
    {
		enableInterceptResponseCheck.setSelection(enabled);
		updateInterceptResponseComposite(enabled);
	}

	private void updateInterceptResponseComposite(boolean enabled)
	{
		scanSettings.setInterceptResponses(enabled);
		responseInterceptFilters.setEnabled(enabled);
	}

	public void updateProxyStatus()
	{
		if (!closed)
		{
			getDisplay().syncExec(new Runnable()
			{
				public void run()
				{
					startProxyButton.setEnabled(true);
					restartProxyButton.setEnabled(true);
					boolean start = !scan.getProxy().isRunning();
					startProxyButton.setText(start ? "Start" : "Stop");
					startProxyButton.setData(PROXY_START, start);
				}
			});
		}
	}

	private static final String PROXY_START = "start"; 
	
	private void commitProxySettings()
	{
		scanSettings.setProxyPort(Integer.valueOf(proxyBindPortTextBox.getText()));
		scanSettings.setMaxProxyThreads(Integer.valueOf(maxProxyThreadTextBox.getText()));
		scanSettings.setProxyIPAddress(proxyBindAddressTextBox.getText());
	}

	public void scanComplete()
	{
		if (!exiting)
		{
			displayMessage("Notice:", "The scan is complete.");
			getDisplay().syncExec(new Runnable()
			{
				public void run()
				{
					disableNonScanElements();
				}
			});
		}
	}
	
	private void disableNonScanElements()
	{
		terminateScanButton.setEnabled(false);
		terminateScanButton.setVisible(false);
		testProxyRequestsCheckbox.setEnabled(false);
		testIntecptedRequestsCheckbox.setEnabled(false);
		testIntecptedRequestsCheckbox2.setEnabled(false);
		waitOnProxyCheckbox.setEnabled(false);
		pauseScanButton.setEnabled(false);
		pauseScanButton.setVisible(false);
		testManualRequestsCheckbox.setEnabled(false);
	}
	
	private void startFuzzer()
	{
		String message = "";
		if (fuzzVector == null)
		{
			message += "Please define a fuzz vector.\n";
		}
		if (FuzzTemplateComposite.fuzzTemplateText == null || FuzzTemplateComposite.fuzzTemplateText.equals(""))
		{
			message += "Please define a fuzz template.";
		}
		if (message.length() > 0)
		{
			MessageBox m = new MessageBox(getShell(), SWT.OK);
			m.setText("Error");
			m.setMessage(message);
			m.open();
		}
		else
		{
			fuzzer = new Fuzzer(fuzzVector, Integer.valueOf(maxFuzzRequestsTextbox.getText()), 
					scan, FuzzTemplateComposite.fuzzTemplateText, fuzzFilters, usePlatformErrors);
			fuzzer.start();
			startFuzzButton.setText(PAUSE);
			stopFuzzButton.setEnabled(true);
		}
	}
	final private static String PAUSE = "Pause";
	final private static String RESUME = "Resume";
	final private static String START = "Start";
	
	public void fuzzDone()
	{
		getDisplay().syncExec(new Runnable()
		{
			public void run()
			{
				startFuzzButton.setText(START);
				stopFuzzButton.setEnabled(false);
			}
		});
	}

	public TabFolder getScanTabs()
    {
    	return scanTabs;
    }

	public boolean isExiting()
    {
    	return exiting;
    }
}
