package com.grendelscan.GUI.fuzzing;

import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import java.util.*;

import com.grendelscan.GrendelScan;
import com.grendelscan.GUI.http.interception.*;


/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class FuzzCriteriaDialog extends org.eclipse.swt.widgets.Dialog {
	private Shell dialogShell;
	private Button platformErrorCheckbox;
	private InterceptionSettingsComposite filterComposite;
	private Button closeButton;
	private final List<InterceptFilter> filters;
	private boolean usePlatformErrors;

	/**
	 * 
	 * @param filters
	 * @return True if checks for platform error messages
	 */
	public static boolean showGUI(Shell parent, final List<InterceptFilter> filters, final boolean usePlatformErrors) 
	{
		FuzzCriteriaDialog inst = new FuzzCriteriaDialog(parent, SWT.NULL, filters, usePlatformErrors);
		return inst.usePlatformErrors;
	}

	private FuzzCriteriaDialog(Shell parent, int style, final List<InterceptFilter> filters, boolean usePlatformErrors) 
	{
		super(parent, style);
		this.usePlatformErrors = usePlatformErrors;
		this.filters = filters;
		initGUI();
	}

	private void initGUI() {
		try {
			dialogShell = new Shell(getParent(), SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL | SWT.RESIZE );
			dialogShell.setText(GrendelScan.versionText + " - Fuzz Criteria");
			FillLayout dialogShellLayout = new FillLayout(org.eclipse.swt.SWT.HORIZONTAL);
			dialogShell.setLayout(dialogShellLayout);
			dialogShell.setSize(931,291);
			Composite dialogComposite = new Composite(dialogShell, SWT.NONE);
			dialogComposite.setLayout(new FormLayout());
			dialogComposite.setSize(931, 291);
			{
				closeButton = new Button(dialogComposite, SWT.PUSH | SWT.CENTER);
				FormData closeButtonLData = new FormData();
				closeButtonLData.width = 61;
				closeButtonLData.height = 27;
				closeButtonLData.left =  new FormAttachment(0, 1000, 5);
				closeButtonLData.bottom =  new FormAttachment(1000, 1000, -5);
				closeButton.setLayoutData(closeButtonLData);
				closeButton.setText("Close");
				closeButton.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) 
					{
						dialogShell.dispose();
					}
				});
			}
			{
				platformErrorCheckbox = new Button(dialogComposite, SWT.CHECK | SWT.LEFT);
				FormData platformErrorCheckboxLData = new FormData();
				platformErrorCheckbox.setSelection(usePlatformErrors);
				platformErrorCheckboxLData.width = 271;
				platformErrorCheckboxLData.height = 19;
				platformErrorCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				platformErrorCheckboxLData.top =  new FormAttachment(0, 1000, 5);
				platformErrorCheckbox.setLayoutData(platformErrorCheckboxLData);
				platformErrorCheckbox.setText("Check against platform error messages");
				platformErrorCheckbox.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) 
					{
						usePlatformErrors = platformErrorCheckbox.getSelection();
					}
				});
			}
			{
				FormData filterCompositeLData = new FormData();
				filterCompositeLData.width = 906;
				filterCompositeLData.height = 184;
				filterCompositeLData.left =  new FormAttachment(0, 1000, 5);
				filterCompositeLData.right =  new FormAttachment(1000, 1000, -5);
				filterCompositeLData.top =  new FormAttachment(0, 1000, 35);
				filterCompositeLData.bottom =  new FormAttachment(1000, 1000, -40);
				filterComposite = new InterceptionSettingsComposite(dialogComposite, SWT.NONE, InterceptFilterLocation.getResponseLocations(), filters, true);
				filterComposite.setLayoutData(filterCompositeLData);
			}
			dialogComposite.layout();
			dialogShell.setLocation(getParent().toDisplay(100, 100));
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) 
			{
				if (!display.readAndDispatch())
					display.sleep();
			}
		}
		catch (Exception e) 
		{
			e.printStackTrace();
		}
	}

}
