package com.grendelscan.GUI.fuzzing;

import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Combo;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.MessageBox;

import com.grendelscan.GrendelScan;
import com.grendelscan.GUI.fuzzing.vectorComposites.FuzzVectorComposite;
import com.grendelscan.GUI.fuzzing.vectorComposites.NumericSequenceComposite;
import com.grendelscan.GUI.fuzzing.vectorComposites.PresetStringComposite;
import com.grendelscan.GUI.fuzzing.vectorComposites.StringSequenceComposite;
import com.grendelscan.fuzzing.*;

import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.ModifyEvent;
import org.eclipse.swt.events.ModifyListener;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

import java.util.*;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class FuzzVectorChoiceDialog extends org.eclipse.swt.widgets.Dialog 
{
	private Button cancelButton;
	private Button okButton;
	private Group fuzzVectorGroup;
	private Combo vectorTypeCombo;
	private Composite currentFuzzComposite;
	private FormData fuzzCompositeLayout;
	private FuzzVector fuzzVector;
	private Shell dialogShell;

		
	public static FuzzVector getFuzzVector(Shell shell, FuzzVector oldVector) 
	{
		FuzzVectorChoiceDialog inst = new FuzzVectorChoiceDialog(shell, SWT.NULL, oldVector);
		return inst.fuzzVector;
	}

	public FuzzVectorChoiceDialog(Shell parent, int style, FuzzVector oldVector) 
	{
		super(parent, style);
		initGUI(oldVector);
	}
	
	private void initVectorComposites(FuzzVector oldVector)
	{
		fuzzVector = oldVector;
		List<FuzzVectorComposite> comps = new ArrayList<FuzzVectorComposite>(3);
		comps.add(new StringSequenceComposite(fuzzVectorGroup, SWT.NONE));
		comps.add(new NumericSequenceComposite(fuzzVectorGroup, SWT.NONE));
		comps.add(new PresetStringComposite(fuzzVectorGroup, SWT.NONE));
		
//		vectorComposites.put("Numeric sequence", new NumericSequenceComposite(fuzzVectorGroup, SWT.NONE));
		
		for (FuzzVectorComposite comp: comps)
		{
			vectorTypeCombo.add(comp.getDescription());
			vectorTypeCombo.setData(comp.getDescription(), comp);
			Composite composite = (Composite) comp;
			if (oldVector != null && comp.getFuzzVectorClass().equals(oldVector.getClass()))
			{
				composite.setVisible(true);
				comp.displayFuzzVector(oldVector);
				vectorTypeCombo.setText(comp.getDescription());
			}
			else
			{
				composite.setVisible(false);
			}
			composite.setLayoutData(fuzzCompositeLayout);
		}
	}


	private void initGUI(FuzzVector oldVector) 
	{
		try {
			dialogShell = new Shell(getParent(), SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL | SWT.RESIZE );
			dialogShell.setText(GrendelScan.versionText + " - Fuzz Vector");
			FillLayout dialogShellLayout = new FillLayout(org.eclipse.swt.SWT.HORIZONTAL);
			dialogShell.setLayout(dialogShellLayout);
			dialogShell.setSize(500,500);
			Composite dialogComposite = new Composite(dialogShell, SWT.NONE);
			dialogComposite.setLayout(new FormLayout());
			dialogComposite.setSize(500, 500);
			{
				FormData vectorTypeComboLData = new FormData();
				vectorTypeComboLData.width = 215;
				vectorTypeComboLData.height = 25;
				vectorTypeComboLData.left =  new FormAttachment(0, 1000, 7);
				vectorTypeComboLData.top =  new FormAttachment(0, 1000, 7);
				vectorTypeCombo = new Combo(dialogComposite, SWT.READ_ONLY);
				vectorTypeCombo.setLayoutData(vectorTypeComboLData);
				vectorTypeCombo.addModifyListener(new ModifyListener() 
				{
					public void modifyText(ModifyEvent evt) 
					{
						Composite composite = (Composite) vectorTypeCombo.getData(vectorTypeCombo.getText());
						if (currentFuzzComposite != null)
						{
							currentFuzzComposite.setVisible(false);
						}
						composite.setVisible(true);
						currentFuzzComposite = composite;
					}
				});
			}
			{
				fuzzVectorGroup = new Group(dialogComposite, SWT.NONE);
				FormLayout fuzzVectorGroupLayout = new FormLayout();
				fuzzVectorGroup.setLayout(fuzzVectorGroupLayout);
				FormData fuzzVectorGroupLData = new FormData();
				fuzzVectorGroupLData.width = 701;
				fuzzVectorGroupLData.height = 361;
				fuzzVectorGroupLData.left =  new FormAttachment(0, 1000, 5);
				fuzzVectorGroupLData.top =  new FormAttachment(0, 1000, 45);
				fuzzVectorGroupLData.right =  new FormAttachment(1000, 1000, -5);
				fuzzVectorGroupLData.bottom =  new FormAttachment(1000, 1000, -42);
				fuzzVectorGroup.setLayoutData(fuzzVectorGroupLData);
				fuzzVectorGroup.setText("Fuzz Vector Definition");
				{
					fuzzCompositeLayout = new FormData();
					fuzzCompositeLayout.left =  new FormAttachment(0, 1000, 5);
					fuzzCompositeLayout.top =  new FormAttachment(0, 1000, 5);
					fuzzCompositeLayout.right =  new FormAttachment(1000, 1000, -5);
					fuzzCompositeLayout.bottom =  new FormAttachment(1000, 1000, -5);
				}
			}
			{
				okButton = new Button(dialogComposite, SWT.PUSH | SWT.CENTER);
				FormData okButtonLData = new FormData();
				okButtonLData.width = 50;
				okButtonLData.height = 25;
				okButtonLData.left =  new FormAttachment(0, 1000, 5);
				okButtonLData.bottom =  new FormAttachment(1000, 1000, -5);
				okButton.setLayoutData(okButtonLData);
				okButton.setText("OK");
				okButton.addSelectionListener(new SelectionAdapter() 
				{
					public void widgetSelected(SelectionEvent evt) 
					{
						if (currentFuzzComposite == null)
						{
							fuzzVector = null;
    						dialogShell.close();
						}
						else
						{
							try
                            {
	                            fuzzVector = ((FuzzVectorComposite) currentFuzzComposite).getFuzzVector();
	    						dialogShell.close();
                            }
                            catch (FuzzVectorFormatException e)
                            {
                            	MessageBox m = new MessageBox(getParent().getShell());
                            	m.setText("Error");
                            	m.setMessage(e.toString());
                            	m.open();
                            }
						}
					}
				});
			}
			{
				cancelButton = new Button(dialogComposite, SWT.PUSH | SWT.CENTER);
				FormData button1LData = new FormData();
				button1LData.width = 50;
				button1LData.height = 25;
				button1LData.left =  new FormAttachment(0, 1000, 67);
				button1LData.bottom =  new FormAttachment(1000, 1000, -5);
				cancelButton.setLayoutData(button1LData);
				cancelButton.setText("Cancel");
				cancelButton.addSelectionListener(new SelectionAdapter() 
				{
					public void widgetSelected(SelectionEvent evt) 
					{
						dialogShell.close();
					}
				});
			}
			initVectorComposites(oldVector);
			dialogComposite.layout();
			dialogShell.setLocation(getParent().toDisplay(100, 100));
			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed()) 
			{
				if (!display.readAndDispatch())
					display.sleep();
			}
		}
		catch (Exception e) 
		{
			e.printStackTrace();
		}
	}
	

}
