package com.grendelscan.GUI.http;

import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Composite;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Event;
import org.eclipse.swt.widgets.Listener;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Table;
import org.eclipse.swt.widgets.TableColumn;
import org.eclipse.swt.widgets.TableItem;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.events.*;
import org.eclipse.swt.custom.TableEditor;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.SWT;
import com.grendelscan.utils.*;
import com.cloudgarden.resource.SWTResourceManager;
import com.grendelscan.GUI.*;
import com.grendelscan.GUI.Verifiers.EnforceHexOnly;
import java.util.*;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class HexViewComposite extends org.eclipse.swt.widgets.Composite {
	private Table hexTable;
	private TableEditor editor;
	private TableColumn textColumn;
	private TableColumn positionColumn;
	private boolean editable;
	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		HexViewComposite inst = new HexViewComposite(shell, SWT.NULL, false);
		inst.updateData("To run a snippet, simply import SWT into your Eclipse workspace, create a new Java project that depends on SWT, copy the desired snippet to the clipboard, and paste it into a new snippet class. (If you are using eclipse 3.2 M1 or earlier, you need to create the class using the New Class wizard before pasting; but since 3.2 M1 you can simply select your project and paste, and the class is created for you). Run by selecting the class and then selecting Run > Run As > Java Application.".getBytes());
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public HexViewComposite(org.eclipse.swt.widgets.Composite parent, int style, boolean editable) 
	{
		super(parent, style);
		this.editable = editable;
		initGUI();
	}
	
	public void updateData(byte[] data)
	{
		hexTable.removeAll();
		populateTable(data);
	}

	private void initGUI() 
	{
		SWTResourceManager.registerResourceUser(this);
		try 
		{
			FillLayout thisLayout = new FillLayout(org.eclipse.swt.SWT.HORIZONTAL);
			this.setLayout(thisLayout);
			this.setSize(745, 434);
			{
				final EnforceHexOnly hexOnlyVerifier = new EnforceHexOnly();
				hexTable = new Table(this, SWT.NONE);
				hexTable.setHeaderVisible(true);
				hexTable.setLinesVisible(true);
				hexTable.setFont(SWTResourceManager.getFont("Courier New", 9, SWT.BOLD, false, false));

				editor = new TableEditor(hexTable);
				editor.horizontalAlignment = SWT.LEFT;
				editor.grabHorizontal = true;
				if (editable)
				{
					hexTable.addListener(SWT.MouseDoubleClick, new Listener()
					{
						public void handleEvent(Event event)
						{
							Rectangle clientArea = hexTable.getClientArea();
							Point pt = new Point(event.x, event.y);
							int index = hexTable.getTopIndex();
							while (index < hexTable.getItemCount())
							{
								boolean tableEditorVisible = false;
								final TableItem item = hexTable.getItem(index);
								// We're starting at 1, because column 0 shouldn't be edited
								for (int i = 1; i < 17; i++)
								{
									Rectangle rect = item.getBounds(i);
									if (rect.contains(pt) && item.getText(i) != "")
									{
										final int column = i;
										final Text text = new Text(hexTable, SWT.NONE);
										final boolean hex;
										if (i > 0 && i < 17)
										{
											hex = true;
										}
										else
										{
											hex = false;
										}
	
										Listener textListener = new Listener()
										{
											public void handleEvent(final Event e)
											{
												if (hex)
												{
													if (text.getText().length() == 0)
													{
														text.setText("00");
													}
													else if (text.getText().length() == 1)
													{
														String newText = "0" + text.getText();
														// This is due to problems with the verifier
														text.setText("");
														text.setText(newText);
													}
												}
												switch (e.type)
												{
													case SWT.FocusOut:
														item.setText(column, text.getText());
														text.dispose();
														break;
													case SWT.Traverse:
														switch (e.detail)
														{
															case SWT.TRAVERSE_RETURN:
																item.setText(column, text.getText());
																// FALL THROUGH
															case SWT.TRAVERSE_ESCAPE:
																text.dispose();
																e.doit = false;
														}
														break;
												}
												if (hex)
												{
													item.setText(17, getRowText(item));
												}
												else
												{
													String newText = item.getText(17);
													int offset = Integer.parseInt(item.getText(0));
													
													item.setText(createRowData(newText.getBytes(), offset, newText.length()));
												}
											}
										};
										text.addListener(SWT.FocusOut, textListener);
										text.addListener(SWT.Traverse, textListener);
										text.setFont(SWTResourceManager.getFont("Courier New", 9, SWT.BOLD, false, false));
	
										editor.setEditor(text, item, i);
										// set limits
										if (hex)
										{
											text.addVerifyListener(hexOnlyVerifier);
											text.setTextLimit(2);
										}
										else
										{
											text.setTextLimit(16);
										}
										text.setText(item.getText(i));
										text.selectAll();
										text.setFocus();
										return;
									}
									if (!tableEditorVisible && rect.intersects(clientArea))
									{
										tableEditorVisible = true;
									}
								}
								if (!tableEditorVisible)
								{
									return;
								}
								index++;
							}
						}
					});
				}
				{
					positionColumn = new TableColumn(hexTable, SWT.NONE);
					positionColumn.setWidth(80);
					positionColumn.setResizable(false);
					positionColumn.setText("Offset");
				}

				makeHexColumn(hexTable, "0");
				makeHexColumn(hexTable, "1");
				makeHexColumn(hexTable, "2");
				makeHexColumn(hexTable, "3");
				makeHexColumn(hexTable, "4");
				makeHexColumn(hexTable, "5");
				makeHexColumn(hexTable, "6");
				makeHexColumn(hexTable, "7");
				makeHexColumn(hexTable, "8");
				makeHexColumn(hexTable, "9");
				makeHexColumn(hexTable, "A");
				makeHexColumn(hexTable, "B");
				makeHexColumn(hexTable, "C");
				makeHexColumn(hexTable, "D");
				makeHexColumn(hexTable, "E");
				makeHexColumn(hexTable, "F");
				{
					textColumn = new TableColumn(hexTable, SWT.NONE);
					textColumn.setResizable(false);
					textColumn.setWidth(160);
					textColumn.setText("Text");
				}
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private String getRowText(TableItem item)
	{
		String rowData[] = new String[17];
		for (int index = 1; index < 17; index++)
		{
			rowData[index] = item.getText(index);
		}
		return getRowText(rowData);
	}
	
	private String getRowText(String rowData[])
	{
		String text = "";
		for (int index = 1; index < 17; index++) 
		{
			String datum = rowData[index];
			if (datum != "")
			{
				int value = Integer.parseInt(datum, 16);
				if (value < 32)
				{
					text += ".";
				}
				else
				{
					text += String.format("%c", value);
				}
			}
		}
		return text;
	}
	
	private void populateTable(byte[] data)
	{
		for (int index = 0; index < data.length; index += 16)
		{
			TableItem item = new TableItem(hexTable, SWT.NONE);
			item.setFont(SWTResourceManager.getFont("Courier New", 9, SWT.BOLD, false, false));
			byte currentRow[] = ArrayUtils.copyOfRange(data, index, index + 15);
			item.setText(createRowData(currentRow, index, data.length - index));
		}
	}

	private String[] createRowData(byte[] data, int offset, int maxLength)
	{
		String text[] = new String[18];
		text[0] = String.format("%08x", offset);
		for (int index = 0; index < 16; index++)
		{
			if (index < data.length && index < maxLength)
			{
				text[index + 1] = String.format("%02X", data[index]);
			}
			else
			{
				text[index + 1] = "";
			}
		}
		text[17] = getRowText(text);
		return text;
	}
	
	
	
	private TableColumn makeHexColumn(Table parent, String name)
	{
		TableColumn hexColumn = new TableColumn(parent, SWT.NONE);
		hexColumn.setText(name);
		hexColumn.setResizable(false);
		hexColumn.setWidth(30);
		return hexColumn;
	}
	
	public byte[] getBytes()
	{
		int lastRowIndex = hexTable.getItemCount() - 1;
		if (lastRowIndex < 0)
		{
			return new byte[0];
		}
		int byteCount = 16 * lastRowIndex + getRowText(hexTable.getItem(lastRowIndex)).length(); 
		byte[] bytes = new byte[byteCount];
		int index = 0;
		for (TableItem item: hexTable.getItems())
		{
			for (int index2 = 1; index2 < 17; index2++)
			{
				String text = item.getText(index2);
				if (text != "")
				{
					bytes[index++] = (byte) Integer.parseInt(text, 16);
				}
				else
				{
					break;
				}
			}
		}
		
		return bytes;
	}
}
