package com.grendelscan.GUI.http;

import java.util.ArrayList;
import java.util.Iterator;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.browser.Browser;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.SWT;
import com.grendelscan.utils.*;
import com.grendelscan.GUI.*;
import com.grendelscan.GUI.customControls.SwingBrowserComposite;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class ParsedResponseBodyComposite extends org.eclipse.swt.widgets.Composite {
	private Button htmlEncodedRadioButton;
	private Button textEncodedRadio;
	private Button imageEncodedRadio;
	private Button hexEncodedRadio;
	private Text rawBodyTextBox;
	private HexViewComposite hexComposite;
	private HttpResponseContentType contentType;
	private byte[] body;
	private boolean editable;
	private SwingBrowserComposite browser;

	private FormData bodyFormatData;
	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		ParsedResponseBodyComposite inst = new ParsedResponseBodyComposite(shell, SWT.NULL, true, "<html><body>hi <b>there</b></body></html>".getBytes(), HttpResponseContentType.HTML);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public ParsedResponseBodyComposite(Composite parent, int style, boolean editable, byte body[], HttpResponseContentType contentType) 
	{
		super(parent, style);
		this.contentType = contentType;
		this.editable = editable;
		initGUI();
		updateData(body);
	}
	
	public void updateData(byte[] body)
	{
		this.body = body;
		updateBodyControl();
	}
	
	private void createBodyControls()
	{
		if (contentType == HttpResponseContentType.HTML)
		{
			browser = new SwingBrowserComposite(this, SWT.BORDER);
			browser.setLayoutData(bodyFormatData);
			browser.setVisible(false);
		}
		if (contentType == HttpResponseContentType.HTML || contentType == HttpResponseContentType.TEXT)
		{
			rawBodyTextBox = new Text(this, SWT.BORDER|SWT.MULTI|SWT.H_SCROLL|SWT.V_SCROLL);
			rawBodyTextBox.setLayoutData(bodyFormatData);
			rawBodyTextBox.setVisible(false);
			rawBodyTextBox.setEditable(editable);
		}
		if (contentType == HttpResponseContentType.IMAGE)
		{
		}
		
		hexComposite = new HexViewComposite(this, SWT.BORDER, editable);
		hexComposite.setLayoutData(bodyFormatData);
		hexComposite.setVisible(false);
		
		this.layout();
	}

	private boolean needBodyControlUpdate()
	{
		if (
				(htmlEncodedRadioButton != null && !browser.isVisible() && htmlEncodedRadioButton.getSelection())
				|| (textEncodedRadio != null && !rawBodyTextBox.isVisible() && textEncodedRadio.getSelection())
				|| (imageEncodedRadio != null && !true && imageEncodedRadio.getSelection())
				|| (hexEncodedRadio.getSelection() && !hexComposite.isVisible())
			)
		{
			return true;
		}
		return false;
	}
	
	private void updateBodyControl()
	{
		makeAllInvisible();
		if (htmlEncodedRadioButton != null && htmlEncodedRadioButton.getSelection())
		{
			browser.setHtmlText(new String(body));
			browser.setVisible(true);
		}
		else if (textEncodedRadio != null && textEncodedRadio.getSelection())
		{
			String bodyToUse;
			if (editable)
			{
				bodyToUse = new String(body);
			}
			else
			{
				bodyToUse = new String(body).replaceAll("\r?\n", Text.DELIMITER);
			}
			rawBodyTextBox.setText(bodyToUse);
			rawBodyTextBox.setVisible(true);
		}
		else if (imageEncodedRadio != null && imageEncodedRadio.getSelection())
		{
		}
		else if (hexEncodedRadio.getSelection())
		{
			hexComposite.updateData(body);
			hexComposite.setVisible(true);
		}
		this.layout();
	}
	
	private void makeAllInvisible()
	{
		if (browser != null) browser.setVisible(false);
		if (rawBodyTextBox != null) rawBodyTextBox.setVisible(false);
		if (hexComposite != null) hexComposite.setVisible(false);
	}
	
//	private void destroyOld()
//	{
//		if (browser != null)
//		{
//			browser.dispose();
//			browser = null;
//		}
//		else if (hexComposite != null)
//		{
//			hexComposite.dispose();
//			hexComposite = null;
//		}
//		else if (rawBodyTextBox != null)
//		{
//			rawBodyTextBox.dispose();
//			rawBodyTextBox = null;
//		}
//	}
	
	private void updateBody()
	{
		if (editable)
		{
			if (hexComposite != null && hexComposite.isVisible())
			{
				body = hexComposite.getBytes();
			}
			else if (rawBodyTextBox != null && rawBodyTextBox.isVisible())
			{
				body = rawBodyTextBox.getText().getBytes();
			}
		}
	}
	
	private void initGUI() {
		try {
			int leftLabelPosition = 0;
			this.setLayout(new FormLayout());
			this.setSize(834, 408);
			
			if (contentType == HttpResponseContentType.HTML)
			{
				htmlEncodedRadioButton = new Button(this, SWT.RADIO | SWT.LEFT);
				FormData htmlEncodedRadioButtonLData = new FormData();
				htmlEncodedRadioButtonLData.width = 65;
				htmlEncodedRadioButtonLData.height = 15;
				htmlEncodedRadioButtonLData.left =  new FormAttachment(0, 1000, leftLabelPosition);
				htmlEncodedRadioButtonLData.top =  new FormAttachment(0, 1000, 0);
				leftLabelPosition += htmlEncodedRadioButtonLData.width + 10;
				htmlEncodedRadioButton.setLayoutData(htmlEncodedRadioButtonLData);
				htmlEncodedRadioButton.setText("HTML");
				htmlEncodedRadioButton.setSelection(true);
				htmlEncodedRadioButton.addSelectionListener
				(
					new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent event)
						{ 
							if (needBodyControlUpdate())
							{
								updateBody();
								updateBodyControl();
							}
						}
					}
				);
			}

			if (contentType == HttpResponseContentType.HTML || contentType == HttpResponseContentType.TEXT)
			{
				textEncodedRadio = new Button(this, SWT.RADIO | SWT.LEFT);
				FormData rawEncodedRadioLData = new FormData();
				rawEncodedRadioLData.width = 50;
				rawEncodedRadioLData.height = 15;
				rawEncodedRadioLData.left =  new FormAttachment(0, 1000, leftLabelPosition);
				leftLabelPosition += rawEncodedRadioLData.width + 10;
				rawEncodedRadioLData.top =  new FormAttachment(0, 1000, 0);
				textEncodedRadio.setLayoutData(rawEncodedRadioLData);
				textEncodedRadio.setText("Text");
				if (contentType == HttpResponseContentType.TEXT)
				{
					textEncodedRadio.setSelection(true);
				}
				textEncodedRadio.addSelectionListener
				(
					new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent event)
						{ 
							if (needBodyControlUpdate())
							{
								updateBody();
								updateBodyControl();
							}
						}
					}
				);
			}
			
			
			if (contentType == HttpResponseContentType.IMAGE)
			{
				imageEncodedRadio = new Button(this, SWT.RADIO | SWT.LEFT);
				FormData imageEncodedRadioButtonLData = new FormData();
				imageEncodedRadioButtonLData.width = 114;
				imageEncodedRadioButtonLData.height = 15;
				imageEncodedRadioButtonLData.left =  new FormAttachment(0, 1000, leftLabelPosition);
				imageEncodedRadioButtonLData.top =  new FormAttachment(0, 1000, 0);
				leftLabelPosition += imageEncodedRadioButtonLData.width + 10;
				imageEncodedRadio.setLayoutData(imageEncodedRadioButtonLData);
				imageEncodedRadio.setText("Image");
				imageEncodedRadio.setSelection(true);
				imageEncodedRadio.addSelectionListener
				(
					new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent event)
						{ 
							if (needBodyControlUpdate())
							{
								updateBody();
								updateBodyControl();
							}
						}
					}
				);
			}
			
			{
				hexEncodedRadio = new Button(this, SWT.RADIO | SWT.LEFT);
				FormData hexEncodedRadioLData = new FormData();
				hexEncodedRadioLData.width = 50;
				hexEncodedRadioLData.height = 15;
				hexEncodedRadioLData.left =  new FormAttachment(0, 1000, leftLabelPosition);
				leftLabelPosition += hexEncodedRadioLData.width + 10;
				hexEncodedRadioLData.top =  new FormAttachment(0, 1000, 0);
				hexEncodedRadio.setLayoutData(hexEncodedRadioLData);
				hexEncodedRadio.setText("Hex");
				if (contentType == HttpResponseContentType.BINARY)
				{
					hexEncodedRadio.setSelection(true);
				}

				hexEncodedRadio.addSelectionListener
				(
					new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent event)
						{ 
							if (needBodyControlUpdate())
							{
								updateBody();
								updateBodyControl();
							}
						}
					}
				);
			}

			
			{
				bodyFormatData = new FormData();
//				bodyFormatData.width = 828;
//				bodyFormatData.height = 374;
				bodyFormatData.left =  new FormAttachment(0, 1000, 0);
				bodyFormatData.top =  new FormAttachment(0, 1000, 16);
				bodyFormatData.bottom =  new FormAttachment(1000, 1000, 0);
				bodyFormatData.right =  new FormAttachment(1000, 1000, 0);
			}
			createBodyControls();
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	

	public byte[] getBody() 
	{
		updateBody();
		return body;
	}
	
	public void clearData()
	{
		body = new byte[0];
		rawBodyTextBox.setText("");
		browser.setHtmlText("");
		hexComposite.updateData(body);
	}
}
