package com.grendelscan.GUI.http;

import java.text.DateFormat;
import java.util.*;

import com.cloudgarden.resource.SWTResourceManager;
import com.grendelscan.GUI.*;
import com.grendelscan.GUI.fuzzing.FuzzTemplateComposite;

import org.eclipse.jface.viewers.IStructuredContentProvider;
import org.eclipse.jface.viewers.ITableLabelProvider;
import org.eclipse.jface.viewers.LabelProvider;
import org.eclipse.jface.viewers.TableViewer;
import org.eclipse.jface.viewers.Viewer;
import org.eclipse.jface.viewers.ViewerSorter;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.*;

import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.scan.Scan;

/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class TransactionTable extends org.eclipse.swt.widgets.Composite
{
//	private Map<Integer, TransactionSummary> activeTransactions;
	private Button firstRecordButton;
	private int firstRecordID = 0;
	private int lastRecordID = 0;
	private Button lastRecordButton;
	private Button nextRecordButton;
	private Button exportDisplayedButton;
	private Button exportAllButton;
	private Button previousRecordButton;
	private Button refreshButton;
	private Scan scan;
	private Button settingsButton;
	private TransactionTableSettingsDialog settingsDialog;
	private TransactionTableSettings tableSettings;
	private TableViewer tableViewer;
	private Table transactionsTable;
	private boolean topToBottom = true;
	private ScanStatusWindow scanStatusWindow;
	private boolean allTransactions;
	private Text transactionCountTextBox;
	
	public TransactionTable(org.eclipse.swt.widgets.Composite parent, int style, Scan scan, ScanStatusWindow scanStatusWindow, boolean allTransactions)
	{
		super(parent, style);
		this.allTransactions = allTransactions;
		this.scan = scan;
		this.scanStatusWindow = scanStatusWindow;
//		activeTransactions = new HashMap<Integer, TransactionSummary>(250);
		tableSettings = new TransactionTableSettings();
		initGUI();
	}
	
	/**
	 * Auto-generated main method to display this
	 * org.eclipse.swt.widgets.Composite inside a new Shell.
	 */
	public static void main(String[] args)
	{
		showGUI();
	}
	
	/**
	 * Auto-generated method to display this org.eclipse.swt.widgets.Composite
	 * inside a new Shell.
	 */
	public static void showGUI()
	{
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		TransactionTable inst = new TransactionTable(shell, SWT.NULL, null, null, true);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if ((size.x == 0) && (size.y == 0))
		{
			inst.pack();
			shell.pack();
		}
		else
		{
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed())
		{
			if (!display.readAndDispatch())
			{
				display.sleep();
			}
		}
	}
	
	private void addTransactionColumn(String text, int width, boolean sortable)
	{
		TableColumn column = new TableColumn(transactionsTable, SWT.NONE);
		column.setText(text);
		column.setWidth(width);
		if (sortable)
		{
			column.addSelectionListener(new SelectionAdapter()
			{
				@Override
				public void widgetSelected(SelectionEvent e)
				{
					tableViewer.setSorter(new ViewerSorter());
				}
			});
		}
	}
	
	private void createTable(int top)
	{
		{
			FormData transactionsTableLData = new FormData();
			transactionsTableLData.width = 703;
			transactionsTableLData.height = 347;
			transactionsTableLData.left = new FormAttachment(0, 1000, 5);
			transactionsTableLData.top = new FormAttachment(0, 1000, top);
			transactionsTableLData.right = new FormAttachment(1000, 1000, -5);
			transactionsTableLData.bottom = new FormAttachment(1000, 1000, -5);
			transactionsTable = new Table(this, SWT.H_SCROLL | SWT.V_SCROLL | SWT.BORDER | SWT.FULL_SELECTION);
			transactionsTable.setLayoutData(transactionsTableLData);
			transactionsTable.setHeaderVisible(true);
			transactionsTable.addListener(SWT.MenuDetect, new Listener()
			{

                public void handleEvent(Event e)
                {
					final TableItem selection[] = transactionsTable.getSelection();
					if (selection.length == 1)
					{
						Menu menu = createContextMenu();
						final int transactionID = Integer.valueOf(selection[0].getText());
						
						
						{
							MenuItem item = new MenuItem(menu, SWT.PUSH);
							item.setText("Open");
							item.addSelectionListener(new SelectionAdapter()
							{
								public void widgetSelected(SelectionEvent evt)
								{
									AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(transactionID);
									TransactionComposite.displayTransaction(transaction, false, false, true);
								}
							});
						}

						{
							MenuItem item = new MenuItem(menu, SWT.PUSH);
							item.setText("Send to manual request");
							item.addSelectionListener(new SelectionAdapter()
							{
								public void widgetSelected(SelectionEvent evt)
								{
									scanStatusWindow.displayTransactionInManualRequest(transactionID);
									scanStatusWindow.getScanTabs().setSelection(ScanStatusWindow.MANUAL_REQUEST_TAB);
								}
							});
						}
						
						if (allTransactions)
						{
							MenuItem item = new MenuItem(menu, SWT.PUSH);
							item.setText("Use as fuzz template");
							item.addSelectionListener(new SelectionAdapter()
							{
								public void widgetSelected(SelectionEvent evt)
								{
									AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(transactionID);
									FuzzTemplateComposite.fuzzTemplateText = transaction.requestToString();
									scanStatusWindow.getScanTabs().setSelection(ScanStatusWindow.FUZZER_TAB);
									FuzzTemplateComposite.getFuzzTemplate(getShell());
								}
							});
						}

						
						menu.setLocation(e.x, e.y);
						menu.setVisible(true);
						while (!menu.isDisposed() && menu.isVisible()) 
						{
				          if (!menu.getDisplay().readAndDispatch())
				        	  menu.getDisplay().sleep();
				        }
				        menu.dispose();
					}
                }
				
			});
			transactionsTable.addMouseListener(new MouseAdapter() {
				public void mouseDoubleClick(MouseEvent evt) 
				{
					TableItem selection[] = transactionsTable.getSelection();
					if (selection.length != 1)
					{
						return;
					}
					int id = Integer.valueOf(selection[0].getText());
					AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(id);
					TransactionComposite.displayTransaction(transaction, false, false, true);
				}
			});
			{
				addTransactionColumn("ID", 50, false);
				addTransactionColumn("Time", 90, false);
				if (allTransactions)
				{
					addTransactionColumn("Source", 60, false);
				}
				addTransactionColumn("Method", 60, false);
				addTransactionColumn("Host", 150, false);
				addTransactionColumn("Path", 150, false);
				addTransactionColumn("Query", 150, false);
				addTransactionColumn("Response Status", 100, false);
			}
			
		}
	}
	
	private Menu createContextMenu()
	{
		Menu menu = new Menu(this.getShell(), SWT.POP_UP);
		return menu;
	}
	
	private void createTableViewer()
	{
		tableViewer = new TableViewer(transactionsTable);
		tableViewer.setUseHashlookup(true);
		tableViewer.setColumnProperties(getColumnNames());
		// tableViewer.setSorter(new ViewerSorter());
		
		getDisplay().timerExec(0, new TailTableUpdate());
	}
	
	private String[] getColumnNames()
	{
		String names[] = new String[transactionsTable.getColumnCount()];
		int index = 0;
		for (TableColumn column: transactionsTable.getColumns())
		{
			names[index++] = column.getText();
		}
		return names;
	}
	
	private void initGUI()
	{
		try
		{
			settingsDialog = new TransactionTableSettingsDialog(getShell(), SWT.NONE);
			setLayout(new FormLayout());
			this.setSize(900, 179);
			int top = 0;
			if (allTransactions)
			{
				top = 35;
				{
					refreshButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData refreshButtonLData = new FormData();
					refreshButtonLData.width = 75;
					refreshButtonLData.height = 25;
					refreshButtonLData.left = new FormAttachment(0, 1000, 85);
					refreshButtonLData.top = new FormAttachment(0, 1000, 5);
					refreshButton.setLayoutData(refreshButtonLData);
					refreshButton.setText("Refresh");
					refreshButton.addSelectionListener(new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent evt)
						{
							refreshTable();
						}
					});
				}
				{
					settingsButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData settingsButtonLData = new FormData();
					settingsButtonLData.width = 75;
					settingsButtonLData.height = 25;
					settingsButtonLData.left = new FormAttachment(0, 1000, 5);
					settingsButtonLData.top = new FormAttachment(0, 1000, 5);
					settingsButton.setLayoutData(settingsButtonLData);
					settingsButton.setText("Settings");
					settingsButton.addSelectionListener(new SelectionAdapter()
					{
						@Override
						public void widgetSelected(SelectionEvent evt)
						{
							if (settingsDialog.open(tableSettings))
							{
								updateJumpButtons();
								refreshTable();
							}
						}
					});
				}
				{
					firstRecordButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData firstRecordButtonLData = new FormData();
					firstRecordButtonLData.width = 25;
					firstRecordButtonLData.height = 20;
					firstRecordButtonLData.left = new FormAttachment(0, 1000, 172);
					firstRecordButtonLData.top = new FormAttachment(0, 1000, 8);
					firstRecordButton.setLayoutData(firstRecordButtonLData);
					firstRecordButton.setToolTipText("First page");
					firstRecordButton.setText("<<");
					firstRecordButton.addSelectionListener(new SelectionAdapter()
					{
						@Override
						public void widgetSelected(SelectionEvent evt)
						{
							firstRecordID = 1;
							topToBottom = true;
							refreshTable();
						}
					});
					
				}
				{
					previousRecordButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData firstRecordButtonLData = new FormData();
					firstRecordButtonLData.width = 25;
					firstRecordButtonLData.height = 20;
					firstRecordButtonLData.left = new FormAttachment(0, 1000, 207);
					firstRecordButtonLData.top = new FormAttachment(0, 1000, 8);
					previousRecordButton.setLayoutData(firstRecordButtonLData);
					previousRecordButton.setToolTipText("Previous page");
					previousRecordButton.setText("<");
					previousRecordButton.addSelectionListener(new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent evt)
						{
							lastRecordID = firstRecordID - 1;
							topToBottom = false;
							if (lastRecordID <= 1)
							{
								lastRecordID = 1;
								topToBottom = true;
							}
							refreshTable();
						}
					});
				}
				{
					nextRecordButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData firstRecordButtonLData = new FormData();
					firstRecordButtonLData.width = 25;
					firstRecordButtonLData.height = 20;
					firstRecordButtonLData.left = new FormAttachment(0, 1000, 242);
					firstRecordButtonLData.top = new FormAttachment(0, 1000, 8);
					nextRecordButton.setLayoutData(firstRecordButtonLData);
					nextRecordButton.setToolTipText("Next page");
					nextRecordButton.setText(">");
					nextRecordButton.addSelectionListener(new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent evt)
						{
							firstRecordID = lastRecordID + 1;
							topToBottom = true;
							refreshTable();
						}
					});
				}
				{
					lastRecordButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData firstRecordButtonLData = new FormData();
					firstRecordButtonLData.width = 25;
					firstRecordButtonLData.height = 20;
					firstRecordButtonLData.left = new FormAttachment(0, 1000, 277);
					firstRecordButtonLData.top = new FormAttachment(0, 1000, 8);
					lastRecordButton.setLayoutData(firstRecordButtonLData);
					lastRecordButton.setToolTipText("Last page");
					lastRecordButton.setText(">>");
					lastRecordButton.addSelectionListener(new SelectionAdapter()
					{
						public void widgetSelected(SelectionEvent evt)
						{
							lastRecordID = AbstractHttpTransaction.getLastID();
							topToBottom = false;
							refreshTable();
						}
					});
				}
				{
					exportDisplayedButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData exportDisplayedButtonLData = new FormData();
					exportDisplayedButtonLData.width = 118;
					exportDisplayedButtonLData.height = 27;
					exportDisplayedButtonLData.left =  new FormAttachment(0, 1000, 410);
					exportDisplayedButtonLData.top =  new FormAttachment(0, 1000, 5);
					exportDisplayedButton.setLayoutData(exportDisplayedButtonLData);
					exportDisplayedButton.setText("Export Displayed");
					exportDisplayedButton.addSelectionListener(new SelectionAdapter() {
						public void widgetSelected(SelectionEvent evt) {
							exportDisplayedButtonWidgetSelected(evt);
						}
					});
				}
				{
					exportAllButton = new Button(this, SWT.PUSH | SWT.CENTER);
					FormData exportAllButtonLData = new FormData();
					exportAllButtonLData.width = 71;
					exportAllButtonLData.height = 27;
					exportAllButtonLData.left =  new FormAttachment(0, 1000, 327);
					exportAllButtonLData.top =  new FormAttachment(0, 1000, 5);
					exportAllButton.setLayoutData(exportAllButtonLData);
					exportAllButton.setText("Export All");
					exportAllButton.addSelectionListener(new SelectionAdapter() {
						public void widgetSelected(SelectionEvent evt) {
							exportAllButtonWidgetSelected(evt);
						}
					});
				}
				{
					Label transactionCountLabel = new Label(this, SWT.NONE);
					transactionCountLabel.setText("Total request count:");
					FormData transactionCountLabelLData = new FormData();
					transactionCountLabelLData.width = 125;
					transactionCountLabelLData.height = 25;
					transactionCountLabelLData.top =  new FormAttachment(0, 1000, 5);
					transactionCountLabelLData.right =  new FormAttachment(1000, 1000, -70);
					transactionCountLabel.setLayoutData(transactionCountLabelLData);
					transactionCountLabel.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
				}
				{
					transactionCountTextBox = new Text(this, SWT.READ_ONLY | SWT.BORDER);
					transactionCountTextBox.setBackground(SWTResourceManager.getColor(255,255,255));
					FormData transactionCountTextBoxLData = new FormData();
					transactionCountTextBoxLData.width = 50;
					transactionCountTextBoxLData.height = 20;
					transactionCountTextBoxLData.top =  new FormAttachment(0, 1000, 5);
					transactionCountTextBoxLData.right =  new FormAttachment(1000, 1000, -5);
					transactionCountTextBox.setLayoutData(transactionCountTextBoxLData);
					transactionCountTextBox.setFont(SWTResourceManager.getFont(GUIConstants.fontName, GUIConstants.fontSize, 0, false, false));
				}
			}
			createTable(top);
			createTableViewer();
			if (allTransactions)
			{
				tableViewer.setContentProvider(new TransactionContentProvider());
				updateJumpButtons();
			}
			tableViewer.setLabelProvider(new TransactionLabelProvider());
			this.layout();
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	
	public void addTransaction(AbstractHttpTransaction transaction)
	{
		final TransactionSummary summary = new TransactionSummary(transaction.getId(), transaction.getExecutionTime(), transaction.getMethod(), transaction.getHost(), transaction.getPath() + transaction.getFilename(), transaction.getUriQueryString(), transaction.getResponseStatusCode(), transaction.getResponseWrapper().getStatusLine().toString(), transaction.getSource().getText());
		
		getDisplay().asyncExec(new Runnable()
		{
			public void run()
			{
				tableViewer.add(summary);
			}
		});
	}
	
	public void clearTable()
	{
		getDisplay().syncExec(new Runnable()
		{
			public void run()
			{
				transactionsTable.removeAll();
			}
		});
	}
	
	public void refreshTable()
	{
//		for (TransactionSummary wrapper: activeTransactions.values())
//		{
//			tableViewer.remove(wrapper);
//		}
//		activeTransactions.clear();
		tableViewer.setInput("reset");
	}
	
	private void updateJumpButtons()
	{
		firstRecordButton.setEnabled(!tableSettings.tail);
		previousRecordButton.setEnabled(!tableSettings.tail);
		nextRecordButton.setEnabled(!tableSettings.tail);
		lastRecordButton.setEnabled(!tableSettings.tail);
	}
	
	private class TransactionContentProvider implements IStructuredContentProvider
	{
		public void dispose()
		{
//			System.out.println("dispose");
		}
		
		public Object[] getElements(Object arg0)
		{
//			System.out.println("getElements");
			int startingID;
			if (topToBottom)
			{
				startingID = firstRecordID;
			}
			else
			{
				startingID = lastRecordID;
			}
			
			java.util.List<TransactionSummary> transactions = scan.getTransactionRecord().getTransactions(tableSettings, startingID, topToBottom, false);
			if(transactions.size() > 0)
			{
				lastRecordID = transactions.get(transactions.size()-1).transactionID;
				firstRecordID = transactions.get(0).transactionID;
			}
			return transactions.toArray();
		}
		
		public void inputChanged(Viewer viewer, Object oldInput, Object newInput)
		{
			// ((RecordWrapper)newInput).data = "changed";
//			System.out.println("inputChanged");
		}
		
	}
	
	private DateFormat timeFormater = DateFormat.getTimeInstance(DateFormat.FULL);
	
	private class TransactionLabelProvider extends LabelProvider implements ITableLabelProvider
	{
		
		public Image getColumnImage(Object arg0, int arg1)
		{
			return null;
		}
		
		public String getColumnText(Object transactionWrapper, int columnIndex)
		{
			TransactionSummary _transactionWrapper = (TransactionSummary) transactionWrapper;
			if (allTransactions)
			{
				switch (columnIndex)
				{
					case 0:
						return String.valueOf(_transactionWrapper.transactionID);
					case 1:
						return timeFormater.format(_transactionWrapper.time);
					case 2:
						return _transactionWrapper.source;
					case 3:
						return _transactionWrapper.method;
					case 4:
						return _transactionWrapper.host;
					case 5:
						return _transactionWrapper.path;
					case 6:
						return _transactionWrapper.query;
					case 7:
						return _transactionWrapper.resultText;
				}
			}
			else
			{
				switch (columnIndex)
				{
					case 0:
						return String.valueOf(_transactionWrapper.transactionID);
					case 1:
						return timeFormater.format(_transactionWrapper.time);
					case 2:
						return _transactionWrapper.method;
					case 3:
						return _transactionWrapper.host;
					case 4:
						return _transactionWrapper.path;
					case 5:
						return _transactionWrapper.query;
					case 6:
						return _transactionWrapper.resultText;
				}
			}
			return ((TransactionSummary) transactionWrapper).transactionID + "-getColumnText";
		}
		
	}
	
	
	private class TailTableUpdate implements Runnable
	{
		public void run()
		{
			if (tableSettings.tail) 
			{
				int currentID = AbstractHttpTransaction.getLastID();
				if (currentID > lastRecordID)
				{
					refreshTable();
//					for (int id = lastRecordID + 1; id <= currentID; id++)
//					{
//						AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(id);
//						TransactionSummary transactionSummary = new TransactionSummary(transaction.getId(), transaction.getExecutionTime(), transaction.getMethod(),
//								transaction.getHostUri(), transaction.getPath(), transaction.getUriQueryString(), transaction.getResponseStatusCode(), 
//								transaction.getStatusLineString(), transaction.getSource().getText());
//						if (tableSettings.checkTransactionCriteria(transactionSummary))
//						{
//							tableViewer.add(transactionSummary);
//							activeTransactions.put(id, transactionSummary);
//						}
//					}
//					lastRecordID = currentID;
//					
//					if (lastRecordID - firstRecordID > tableSettings.maxRecords)
//					{
//						for (int id = firstRecordID; id <= lastRecordID - tableSettings.maxRecords; id++)
//						{
//							TransactionSummary wrapper = activeTransactions.get(id);
//							tableViewer.remove(wrapper);
//							activeTransactions.remove(id);
//						}
//						firstRecordID = lastRecordID - tableSettings.maxRecords + 1;
//					}
				}
			}
			getDisplay().timerExec(tableSettings.updateFrequency, new TailTableUpdate());
		}
	}

	public void setTransactionCount(int value)
    {
	    transactionCountTextBox.setText(String.valueOf(value));
    }
	
	private void exportDisplayedButtonWidgetSelected(SelectionEvent evt) 
	{
		for (TableItem item: transactionsTable.getItems())
		{
			exportTransaction(Integer.valueOf(item.getText(0)));
		}
	}
	
	private void exportAllButtonWidgetSelected(SelectionEvent evt) 
	{
		scan.getTransactionRecord().writeAllExecutedToDisk();
		scan.getScanStatusWindow().displayMessage("Notice:", 
				"A seperate thread has been spawned\n" +
				"to export all of the transactions.\n");
	}
	
	private void exportTransaction(int id)
	{
		AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(id);
		transaction.writeToDisk(true);
	}

}
