package com.grendelscan.GUI.http;

import com.grendelscan.GrendelScan;
import com.grendelscan.GUI.*;
import com.grendelscan.GUI.Verifiers.*;

import org.eclipse.swt.layout.FillLayout;
import java.util.*;
import java.util.regex.*;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.layout.GridData;
import org.eclipse.swt.layout.GridLayout;
import org.eclipse.swt.widgets.Button;
import org.eclipse.swt.widgets.Display;
import org.eclipse.swt.widgets.Group;
import org.eclipse.swt.widgets.Label;
import org.eclipse.swt.widgets.MessageBox;
import org.eclipse.swt.widgets.Shell;
import org.eclipse.swt.widgets.Text;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.FocusAdapter;
import org.eclipse.swt.events.FocusEvent;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import com.grendelscan.requester.*;
/**
 * This code was edited or generated using CloudGarden's Jigloo SWT/Swing GUI
 * Builder, which is free for non-commercial use. If Jigloo is being used
 * commercially (ie, by a corporation, company or business for any purpose
 * whatever) then you should purchase a license for each developer using Jigloo.
 * Please visit www.cloudgarden.com for details. Use of Jigloo implies
 * acceptance of these licensing terms. A COMMERCIAL LICENSE HAS NOT BEEN
 * PURCHASED FOR THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED LEGALLY FOR
 * ANY CORPORATE OR COMMERCIAL PURPOSE.
 */
public class TransactionTableSettingsDialog extends org.eclipse.swt.widgets.Dialog
{
	
	private Shell dialogShell;
	private Group transactionSourceGroup;
	private Button authenticationSourceCheckbox;
	private Button noneSourceButton;
	private Button cancelButton;
	private Button okButton;
	private Text responseCodeRegexText;
	private Text queryRegexText;
	private Text pathRegexText;
	private Text hostRegexText;
	private Text maxRecordsText;
	private Text updateFrequencyText;
	private Label responseCodeRegexLabel;
	private Button resetButton;
	private Label queryRegexLabel;
	private Label pathRegexLabel;
	private Label hostRegexLabel;
	private Button allSourceButton;
	private Button cobraSourceCheckbox;
	private Button manualRequestCheckbox;
	private Button overrideSourceCheckbox;
	private Button categorizerSourceCheckbox;
	private Button niktoSourceCheckbox;
	private Button baseUrlCheckbox;
	private Button enumerationSourceCheckbox;
	private Button testSourceCheckbox;
	private Button spiderSourceCheckbox;
	private Button proxySourceCheckbox;
	private boolean canceled = false;
	private Button fuzzerSourceCheckbox;
	private Label updateFrequencyLabel;
	private Label maxRecordsLabel;
	private Button tailCheckbox;
	private Group miscGroup;
	private Group filterGroup;
	private TransactionTableSettings existingSettings;
	private boolean changed;
	/**
	 * Auto-generated main method to display this org.eclipse.swt.widgets.Dialog
	 * inside a new Shell.
	 */
	public static void main(String[] args)
	{
		try
		{
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			TransactionTableSettingsDialog inst = new TransactionTableSettingsDialog(shell, SWT.NULL);
			inst.open(null);
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
	}
	
	public TransactionTableSettingsDialog(Shell parent, int style)
	{
		super(parent, style);
	}
	
	public boolean open(TransactionTableSettings existingSettings)
	{
		this.existingSettings = existingSettings;
		changed = false;
		try
		{
			createDialog();
			loadDefaults();
			enableNonTailSettings(!existingSettings.tail);
			displayFilter(existingSettings);
			dialogShell.setLocation(getParent().toDisplay(100, 100));
			dialogShell.setText(GrendelScan.versionText + " - Transaction Table Settings");

			dialogShell.open();
			Display display = dialogShell.getDisplay();
			while (!dialogShell.isDisposed())
			{
				if (!display.readAndDispatch())
					display.sleep();
			}
		}
		catch (Exception e)
		{
			e.printStackTrace();
		}
		return changed;
	}
	
	
	
	
	private void displayFilter(TransactionTableSettings filter)
	{
		if (filter != null)
		{
			for (TransactionSource source: filter.getSources())
			{
				switch (source)
				{
					case AUTHENTICATION: authenticationSourceCheckbox.setSelection(true); break;
					case AUTOMATIC_RESPONSE_CODE_OVERRIDES: overrideSourceCheckbox.setSelection(true); break;
					case BASE: baseUrlCheckbox.setSelection(true); break;
					case CATEGORIZER: categorizerSourceCheckbox.setSelection(true); break;
					case COBRA: cobraSourceCheckbox.setSelection(true); break;
					case ENUMERATION: enumerationSourceCheckbox.setSelection(true); break;
					case FUZZER: fuzzerSourceCheckbox.setSelection(true); break;
					case MANUAL_REQUEST: manualRequestCheckbox.setSelection(true); break;
					case NIKTO: niktoSourceCheckbox.setSelection(true); break;
					case PROXY: proxySourceCheckbox.setSelection(true); break;
					case SPIDER: spiderSourceCheckbox.setSelection(true); break;
					case TEST: testSourceCheckbox.setSelection(true); break;
				}
			}
			hostRegexText.setText(filter.getHostPattern());
			pathRegexText.setText(filter.getPathPattern());
			queryRegexText.setText(filter.getQueryPattern());
			responseCodeRegexText.setText(filter.getResponseCodePattern());
			tailCheckbox.setSelection(filter.tail);
			maxRecordsText.setText(String.valueOf(filter.maxRecords));
			updateFrequencyText.setText(String.valueOf(filter.updateFrequency));
		}
	}
	
	private void createDialog()
	{
		EnforceIntegersOnly numbersOnly = new EnforceIntegersOnly();
		Shell parent = getParent();
		dialogShell = new Shell(parent, SWT.DIALOG_TRIM | SWT.APPLICATION_MODAL);
		
		dialogShell.setLayout(new FormLayout());
		dialogShell.layout();
		dialogShell.pack();
		dialogShell.setSize(618, 445);
		{
			miscGroup = new Group(dialogShell, SWT.NONE);
			FormLayout miscGroupLayout = new FormLayout();
			miscGroup.setLayout(miscGroupLayout);
			FormData miscGroupLData = new FormData();
			miscGroupLData.width = 421;
			miscGroupLData.height = 123;
			miscGroupLData.left =  new FormAttachment(0, 1000, 171);
			miscGroupLData.top =  new FormAttachment(0, 1000, 194);
			miscGroup.setLayoutData(miscGroupLData);
			miscGroup.setText("Miscellaneous");
			{
				tailCheckbox = new Button(miscGroup, SWT.CHECK | SWT.LEFT);
				FormData tailCheckboxLData = new FormData();
				tailCheckboxLData.width = 189;
				tailCheckboxLData.height = 25;
				tailCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				tailCheckboxLData.top =  new FormAttachment(0, 1000, 5);
				tailCheckbox.setLayoutData(tailCheckboxLData);
				tailCheckbox.setText("Tail (proxy && manual only)");
				tailCheckbox.addSelectionListener(new SelectionAdapter()
				{
					public void widgetSelected(SelectionEvent evt)
					{
						enableNonTailSettings(!tailCheckbox.getSelection());
					}
				});

				
			}
			{
				maxRecordsLabel = new Label(miscGroup, SWT.NONE);
				FormData maxRecordsLabelLData = new FormData();
				maxRecordsLabelLData.width = 81;
				maxRecordsLabelLData.height = 25;
				maxRecordsLabelLData.left =  new FormAttachment(0, 1000, 5);
				maxRecordsLabelLData.top =  new FormAttachment(0, 1000, 40);
				maxRecordsLabel.setLayoutData(maxRecordsLabelLData);
				maxRecordsLabel.setText("Max records:");

			}
			{
				FormData maxRecordsTextLData = new FormData();
				maxRecordsTextLData.width = 69;
				maxRecordsTextLData.height = 19;
				maxRecordsTextLData.left =  new FormAttachment(0, 1000, 130);
				maxRecordsTextLData.top =  new FormAttachment(0, 1000, 40);
				maxRecordsText = new Text(miscGroup, SWT.BORDER);
				maxRecordsText.setLayoutData(maxRecordsTextLData);
				maxRecordsText.setText("1000");
				maxRecordsText.addVerifyListener(numbersOnly);
			}
			{
				updateFrequencyLabel = new Label(miscGroup, SWT.NONE);
				FormData updateFrequencyLabelLData = new FormData();
				updateFrequencyLabelLData.width = 117;
				updateFrequencyLabelLData.height = 25;
				updateFrequencyLabelLData.left =  new FormAttachment(0, 1000, 5);
				updateFrequencyLabelLData.top =  new FormAttachment(0, 1000, 75);
				updateFrequencyLabel.setLayoutData(updateFrequencyLabelLData);
				updateFrequencyLabel.setText("Update frequency:");
				updateFrequencyLabel.setEnabled(false);
			}
			{
				FormData updateFrequencyTextLData = new FormData();
				updateFrequencyTextLData.width = 71;
				updateFrequencyTextLData.height = 19;
				updateFrequencyTextLData.left =  new FormAttachment(0, 1000, 130);
				updateFrequencyTextLData.top =  new FormAttachment(0, 1000, 75);
				updateFrequencyText = new Text(miscGroup, SWT.BORDER);
				updateFrequencyText.setLayoutData(updateFrequencyTextLData);
				updateFrequencyText.setEnabled(false);
				updateFrequencyText.addVerifyListener(numbersOnly);
			}
		}
		{
			okButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			FormData okButtonLData = new FormData();
			okButtonLData.width = 86;
			okButtonLData.height = 27;
			okButtonLData.left =  new FormAttachment(0, 1000, 30);
			okButtonLData.bottom =  new FormAttachment(1000, 1000, -5);
			okButton.setLayoutData(okButtonLData);
			okButton.setText("OK");
			okButton.addSelectionListener(new SelectionAdapter() {
				public void widgetSelected(SelectionEvent evt) {
					okButtonWidgetSelected(evt);
				}
			});
		}
		{
			cancelButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			FormData cancelButtonLData = new FormData();
			cancelButtonLData.width = 86;
			cancelButtonLData.height = 27;
			cancelButtonLData.left =  new FormAttachment(0, 1000, 128);
			cancelButtonLData.bottom =  new FormAttachment(1000, 1000, -5);
			cancelButton.setLayoutData(cancelButtonLData);
			cancelButton.setText("Cancel");
			cancelButton.addSelectionListener(new SelectionAdapter() 
			{
				public void widgetSelected(SelectionEvent evt) 
				{
					canceled = true;
					dialogShell.close();
				}
			});
		}
		{
			resetButton = new Button(dialogShell, SWT.PUSH | SWT.CENTER);
			FormData resetButtonLData = new FormData();
			resetButtonLData.width = 86;
			resetButtonLData.height = 27;
			resetButtonLData.left =  new FormAttachment(0, 1000, 247);
			resetButtonLData.bottom =  new FormAttachment(1000, 1000, -5);
			resetButton.setLayoutData(resetButtonLData);
			resetButton.setText("Reset");
			resetButton.addSelectionListener(new SelectionAdapter() 
			{
				public void widgetSelected(SelectionEvent evt) 
				{
					loadDefaults();
				}
			});
		}
		{
			filterGroup = new Group(dialogShell, SWT.NONE);
			filterGroup.setLayout(new FormLayout());
			FormData filterGroupLData = new FormData();
			filterGroupLData.width = 421;
			filterGroupLData.height = 163;
			filterGroupLData.left =  new FormAttachment(0, 1000, 171);
			filterGroupLData.top =  new FormAttachment(0, 1000, 5);
			filterGroup.setLayoutData(filterGroupLData);
			filterGroup.setText("Filters");
			{
				hostRegexLabel = new Label(filterGroup, SWT.NONE);
				FormData hostRegexLabelLData = new FormData();
				hostRegexLabelLData.width = 72;
				hostRegexLabelLData.height = 17;
				hostRegexLabelLData.left =  new FormAttachment(0, 1000, 5);
				hostRegexLabelLData.top =  new FormAttachment(0, 1000, 5);
				hostRegexLabel.setLayoutData(hostRegexLabelLData);
				hostRegexLabel.setText("Host regex:");
			}
			{
				FormData hostRegexTextLData = new FormData();
				hostRegexTextLData.width = 300;
				hostRegexTextLData.height = 19;
				hostRegexTextLData.left =  new FormAttachment(0, 1000, 105);
				hostRegexTextLData.top =  new FormAttachment(0, 1000, 7);
				hostRegexText = new Text(filterGroup, SWT.BORDER);
				hostRegexText.setLayoutData(hostRegexTextLData);
			}
			{
				pathRegexLabel = new Label(filterGroup, SWT.NONE);
				FormData pathRegexLabelLData = new FormData();
				pathRegexLabelLData.width = 72;
				pathRegexLabelLData.height = 17;
				pathRegexLabelLData.left =  new FormAttachment(0, 1000, 5);
				pathRegexLabelLData.top =  new FormAttachment(0, 1000, 45);
				pathRegexLabel.setLayoutData(pathRegexLabelLData);
				pathRegexLabel.setText("Path regex:");
			}
			{
				FormData pathRegexTextLData = new FormData();
				pathRegexTextLData.width = 300;
				pathRegexTextLData.height = 19;
				pathRegexTextLData.left =  new FormAttachment(0, 1000, 105);
				pathRegexTextLData.top =  new FormAttachment(0, 1000, 47);
				pathRegexText = new Text(filterGroup, SWT.BORDER);
				pathRegexText.setLayoutData(pathRegexTextLData);
			}
			{
				queryRegexLabel = new Label(filterGroup, SWT.NONE);
				FormData queryRegexLabelLData = new FormData();
				queryRegexLabelLData.width = 82;
				queryRegexLabelLData.height = 17;
				queryRegexLabelLData.left =  new FormAttachment(0, 1000, 5);
				queryRegexLabelLData.top =  new FormAttachment(0, 1000, 85);
				queryRegexLabel.setLayoutData(queryRegexLabelLData);
				queryRegexLabel.setText("Query regex:");
			}
			{
				FormData queryRegexTextLData = new FormData();
				queryRegexTextLData.width = 300;
				queryRegexTextLData.height = 19;
				queryRegexTextLData.left =  new FormAttachment(0, 1000, 105);
				queryRegexTextLData.top =  new FormAttachment(0, 1000, 87);
				queryRegexText = new Text(filterGroup, SWT.BORDER);
				queryRegexText.setLayoutData(queryRegexTextLData);
			}
			{
				responseCodeRegexLabel = new Label(filterGroup, SWT.WRAP);
				FormData responseCodeRegexLData = new FormData();
				responseCodeRegexLData.width = 82;
				responseCodeRegexLData.height = 37;
				responseCodeRegexLData.left =  new FormAttachment(0, 1000, 5);
				responseCodeRegexLData.top =  new FormAttachment(0, 1000, 119);
				responseCodeRegexLabel.setLayoutData(responseCodeRegexLData);
				responseCodeRegexLabel.setText("Response code regex:");
			}
			{
				FormData responseCodeRegexTextLData = new FormData();
				responseCodeRegexTextLData.width = 100;
				responseCodeRegexTextLData.height = 19;
				responseCodeRegexTextLData.left =  new FormAttachment(0, 1000, 105);
				responseCodeRegexTextLData.top =  new FormAttachment(0, 1000, 127);
				responseCodeRegexText = new Text(filterGroup, SWT.BORDER);
				responseCodeRegexText.setLayoutData(responseCodeRegexTextLData);
			}
		}
		{
			transactionSourceGroup = new Group(dialogShell, SWT.NONE);
			FormLayout transactionSourceGroupLayout = new FormLayout();
			transactionSourceGroup.setLayout(transactionSourceGroupLayout);
			FormData transactionSourceGroupLData = new FormData();
			transactionSourceGroupLData.width = 148;
			transactionSourceGroupLData.height = 328;
			transactionSourceGroupLData.left =  new FormAttachment(0, 1000, 5);
			transactionSourceGroupLData.top =  new FormAttachment(0, 1000, 5);
			transactionSourceGroup.setLayoutData(transactionSourceGroupLData);
			transactionSourceGroup.setText("Transaction Source");
			{
				fuzzerSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData fuzzerSourceCheckboxLData = new FormData();
				fuzzerSourceCheckboxLData.width = 67;
				fuzzerSourceCheckboxLData.height = 19;
				fuzzerSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				fuzzerSourceCheckboxLData.top =  new FormAttachment(0, 1000, 83);
				fuzzerSourceCheckbox.setLayoutData(fuzzerSourceCheckboxLData);
				fuzzerSourceCheckbox.setText("Fuzzer");
			}
			{
				allSourceButton = new Button(transactionSourceGroup, SWT.PUSH | SWT.CENTER);
				FormData allSourceButtonLData = new FormData();
				allSourceButtonLData.width = 40;
				allSourceButtonLData.height = 20;
				allSourceButtonLData.left = new FormAttachment(0, 1000, 10);
				allSourceButtonLData.top = new FormAttachment(0, 1000, 10);
				allSourceButton.setLayoutData(allSourceButtonLData);
				allSourceButton.setText("All");
				allSourceButton.addSelectionListener(new SelectionAdapter()
				{
					public void widgetSelected(SelectionEvent evt)
					{
						changeAllSources(true);
					}
				});
			}
			{
				noneSourceButton = new Button(transactionSourceGroup, SWT.PUSH | SWT.CENTER);
				noneSourceButton.setText("None");
				FormData noneSourceButtonLData = new FormData();
				noneSourceButtonLData.width = 40;
				noneSourceButtonLData.height = 20;
				noneSourceButtonLData.left = new FormAttachment(0, 1000, 65);
				noneSourceButtonLData.top = new FormAttachment(0, 1000, 10);
				noneSourceButton.setLayoutData(noneSourceButtonLData);
				noneSourceButton.addSelectionListener(new SelectionAdapter() 
				{
					public void widgetSelected(SelectionEvent evt) 
					{
						changeAllSources(false);
					}
				});
			}
			{
				proxySourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData proxySourceCheckboxLData = new FormData();
				proxySourceCheckboxLData.width = 59;
				proxySourceCheckboxLData.height = 19;
				proxySourceCheckboxLData.left = new FormAttachment(0, 1000, 5);
				proxySourceCheckboxLData.top = new FormAttachment(0, 1000, 37);
				proxySourceCheckbox.setLayoutData(proxySourceCheckboxLData);
				proxySourceCheckbox.setText("Proxy");
			}
			{
				manualRequestCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData manualRequestCheckboxLData = new FormData();
				manualRequestCheckboxLData.width = 122;
				manualRequestCheckboxLData.height = 19;
				manualRequestCheckboxLData.left = new FormAttachment(0, 1000, 5);
				manualRequestCheckboxLData.top = new FormAttachment(0, 1000, 61);
				manualRequestCheckbox.setLayoutData(manualRequestCheckboxLData);
				manualRequestCheckbox.setText("Manual request");
			}
			{
				spiderSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData spiderSourceCheckboxLData = new FormData();
				spiderSourceCheckboxLData.width = 65;
				spiderSourceCheckboxLData.height = 19;
				spiderSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				spiderSourceCheckboxLData.top =  new FormAttachment(0, 1000, 107);
				spiderSourceCheckbox.setLayoutData(spiderSourceCheckboxLData);
				spiderSourceCheckbox.setText("Spider");
			}
			{
				testSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData testSourceCheckboxLData = new FormData();
				testSourceCheckboxLData.width = 83;
				testSourceCheckboxLData.height = 19;
				testSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				testSourceCheckboxLData.top =  new FormAttachment(0, 1000, 131);
				testSourceCheckbox.setLayoutData(testSourceCheckboxLData);
				testSourceCheckbox.setText("Scan test");
			}
			{
				enumerationSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData enumerationSourceCheckboxLData = new FormData();
				enumerationSourceCheckboxLData.width = 129;
				enumerationSourceCheckboxLData.height = 19;
				enumerationSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				enumerationSourceCheckboxLData.top =  new FormAttachment(0, 1000, 155);
				enumerationSourceCheckbox.setLayoutData(enumerationSourceCheckboxLData);
				enumerationSourceCheckbox.setText("File enumeration");
			}
			{
				baseUrlCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData baseUrlCheckboxLData = new FormData();
				baseUrlCheckboxLData.width = 88;
				baseUrlCheckboxLData.height = 19;
				baseUrlCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				baseUrlCheckboxLData.top =  new FormAttachment(0, 1000, 179);
				baseUrlCheckbox.setLayoutData(baseUrlCheckboxLData);
				baseUrlCheckbox.setText("Base URL");
			}
			{
				authenticationSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData authenticationSourceCheckboxLData = new FormData();
				authenticationSourceCheckboxLData.width = 114;
				authenticationSourceCheckboxLData.height = 19;
				authenticationSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				authenticationSourceCheckboxLData.top =  new FormAttachment(0, 1000, 203);
				authenticationSourceCheckbox.setLayoutData(authenticationSourceCheckboxLData);
				authenticationSourceCheckbox.setText("Authentication");
			}
			{
				niktoSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData niktoSourceCheckboxLData = new FormData();
				niktoSourceCheckboxLData.width = 56;
				niktoSourceCheckboxLData.height = 19;
				niktoSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				niktoSourceCheckboxLData.top =  new FormAttachment(0, 1000, 227);
				niktoSourceCheckbox.setLayoutData(niktoSourceCheckboxLData);
				niktoSourceCheckbox.setText("Nikto");
			}
			{
				categorizerSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData categorizerSourceCheckboxLData = new FormData();
				categorizerSourceCheckboxLData.width = 97;
				categorizerSourceCheckboxLData.height = 19;
				categorizerSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				categorizerSourceCheckboxLData.top =  new FormAttachment(0, 1000, 251);
				categorizerSourceCheckbox.setLayoutData(categorizerSourceCheckboxLData);
				categorizerSourceCheckbox.setText("Categorizer");
			}
			{
				overrideSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData overrideSourceCheckboxLData = new FormData();
				overrideSourceCheckboxLData.width = 111;
				overrideSourceCheckboxLData.height = 19;
				overrideSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				overrideSourceCheckboxLData.top =  new FormAttachment(0, 1000, 275);
				overrideSourceCheckbox.setLayoutData(overrideSourceCheckboxLData);
				overrideSourceCheckbox.setText("404-detection");
			}
			{
				cobraSourceCheckbox = new Button(transactionSourceGroup, SWT.CHECK | SWT.LEFT);
				FormData cobraSourceCheckboxLData = new FormData();
				cobraSourceCheckboxLData.width = 62;
				cobraSourceCheckboxLData.height = 19;
				cobraSourceCheckboxLData.left =  new FormAttachment(0, 1000, 5);
				cobraSourceCheckboxLData.top =  new FormAttachment(0, 1000, 299);
				cobraSourceCheckbox.setLayoutData(cobraSourceCheckboxLData);
				cobraSourceCheckbox.setText("Cobra");
			}
		}
		
	}
	
	private void changeAllSources(boolean selected)
	{
		manualRequestCheckbox.setSelection(selected);
		proxySourceCheckbox.setSelection(selected);
		authenticationSourceCheckbox.setSelection(selected);
		baseUrlCheckbox.setSelection(selected);
		categorizerSourceCheckbox.setSelection(selected);
		cobraSourceCheckbox.setSelection(selected);
		enumerationSourceCheckbox.setSelection(selected);
		niktoSourceCheckbox.setSelection(selected);
		overrideSourceCheckbox.setSelection(selected);
		spiderSourceCheckbox.setSelection(selected);
		testSourceCheckbox.setSelection(selected);
		fuzzerSourceCheckbox.setSelection(selected);
	}
	
	private void okButtonWidgetSelected(SelectionEvent evt) 
	{
		String message = "";
		if (badPattern(hostRegexText.getText()))
		{
			message += "- Invalid host regular expression\n";
		}
		if (badPattern(pathRegexText.getText()))
		{
			message += "- Invalid path regular expression\n";
		}
		if (badPattern(queryRegexText.getText()))
		{
			message += "- Invalid query regular expression\n";
		}
		if (badPattern(responseCodeRegexText.getText()))
		{
			message += "- Invalid response code regular expression\n";
		}
		
		if (message != "")
		{
			MessageBox messageBox = new MessageBox(getParent().getShell(), SWT.OK);
			messageBox.setMessage(message);
			messageBox.setText("Error");
			messageBox.open();
		}
		else
		{
			if (!(
					existingSettings.getHostPattern().equals(hostRegexText.getText())
					&& existingSettings.getPathPattern().equals(pathRegexText.getText())
					&& existingSettings.getQueryPattern().equals(queryRegexText.getText())
					&& existingSettings.getResponseCodePattern().equals(responseCodeRegexText.getText())
					&& existingSettings.maxRecords == Integer.valueOf(maxRecordsText.getText())
					&& existingSettings.updateFrequency == Integer.valueOf(updateFrequencyText.getText())
					&& existingSettings.tail == tailCheckbox.getSelection()
					
					&& authenticationSourceCheckbox.getSelection() ==  
						existingSettings.containsSource(TransactionSource.AUTHENTICATION)
					&& overrideSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.AUTOMATIC_RESPONSE_CODE_OVERRIDES)
					&& baseUrlCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.BASE)
					&& categorizerSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.CATEGORIZER)
					&& cobraSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.COBRA)
					&& enumerationSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.ENUMERATION)
					&& fuzzerSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.FUZZER)
					&& manualRequestCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.MANUAL_REQUEST)
					&& niktoSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.NIKTO)
					&& proxySourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.PROXY)
					&& spiderSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.SPIDER)
					&& testSourceCheckbox.getSelection() ==
						existingSettings.containsSource(TransactionSource.TEST)
			))
			{
				changed = true;

				existingSettings.setHostPattern(hostRegexText.getText());
				existingSettings.setPathPattern(pathRegexText.getText());
				existingSettings.setQueryPattern(queryRegexText.getText());
				existingSettings.setResponseCodePattern(responseCodeRegexText.getText());
				existingSettings.maxRecords = Integer.valueOf(maxRecordsText.getText());
				existingSettings.updateFrequency = Integer.valueOf(updateFrequencyText.getText());
				existingSettings.tail = tailCheckbox.getSelection();
				
				existingSettings.clearSources();

				if (proxySourceCheckbox.getSelection())
					existingSettings.addSource(TransactionSource.PROXY);
				if (manualRequestCheckbox.getSelection())
					existingSettings.addSource(TransactionSource.MANUAL_REQUEST);

				if (!existingSettings.tail)
                {
					if (spiderSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.SPIDER);
	                if (authenticationSourceCheckbox.getSelection())
	                	existingSettings.addSource(TransactionSource.AUTHENTICATION);
					if (overrideSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.AUTOMATIC_RESPONSE_CODE_OVERRIDES);
					if (baseUrlCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.BASE);
					if (categorizerSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.CATEGORIZER);
					if (cobraSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.COBRA);
					if (enumerationSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.ENUMERATION);
					if (fuzzerSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.FUZZER);
					if (niktoSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.NIKTO);
					if (testSourceCheckbox.getSelection())
						existingSettings.addSource(TransactionSource.TEST);
                  }
			
			}
			

			dialogShell.close();
		}
	}
	
	private boolean badPattern(String pattern)
	{
		boolean bad = false;
		try
		{
			Pattern.compile(pattern);
		}
		catch (Exception e) 
		{
			bad = true;
		}
		return bad;
	}
	


	private void enableNonTailSettings(boolean enabled)
	{
		authenticationSourceCheckbox.setEnabled(enabled);
		baseUrlCheckbox.setEnabled(enabled);
		categorizerSourceCheckbox.setEnabled(enabled);
		cobraSourceCheckbox.setEnabled(enabled);
		enumerationSourceCheckbox.setEnabled(enabled);
		fuzzerSourceCheckbox.setEnabled(enabled);
		niktoSourceCheckbox.setEnabled(enabled);
		overrideSourceCheckbox.setEnabled(enabled);
		spiderSourceCheckbox.setEnabled(enabled);
		testSourceCheckbox.setEnabled(enabled);
		
		updateFrequencyLabel.setEnabled(!enabled);
		updateFrequencyText.setEnabled(!enabled);

	}

	private void loadDefaults()
	{
		changeAllSources(false);
		hostRegexText.setText("");
		pathRegexText.setText("");
		queryRegexText.setText("");
		responseCodeRegexText.setText("");
		enableNonTailSettings(true);
		tailCheckbox.setSelection(false);
		maxRecordsText.setText("1000");
		updateFrequencyText.setText("5000");
	}
}
