package com.grendelscan.GUI.http.interception;

public enum InterceptFilterLocation  
{
	METHOD("Method"), URL("URL"), SCHEME("Scheme"), HOST("Host"), PATH("Path and filename"), 
	QUERY("URL Query"), COOKIE_HEADER("Cookie header"), REQUEST_HEADER_NAME("Request header name"), 
	REQUEST_HEADER_VALUE("Request header value"),
	REQUEST_BODY("Request body"),
	
	RESPONSE_CODE("Response code"), RESPONSE_BODY("Response body"), 
	RESPONSE_HEADER_NAME("Response header name"), RESPONSE_HEADER_VALUE("Response header value"),
	RESPONSE_MIME_TYPE("Response MIME type");
	
	private String text;
	
	private InterceptFilterLocation(String text)
    {
	    this.text = text;
    }

	public String getText()
    {
    	return text;
    }
	
	public static InterceptFilterLocation[] getRequestLocations()
	{
		return new InterceptFilterLocation[] {
				InterceptFilterLocation.METHOD,
				InterceptFilterLocation.URL,
				InterceptFilterLocation.SCHEME,
				InterceptFilterLocation.HOST,
				InterceptFilterLocation.PATH,
				InterceptFilterLocation.QUERY,
				InterceptFilterLocation.COOKIE_HEADER,
				InterceptFilterLocation.REQUEST_HEADER_VALUE,
				InterceptFilterLocation.REQUEST_BODY,
				InterceptFilterLocation.REQUEST_HEADER_NAME
				};
	}

	public static InterceptFilterLocation[] getResponseLocations()
	{
		return new InterceptFilterLocation[] {
				InterceptFilterLocation.RESPONSE_CODE,
				InterceptFilterLocation.RESPONSE_BODY,
				InterceptFilterLocation.RESPONSE_HEADER_NAME,
				InterceptFilterLocation.RESPONSE_HEADER_VALUE,
				InterceptFilterLocation.RESPONSE_MIME_TYPE
				};
	}
	
	public static InterceptFilterLocation[] getAllLocations()
	{
		return new InterceptFilterLocation[] {
				InterceptFilterLocation.METHOD,
				InterceptFilterLocation.URL,
				InterceptFilterLocation.SCHEME,
				InterceptFilterLocation.HOST,
				InterceptFilterLocation.PATH,
				InterceptFilterLocation.QUERY,
				InterceptFilterLocation.COOKIE_HEADER,
				InterceptFilterLocation.REQUEST_HEADER_VALUE,
				InterceptFilterLocation.REQUEST_BODY,
				InterceptFilterLocation.REQUEST_HEADER_NAME,
				
				InterceptFilterLocation.RESPONSE_CODE,
				InterceptFilterLocation.REQUEST_BODY,
				InterceptFilterLocation.RESPONSE_HEADER_NAME,
				InterceptFilterLocation.RESPONSE_HEADER_VALUE,
				InterceptFilterLocation.RESPONSE_MIME_TYPE
				};
		
	}

}
