package com.grendelscan.GUI.http.interception;
import java.io.File;

import com.grendelscan.GrendelScan;
import com.grendelscan.scan.*;

import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpResponse;
import org.apache.http.StatusLine;
import org.apache.http.entity.ByteArrayEntity;
import org.apache.http.message.*;
import org.apache.http.util.EntityUtils;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.graphics.Image;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;
import com.grendelscan.GUI.http.*;
import com.grendelscan.requester.TransactionSource;
import com.grendelscan.requester.http.transactions.*;
import com.grendelscan.requester.http.wrappers.HttpResponseWrapper;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class InterceptionComposite extends org.eclipse.swt.widgets.Composite {
	private Button acceptButton;
	private Button abortButton;
	private Button release;
	private AbstractHttpTransaction transaction;

	private boolean requestOnly;
	private TransactionComposite transactionComposite;
	private Button interceptResponsesButton;
	private Button interceptRequestsButton;
	private boolean changed = false;
	private Scan scan;
	
	public boolean isChanged()
    {
    	return changed;
    }

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		InterceptionComposite inst = new InterceptionComposite(shell, SWT.NULL, null, null, false);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	
	private static class InterceptJob implements Runnable
	{
		Scan scan;
		AbstractHttpTransaction transaction;
		boolean requestOnly;
		boolean changed;
		
		public InterceptJob(Scan scan, AbstractHttpTransaction transaction, boolean requestOnly)
        {
	        super();
	        this.requestOnly = requestOnly;
	        this.scan = scan;
	        this.transaction = transaction;
        }

		public void run()
		{
			Display display = Display.getDefault();
			Shell shell = new Shell(display);
			Image icon = new Image(display, GrendelScan.defaultConfigDirectory + File.separator + "icon.JPG");
			shell.setImage(icon);
			if (requestOnly)
			{
				shell.setText(GrendelScan.versionText + " - Request intercept");
			}
			else
			{
				shell.setText(GrendelScan.versionText + " - Response intercept");
			}
				
			InterceptionComposite inst = new InterceptionComposite(shell, SWT.NULL, scan, transaction, requestOnly);
			Point size = inst.getSize();
			shell.setLayout(new FillLayout());
			shell.layout();
			if(size.x == 0 && size.y == 0) {
				inst.pack();
				shell.pack();
			} else {
				Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
				shell.setSize(shellBounds.width, shellBounds.height);
			}
			shell.open();
			while (!shell.isDisposed()) {
				if (!display.readAndDispatch())
					display.sleep();
			}
			this.transaction = inst.transaction;
			this.changed = inst.isChanged();
		}
	}
	
	public static AbstractHttpTransaction showRequestIntercept(Scan scan, AbstractHttpTransaction transaction) 
	{
		Display display = Display.getDefault();
		InterceptJob interceptJob = new InterceptJob(scan, transaction, true);
		display.syncExec(interceptJob);
		return interceptJob.transaction;
	}

	public static boolean showResponseIntercept(Scan scan, AbstractHttpTransaction transaction) 
	{
		Display display = Display.getDefault();
		InterceptJob interceptJob = new InterceptJob(scan, transaction, false);
		display.syncExec(interceptJob);
		return interceptJob.changed;
	}

	
	private InterceptionComposite(Composite parent, int style, Scan scan, AbstractHttpTransaction transaction, boolean requestOnly) 
	{
		super(parent, style);
		this.transaction = transaction;
		this.requestOnly = requestOnly;
		this.scan = scan;
		initGUI();
	}

	private void initGUI() 
	{
		try 
		{
			this.setLayout(new FormLayout());
			this.setSize(850, 650);
			{
				interceptRequestsButton = new Button(this, SWT.CHECK | SWT.LEFT);
				FormData interceptRequestsButtonLData = new FormData();
				interceptRequestsButtonLData.width = 138;
				interceptRequestsButtonLData.height = 19;
				interceptRequestsButtonLData.left =  new FormAttachment(0, 1000, 5);
				interceptRequestsButtonLData.top =  new FormAttachment(0, 1000, 5);
				interceptRequestsButton.setLayoutData(interceptRequestsButtonLData);
				interceptRequestsButton.setText("Intercept requests");
				interceptRequestsButton.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) 
					{
						scan.getScanStatusWindow().changeEnableInterceptRequestCheck(interceptRequestsButton.getSelection());
					}
				});
				interceptRequestsButton.setSelection(scan.getScanSettings().isInterceptRequests());
			}
			{
				interceptResponsesButton = new Button(this, SWT.CHECK | SWT.LEFT);
				FormData interceptResponsesButtonLData = new FormData();
				interceptResponsesButtonLData.width = 149;
				interceptResponsesButtonLData.height = 19;
				interceptResponsesButtonLData.left =  new FormAttachment(0, 1000, 155);
				interceptResponsesButtonLData.top =  new FormAttachment(0, 1000, 5);
				interceptResponsesButton.setLayoutData(interceptResponsesButtonLData);
				interceptResponsesButton.setText("Intercept responses");
				interceptResponsesButton.setSelection(scan.getScanSettings().isInterceptResponses());
				interceptResponsesButton.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) 
					{
						scan.getScanStatusWindow().changeEnableInterceptResponseCheck(interceptResponsesButton.getSelection());
					}
				});
			}
			{
				if (requestOnly)
				{
					transactionComposite = new TransactionComposite(this, SWT.NONE, true, false, false, false);
					transactionComposite.updateRequestData(transaction.requestToString());
				}
				else
				{
					transactionComposite = new TransactionComposite(this, SWT.NONE, false, true, true, false);
					transactionComposite.updateTransactionData(transaction.requestToString(), transaction.responseToString().getBytes());
				}
				FormData transactionCompositeLData = new FormData();
//				transactionCompositeLData.width = 707;
//				transactionCompositeLData.height = 586;
				transactionCompositeLData.left =  new FormAttachment(0, 1000, 0);
				transactionCompositeLData.right =  new FormAttachment(1000, 1000, 0);
				transactionCompositeLData.top =  new FormAttachment(35, 1000, 0);
				transactionCompositeLData.bottom =  new FormAttachment(1000, 1000, -45);
				transactionComposite.setLayoutData(transactionCompositeLData);
			}
			{
				release = new Button(this, SWT.PUSH | SWT.CENTER);
				FormData releaseLData = new FormData();
				releaseLData.width = 141;
				releaseLData.height = 27;
				releaseLData.left =  new FormAttachment(0, 1000, 139);
				releaseLData.bottom =  new FormAttachment(1000, 1000, -5);
				release.setLayoutData(releaseLData);
				release.setText("Release Unchanged");
				release.addSelectionListener(new SelectionAdapter() 
				{
					public void widgetSelected(SelectionEvent evt) 
					{
						getParent().dispose();
					}
				});
			}
			{
				abortButton = new Button(this, SWT.PUSH | SWT.CENTER);
				FormData abortButtonLData = new FormData();
				abortButtonLData.width = 125;
				abortButtonLData.height = 27;
				abortButtonLData.left =  new FormAttachment(0, 1000, 292);
				abortButtonLData.bottom =  new FormAttachment(1000, 1000, -5);
				abortButton.setLayoutData(abortButtonLData);
				abortButton.setText("Abort Transaction");
				abortButton.addSelectionListener(new SelectionAdapter() 
				{
					public void widgetSelected(SelectionEvent evt) 
					{
						abortTransaction();
					}
				});
			}
			{
				acceptButton = new Button(this, SWT.PUSH | SWT.CENTER);
				FormData acceptButtonLData = new FormData();
				acceptButtonLData.width = 115;
				acceptButtonLData.height = 27;
				acceptButtonLData.left =  new FormAttachment(0, 1000, 12);
				acceptButtonLData.bottom =  new FormAttachment(1000, 1000, -5);
				acceptButton.setLayoutData(acceptButtonLData);
				acceptButton.setText("Accept Changes");
				acceptButton.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						acceptButtonWidgetSelected(evt);
					}
				});
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void acceptButtonWidgetSelected(SelectionEvent evt)  
	{
		try
		{
			if (requestOnly)
			{
				transaction = new UnvalidatedHttpTransaction(scan, 0, TransactionSource.PROXY, transactionComposite.getRequestBody(), transactionComposite.makeHttpRequest(scan));
			}
			else
			{
				transaction.setResponseWrapper(transactionComposite.makeHttpResponseWrapper(scan));
			}
			changed = true;
			getParent().dispose();
		}
		catch(HttpFormatException e)
		{
	        MessageBox m = new MessageBox(getShell(), SWT.OK | SWT.WRAP);
	        m.setText("Invalid message format");
	        m.setMessage("The format of the HTTP message is invalid. Future versions of Grendel-Scan will support " +
	        		"arbitrary request formats. For now, please use a format that resembles RFC 2616.\n" +
	        		"\n" +
	        		"The error message was: " + e.toString());
	        m.open();
		}
	}

	private void abortTransaction()
	{
		changed = true;
		
		HttpResponseWrapper responseWrapper = new HttpResponseWrapper(scan, 500, "Transaction aborted", 
				"HTTP", 1, 1, new Header[] {new BasicHeader("Content-Type", "text/html")}, 
				("<html><title>Transaction Aborted</title><body>This transaction was aborted by the user.<br>\n<br>\n<br>\n" +
				transaction.toString().replaceAll("\n", "<br>\n") + "</body></html>").getBytes());
		transaction.setResponseWrapper(responseWrapper);
		getParent().dispose();
	}
}
