package com.grendelscan.GUI.http.interception;
import java.util.*;
import java.util.List;
import java.util.regex.*;
import org.eclipse.swt.layout.FillLayout;
import org.eclipse.swt.layout.FormAttachment;
import org.eclipse.swt.layout.FormData;
import org.eclipse.swt.layout.FormLayout;
import org.eclipse.swt.widgets.*;
import org.eclipse.swt.graphics.Point;
import org.eclipse.swt.graphics.Rectangle;
import org.eclipse.swt.SWT;
import org.eclipse.swt.custom.*;
import org.eclipse.swt.events.SelectionAdapter;
import org.eclipse.swt.events.SelectionEvent;

/**
* This code was edited or generated using CloudGarden's Jigloo
* SWT/Swing GUI Builder, which is free for non-commercial
* use. If Jigloo is being used commercially (ie, by a corporation,
* company or business for any purpose whatever) then you
* should purchase a license for each developer using Jigloo.
* Please visit www.cloudgarden.com for details.
* Use of Jigloo implies acceptance of these licensing terms.
* A COMMERCIAL LICENSE HAS NOT BEEN PURCHASED FOR
* THIS MACHINE, SO JIGLOO OR THIS CODE CANNOT BE USED
* LEGALLY FOR ANY CORPORATE OR COMMERCIAL PURPOSE.
*/
public class InterceptionSettingsComposite extends ScrolledComposite {

	private Combo componentCombo;
	private Combo matchesCombo;
	private Button resetButton;
	private Button addButton;
	private Button removeButton;
	private Table criteriaTable;
	private Label thenLabel;
	private Label ifLabel;
	private Combo actionCombo;
	private Text patternText;
	private final String MATCHES = "matches";
	private final String DOESNT_MATCH = "doesn't match";

	private final String INTERCEPT;
	private final String DONT_INTERCEPT;
	private TableColumn actionColumn;
	private TableColumn valueColumn;
	private TableColumn relationColumn;
	private TableColumn componentColumn;
	private boolean fuzzing;
	
	private final List<InterceptFilter> filterList;

	/**
	* Auto-generated main method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void main(String[] args) {
		showGUI();
	}
		
	/**
	* Auto-generated method to display this 
	* org.eclipse.swt.widgets.Composite inside a new Shell.
	*/
	public static void showGUI() {
		Display display = Display.getDefault();
		Shell shell = new Shell(display);
		InterceptFilterLocation[] locations = InterceptFilterLocation.getRequestLocations();
		List<InterceptFilter> filters = new ArrayList<InterceptFilter>(1);		
		InterceptionSettingsComposite inst = new InterceptionSettingsComposite(shell, SWT.NULL, locations, filters);
		Point size = inst.getSize();
		shell.setLayout(new FillLayout());
		shell.layout();
		if(size.x == 0 && size.y == 0) {
			inst.pack();
			shell.pack();
		} else {
			Rectangle shellBounds = shell.computeTrim(0, 0, size.x, size.y);
			shell.setSize(shellBounds.width, shellBounds.height);
		}
		shell.open();
		while (!shell.isDisposed()) {
			if (!display.readAndDispatch())
				display.sleep();
		}
	}

	public InterceptionSettingsComposite(org.eclipse.swt.widgets.Composite parent, int style, InterceptFilterLocation[] locations, final List<InterceptFilter> filterList)
	{
		this(parent, style, locations, filterList, false);
	}
	
	public InterceptionSettingsComposite(org.eclipse.swt.widgets.Composite parent, int style, InterceptFilterLocation[] locations, final List<InterceptFilter> filterList, boolean fuzzing)
	{
		super(parent, style | SWT.V_SCROLL | SWT.H_SCROLL);
		this.fuzzing = fuzzing;
		if (fuzzing)
		{
			INTERCEPT = "is a match";
			DONT_INTERCEPT = "isn't a match";
		}
		else
		{
			INTERCEPT = "intercept";
			DONT_INTERCEPT = "don't intercept";
		}
		this.filterList = filterList;
		initGUI(locations);
		for (InterceptFilter filter: filterList)
		{
			TableItem item = new TableItem(criteriaTable, SWT.NONE);
			item.setText(new String[] {filter.getLocation().getText(), filter.isMatches() ? MATCHES : DOESNT_MATCH,
					filter.getPattern().pattern(), filter.isIntercept() ? INTERCEPT : DONT_INTERCEPT});
		}
	}


	private void initGUI(InterceptFilterLocation[] locations) {
		try {
			this.setLayout(new FillLayout(org.eclipse.swt.SWT.HORIZONTAL));
			this.setSize(780, 180);
			this.setMinSize(780, 180);
			this.setExpandHorizontal(true);
			this.setExpandVertical(true);
			
			Composite mainComposite = new Composite(this, SWT.NONE);
			mainComposite.setLayout(new FormLayout());
			this.setContent(mainComposite);
			{
				ifLabel = new Label(mainComposite, SWT.NONE);
				FormData ifLabelLData = new FormData();
				ifLabelLData.width = 8;
				ifLabelLData.height = 25;
				ifLabelLData.left =  new FormAttachment(0, 1000, 5);
				ifLabelLData.top =  new FormAttachment(0, 1000, 7);
				ifLabel.setLayoutData(ifLabelLData);
				ifLabel.setText("If");
			}
			{
				FormData componentComboLData = new FormData();
				componentComboLData.width = 151;
				componentComboLData.height = 25;
				componentComboLData.left =  new FormAttachment(0, 1000, 19);
				componentComboLData.top =  new FormAttachment(0, 1000, 5);
				componentCombo = new Combo(mainComposite, SWT.READ_ONLY);
				componentCombo.setLayoutData(componentComboLData);
				for (InterceptFilterLocation location: locations)
				{
					componentCombo.add(location.getText());
					componentCombo.setData(location.getText(), location);
				}
				componentCombo.setText(componentCombo.getItem(0));
			}
			{
				FormData matchesComboLData = new FormData();
				matchesComboLData.width = 102;
				matchesComboLData.height = 25;
				matchesComboLData.left =  new FormAttachment(0, 1000, 213);
				matchesComboLData.top =  new FormAttachment(0, 1000, 5);
				matchesCombo = new Combo(mainComposite, SWT.READ_ONLY);
				
				matchesCombo.setLayoutData(matchesComboLData);
				matchesCombo.setItems(new String[] {MATCHES, DOESNT_MATCH});
				matchesCombo.setText(matchesCombo.getItem(0));
			}
			{
				FormData patternTextLData = new FormData();
				patternTextLData.width = 236;
				patternTextLData.height = 19;
				patternTextLData.left =  new FormAttachment(0, 1000, 359);
				patternTextLData.top =  new FormAttachment(0, 1000, 5);
				patternTextLData.right =  new FormAttachment(1000, 1000, -179);
				patternText = new Text(mainComposite, SWT.BORDER);
				patternText.setLayoutData(patternTextLData);
			}
			{
				thenLabel = new Label(mainComposite, SWT.NONE);
				FormData thenLabelLData = new FormData();
				thenLabelLData.width = 33;
				thenLabelLData.height = 25;
				thenLabelLData.top =  new FormAttachment(0, 1000, 5);
				thenLabelLData.right =  new FormAttachment(1000, 1000, -140);
				thenLabel.setLayoutData(thenLabelLData);
				thenLabel.setText("then");
			}
			{
				FormData actionComboLData = new FormData();
				actionComboLData.width = 93;
				actionComboLData.height = 25;
				actionComboLData.top =  new FormAttachment(0, 1000, 5);
				actionComboLData.right =  new FormAttachment(1000, 1000, -5);
				actionCombo = new Combo(mainComposite, SWT.READ_ONLY);
				actionCombo.setLayoutData(actionComboLData);
				actionCombo.setItems(new String[] {INTERCEPT, DONT_INTERCEPT});
				actionCombo.setText(actionCombo.getItem(0));
			}
			{
				resetButton = new Button(mainComposite, SWT.PUSH | SWT.CENTER);
				FormData resetButtonLData = new FormData();
				resetButtonLData.width = 60;
				resetButtonLData.height = 27;
				resetButtonLData.top =  new FormAttachment(0, 1000, 42);
				resetButtonLData.right =  new FormAttachment(1000, 1000, -172);
				resetButton.setLayoutData(resetButtonLData);
				resetButton.setText("Reset");
				resetButton.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						resetButtonWidgetSelected(evt);
					}
				});
			}
			{
				addButton = new Button(mainComposite, SWT.PUSH | SWT.CENTER);
				FormData addButtonLData = new FormData();
				addButtonLData.width = 68;
				addButtonLData.height = 27;
				addButtonLData.top =  new FormAttachment(0, 1000, 42);
				addButtonLData.right =  new FormAttachment(1000, 1000, -92);
				addButton.setLayoutData(addButtonLData);
				addButton.setText("Add");
				addButton.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						addButtonWidgetSelected(evt);
					}
				});
			}
			{
				removeButton = new Button(mainComposite, SWT.PUSH | SWT.CENTER);
				FormData removeButtonLData = new FormData();
				removeButtonLData.width = 75;
				removeButtonLData.height = 27;
				removeButtonLData.top =  new FormAttachment(0, 1000, 42);
				removeButtonLData.right =  new FormAttachment(1000, 1000, -5);
				removeButton.setLayoutData(removeButtonLData);
				removeButton.setText("Remove");
				removeButton.addSelectionListener(new SelectionAdapter() {
					public void widgetSelected(SelectionEvent evt) {
						removeButtonWidgetSelected(evt);
					}
				});
			}
			{
				FormData criteriaTableLData = new FormData();
				criteriaTableLData.width = 737;
				criteriaTableLData.height = 187;
				criteriaTableLData.left =  new FormAttachment(0, 1000, 7);
				criteriaTableLData.top =  new FormAttachment(0, 1000, 81);
				criteriaTableLData.bottom =  new FormAttachment(1000, 1000, -5);
				criteriaTableLData.right =  new FormAttachment(1000, 1000, -5);
				criteriaTable = new Table(mainComposite, SWT.FULL_SELECTION | SWT.BORDER);
				criteriaTable.setLayoutData(criteriaTableLData);
				criteriaTable.setHeaderVisible(true);
				{
					componentColumn = new TableColumn(criteriaTable, SWT.NONE);
					componentColumn.setText("Component");
					componentColumn.setWidth(170);
				}
				{
					relationColumn = new TableColumn(criteriaTable, SWT.NONE);
					relationColumn.setText("Relation");
					relationColumn.setWidth(100);
				}
				{
					valueColumn = new TableColumn(criteriaTable, SWT.NONE);
					valueColumn.setText("Value");
					valueColumn.setWidth(370);
				}
				{
					actionColumn = new TableColumn(criteriaTable, SWT.NONE);
					actionColumn.setText("Action");
					actionColumn.setWidth(120);
				}
			}
			this.layout();
		} catch (Exception e) {
			e.printStackTrace();
		}
	}
	
	private void addButtonWidgetSelected(SelectionEvent evt) 
	{
		boolean good = true;
		String messageText = "";
		String pattern = patternText.getText();
		try
		{
			Pattern.compile(pattern);
		}
		catch (Exception e) 
		{
			good = false;
			messageText = "Invalid regular expression format: " + e.toString();
		}
		
		if (patternText.getText().equals(""))
		{
			messageText += "This argument will match all transactions.\n";
		}
		if (! messageText.equals(""))
		{
			MessageBox m = new MessageBox(getShell(), SWT.OK);
			m.setMessage(messageText);
			m.setText("Warning");
			m.open();
		}
		if (good)
		{
//			TableItem item = new TableItem(criteriaTable, SWT.NONE);
			addFilter((InterceptFilterLocation)componentCombo.getData(componentCombo.getText()), pattern,
					this.matchesCombo.getText().equals(MATCHES) ? true : false, this.actionCombo.getText().equals(INTERCEPT) ? true : false);
			patternText.setText("");
		}
	}
	
	public void addFilter(InterceptFilterLocation location, String patternString, boolean matches, boolean intercept)
	{
		TableItem item = new TableItem(criteriaTable, SWT.NONE);
		item.setText(new String[] {location.getText(), matches ? MATCHES : DOESNT_MATCH,
				patternString, intercept ? INTERCEPT : DONT_INTERCEPT});
		InterceptFilter filter = new InterceptFilter(location, patternString, matches, intercept);
		item.setData(filter);
		filterList.add(filter);
	}
	
	private void removeButtonWidgetSelected(SelectionEvent evt) 
	{
		int index = criteriaTable.getSelectionIndex();
		if (index >= 0)
		{
			TableItem item = criteriaTable.getItem(index);
			filterList.remove((InterceptFilter)item.getData());
			componentCombo.setText(item.getText(0));
			matchesCombo.setText(item.getText(1));
			patternText.setText(item.getText(2));
			actionCombo.setText(item.getText(3));
			criteriaTable.remove(index);
			item.dispose();
		}
	}
	 
	private void resetButtonWidgetSelected(SelectionEvent evt) 
	{
		TableItem items[] =  criteriaTable.getItems();
		
		for (TableItem item: items)
        {
			InterceptFilter data = (InterceptFilter)item.getData();
			filterList.remove(data);
	        item.dispose();
        }
		criteriaTable.removeAll();
	}

	@Override
    public void setEnabled(boolean enabled)
    {
	    super.setEnabled(enabled);
	    componentCombo.setEnabled(enabled);
	    matchesCombo.setEnabled(enabled);
	    resetButton.setEnabled(enabled);
	    addButton.setEnabled(enabled);
	    removeButton.setEnabled(enabled);
	    criteriaTable.setEnabled(enabled);
	    thenLabel.setEnabled(enabled);
	    actionCombo.setEnabled(enabled);
	    patternText.setEnabled(enabled);
	    ifLabel.setEnabled(enabled);
    }

}
