/*
 * GrendelScan.java
 * 
 */

package com.grendelscan;
import com.grendelscan.GUI.*;
import java.io.File;
import java.io.FileNotFoundException;

import com.grendelscan.GUI.ScanSettingsWindow;
import com.grendelscan.GUI.ScanStatusWindow;
import com.grendelscan.scan.ConfigurationManager;
import com.grendelscan.scan.Scan;
import com.grendelscan.scan.ScanSettings;
import com.grendelscan.utils.Debug;

/**
 * 
 * This is the main class for the program. 
 * 
 * @author David Byrne
 * 
 */
public class GrendelScan
{
	public static final String defaultConfigDirectory = "conf";
	private static Scan scan;
	private static ScanSettings scanSettings;
	public static final String version = "v1.0";
	public static final String versionText = "Grendel-Scan " + version;
	
	
	public static void main(String[] args)
	{
		
		ConfigurationManager.initializeConfiguration(defaultConfigDirectory + File.separator + "scanner.conf");
		scanSettings = new ScanSettings();
		scan = new Scan(scanSettings);
		try
		{
			scanSettings.loadModules(scan);
		}
		catch (FileNotFoundException e)
		{
			Debug.errDebug("Modules not found: " + e.toString(), e);
			System.exit(1);
		}
		scanSettings.loadDefaultSettings(scan);
		ScanSettingsWindow.showScanGUI(scan);
		ScanStatusWindow.showGUI(scan);
	}
	
	
}
