package com.grendelscan.categorizers;


import java.util.HashSet;
import java.util.Map;
import java.util.Set;

import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.scan.Scan;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;
public abstract class Categorizer
{
	public static String categoryName;

	protected Scan scan;

	/** Creates a new instance of categorizer */
	public Categorizer()
	{

	}
	
	public abstract boolean hasModules();
	
	protected void addJobToCollection(TestJob testJob, TestModule module, Map<TestModule, Set<TestJob>> tests) 
	{
		if (!tests.containsKey(module))
		{
			Set<TestJob> testSet = new HashSet<TestJob>();
			tests.put(module, testSet);
		}
		tests.get(module).add(testJob);
	}
	
	public abstract void resolveDependencies();

	public abstract void addModule(TestModule module);

	/**
	 * @param sharedComponents
	 *            the sharedComponents to set
	 */
	public void setScan(Scan scan)
	{
		this.scan = scan;
	}
}
