package com.grendelscan.categorizers;

import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;


/**
 * The type strings are not case-sensitive.
 * 
 * @author David Byrne
 * 
 */
public abstract class MultiSetTransactionCategorizer extends MultiSetCategorizer implements TransactionCategorizer
{
	public MultiSetTransactionCategorizer(String categoryTestClass)
	{
		super(categoryTestClass);
	}

	public Map<TestModule, Set<TestJob>> analyzeTransaction(AbstractHttpTransaction transaction)
	{
		Map<TestModule, Set<TestJob>> tests = new HashMap<TestModule, Set<TestJob>>();
		for (String type: getTransactionTypeStrings(transaction))
		{
			type = type.toUpperCase();
			if (modulesByType.containsKey(type))
			{
				for (TestModule module: modulesByType.get(type))
				{
					TestJob testJob = makeTestJob(transaction, module, type);
					addJobToCollection(testJob, module, tests);
				}
			}
		}
		return tests;
	}

	protected abstract Set<String> getTransactionTypeStrings(AbstractHttpTransaction transaction);

	protected abstract TestJob makeTestJob(AbstractHttpTransaction transaction, TestModule module, String type);

}
