package com.grendelscan.categorizers;

import com.grendelscan.tests.testModules.TestModule;
import com.grendelscan.tests.testModules.collections.CategoryTestModuleCollection;
import com.grendelscan.utils.Debug;

/**
 * 
 * @author David Byrne
 */
public abstract class SingleSetCategorizer extends Categorizer
{
	protected String categoryTestClass;
	protected CategoryTestModuleCollection testModules;

	@Override
    public boolean hasModules()
    {
	    return testModules.size() > 0 ? true : false;
    }

	public SingleSetCategorizer(String categoryTestClass)
	{
		testModules = new CategoryTestModuleCollection();
		this.categoryTestClass = categoryTestClass;
	}

	@Override
	public void addModule(TestModule module)
	{
		try
		{
			if (Class.forName(categoryTestClass).isInstance(module))
			{
				testModules.add(module);
			}
		}
		catch (ClassNotFoundException e)
		{
			Debug.errDebug("Class " + categoryTestClass + " not found in SingleSetCategorizer.addModule. Someone screwed up: " + e.toString(), e);
			System.exit(1);
		}
	}

	@Override
	public void resolveDependencies()
	{
		testModules.resolveDependencies();
	}

}
