package com.grendelscan.categorizers.impl;


import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.grendelscan.categorizers.SingleSetCategorizer;
import com.grendelscan.categorizers.TransactionCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.AllTransactionsTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;
/**
 * 
 * @author David Byrne
 */
public class AllTransactionsCategorizer extends SingleSetCategorizer implements TransactionCategorizer
{

	/** Creates a new instance of AllTransactionsCategorizer */
	public AllTransactionsCategorizer()
	{
		super("com.grendelscan.tests.testTypes.AllTransactionsTest");
	}

	public Map<TestModule, Set<TestJob>> analyzeTransaction(AbstractHttpTransaction transaction)
	{
		Map<TestModule, Set<TestJob>>  tests = new HashMap<TestModule, Set<TestJob>> ();
		
		for (TestModule module: testModules)
		{
			AllTransactionsTestJob testJob = new AllTransactionsTestJob(module.getModuleNumber(), transaction.getId(), scan);
			addJobToCollection(testJob, module, tests);
		}
		return tests;
	}
}
