package com.grendelscan.categorizers.impl;

import java.util.HashSet;
import java.util.Set;

import com.grendelscan.categorizers.ByTokenCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.ByFileTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;
import com.grendelscan.utils.HttpUtils;

/**
 * 
 * @author David Byrne
 */
public class ByFileCategorizer extends ByTokenCategorizer
{
	public ByFileCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByFileTest");
	}

	@Override
	protected String[] getTokens(AbstractHttpTransaction transaction)
	{
		String tokens[] = new String[0];
		if (HttpUtils.fileExists(transaction.getLogicalResponseCode()))
		{
			String filename = transaction.getPath() + transaction.getFilename();
			if (!filename.equals(""))
			{
				tokens = new String[1];
				tokens[0] = filename;
			}
		}
		
		return tokens;
	}

	@Override
	protected Set<TestJob> makeTestJobs(AbstractHttpTransaction transaction, TestModule module, String token)
	{
		Set<TestJob> jobs = new HashSet<TestJob>();
		jobs.add(new ByFileTestJob(module.getModuleNumber(), transaction.getId(), scan));
		return jobs;
	}

}
