package com.grendelscan.categorizers.impl;

import java.util.HashSet;
import java.util.Set;

import com.grendelscan.categorizers.ByTokenCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.ByHostTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;


/**
 * 
 * @author David Byrne
 */
public class ByHostCategorizer extends ByTokenCategorizer
{

	public ByHostCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByHostTest");
	}

	@Override
	protected String[] getTokens(AbstractHttpTransaction transaction)
	{
		String s[] = {transaction.getHost()}; 
		return s;
	}

	@Override
	protected Set<TestJob> makeTestJobs(AbstractHttpTransaction transaction, TestModule module, String token)
	{
		Set<TestJob> jobs = new HashSet<TestJob>();
		jobs.add(new ByHostTestJob(module.getModuleNumber(), transaction.getId(), scan));
		return jobs;
	}
}
