package com.grendelscan.categorizers.impl;

import java.util.HashSet;
import java.util.Set;

import com.grendelscan.categorizers.ByTokenCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.ByHttpQueryTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;


/**
 * 
 * @author Administrator
 */
public class ByHttpQueryCategorizer extends ByTokenCategorizer
{

	public ByHttpQueryCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByHttpQueryTest");
	}

	@Override
	protected String[] getTokens(AbstractHttpTransaction transaction)
	{
		String s[];
		String query = transaction.getQuerySummary(true);
		if (query.equals(""))
		{
			s = new String[0];
		}
		else
		{
			s = new String[1];
			s[0] = transaction.getHostUri() + query;
		}
		return s;
	}

	@Override
	protected Set<TestJob> makeTestJobs(AbstractHttpTransaction transaction, TestModule module, String token)
	{
		Set<TestJob> jobs = new HashSet<TestJob>();
		jobs.add(new ByHttpQueryTestJob(module.getModuleNumber(), transaction.getId(), scan));
		return jobs;
	}
}
