package com.grendelscan.categorizers.impl;

import java.util.HashSet;
import java.util.*;

import com.grendelscan.categorizers.ByTokenCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.ByHttpQueryParameterTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;


/**
 * Basically a clone of ByHttpQueryCategorizer, except that a new job is created for 
 * every parameter. I'm sure there's a more clever way to do this.
 * @author Administrator
 */
public class ByHttpQueryParameterCategorizer extends ByTokenCategorizer
{

	public ByHttpQueryParameterCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByHttpQueryParameterTest");
	}

	@Override
	protected String[] getTokens(AbstractHttpTransaction transaction)
	{
		String tokens[];
		String query = transaction.getQuerySummary(true);
		if (query.equals(""))
		{
			tokens = new String[0];
		}
		else
		{
			Set<String> parameterNames = transaction.getQueryParameterNames();
			List<String> tmpTokens = new ArrayList<String>(1);
			String uri = transaction.getBaseUri();
			for (String name: parameterNames)
			{
				if (!scan.isQueryParameterIgnored(name))
				{
					tmpTokens.add(uri + name);
				}
			}
			tokens = tmpTokens.toArray(new String[0]);
		}
		return tokens;
	}

	@Override
	protected Set<TestJob> makeTestJobs(AbstractHttpTransaction transaction, TestModule module, String token)
	{
		Set<TestJob> jobs = new HashSet<TestJob>();
		String parameterName = token.replace(transaction.getBaseUri(), "");
		jobs.add(new ByHttpQueryParameterTestJob(module.getModuleNumber(), transaction.getId(), parameterName, scan));
		return jobs;
	}}
