package com.grendelscan.categorizers.impl;

import java.util.HashSet;
import java.util.Set;

import com.grendelscan.categorizers.MultiSetTransactionCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.ByHttpResponseCodeTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;
import com.grendelscan.tests.testTypes.ByHttpResponseCodeTest;

public class ByHttpResponseCodeCategorizer extends MultiSetTransactionCategorizer
{
	public ByHttpResponseCodeCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByHttpResponseCodeTest");
	}

	@Override
	public String[] getModuleTypes(TestModule module)
	{
		ByHttpResponseCodeTest test = (ByHttpResponseCodeTest) module;
		return test.getResponseCodes();
	}

	@Override
	protected Set<String> getTransactionTypeStrings(AbstractHttpTransaction transaction)
	{
		Set<String> types = new HashSet<String>(1);
		types.add(String.valueOf(transaction.getLogicalResponseCode()));
		return types;
	}

	@Override
	protected TestJob makeTestJob(AbstractHttpTransaction transaction, TestModule module, String type)
	{
		TestJob testJob = new ByHttpResponseCodeTestJob(module.getModuleNumber(), transaction.getId(), scan);
		return testJob;
	}

}
