package com.grendelscan.categorizers.impl;

import java.util.HashSet;
import java.util.Set;

import com.grendelscan.categorizers.MultiSetTransactionCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.ByMimeTypeTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;
import com.grendelscan.tests.testTypes.ByMimeTypeTest;

public class ByMimeTypeCategorizer extends MultiSetTransactionCategorizer
{
	public ByMimeTypeCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByMimeTypeTest");
	}

	@Override
	public String[] getModuleTypes(TestModule module)
	{
		ByMimeTypeTest test = (ByMimeTypeTest) module;
		return test.getMimeTypes();
	}

	@Override
	protected Set<String> getTransactionTypeStrings(AbstractHttpTransaction transaction)
	{
		Set<String> types = new HashSet<String>(1);
		types.add(transaction.getResponseMimeType());
		return types;
	}

	@Override
	protected TestJob makeTestJob(AbstractHttpTransaction transaction, TestModule module, String type)
	{
		TestJob testJob = new ByMimeTypeTestJob(module.getModuleNumber(), transaction.getId(), type, scan);
		return testJob;
	}

}
