package com.grendelscan.categorizers.impl;


import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.grendelscan.categorizers.MultiSetCategorizer;
import com.grendelscan.tests.libraries.TokenTesting.TokenContext;
import com.grendelscan.tests.libraries.TokenTesting.TokenContextType;
import com.grendelscan.tests.testJobs.ByRepeatableOutputContextTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;
import com.grendelscan.tests.testTypes.ByRepeatableOutputContextTest;

public class ByRepeatableOutputContextCategorizer extends MultiSetCategorizer
{

	public ByRepeatableOutputContextCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByRepeatableOutputContextTest");

	}

	public void analyzeRepeatableOutputContext(TokenContext context, int transactionID)
	{
		Map<TestModule, Set<TestJob>> tests = new HashMap<TestModule, Set<TestJob>>();
		if (modulesByType.containsKey(context.getContextType()))
		{
			for (TestModule module: modulesByType.get(context.getContextType()))
			{
				if (!scan.isRunning())
				{
					break;
				}
				TestJob testJob =
				        new ByRepeatableOutputContextTestJob(module.getModuleNumber(), transactionID, context, scan);
				addJobToCollection(testJob, module, tests);
			}
		}
		scan.getCategorizerQueue().submitJobs(tests);
	}

	@Override
	public TokenContextType[] getModuleTypes(TestModule module)
	{
		return ((ByRepeatableOutputContextTest) module).getDesiredRepeatableContexts();
	}

}
