package com.grendelscan.categorizers.impl;

import java.util.HashSet;
import java.util.Set;
import com.grendelscan.utils.*;
import com.grendelscan.categorizers.MultiSetTransactionCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.ByResponseHeaderTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;
import com.grendelscan.tests.testTypes.ByResponseHeaderTest;

public class ByResponseHeaderCategorizer extends MultiSetTransactionCategorizer
{
	public ByResponseHeaderCategorizer()
	{
		super("com.grendelscan.tests.testTypes.ByResponseHeaderTest");
	}

	@Override
	public String[] getModuleTypes(TestModule module)
	{
		ByResponseHeaderTest test = (ByResponseHeaderTest) module;
		return test.getResponseHeaders();
	}

	@Override
	protected Set<String> getTransactionTypeStrings(AbstractHttpTransaction transaction)
	{
		// If we don't make these unique, duplicate test jobs will be created.
		String headerNames[] = transaction.getAllResponseHeaderNames();
		Set<String> uniqueNames = new HashSet<String>(headerNames.length);
		for (String name: headerNames)
		{
			uniqueNames.add(name);
		}
		return uniqueNames;
	}

	@Override
	protected TestJob makeTestJob(AbstractHttpTransaction transaction, TestModule module, String type)
	{
		TestJob testJob = new ByResponseHeaderTestJob(module.getModuleNumber(), transaction.getId(), type, scan);
		return testJob;
	}
}
