package com.grendelscan.categorizers.impl;
import com.grendelscan.requester.http.serializable.SerializableBasicCookie;
import java.util.HashSet;
import java.util.Set;

import org.apache.http.cookie.Cookie;

import com.grendelscan.utils.*;
import com.grendelscan.categorizers.*;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.testJobs.BySetCookieTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;

public class BySetCookieCategorizer extends ByTokenCategorizer
{
	public BySetCookieCategorizer()
	{
		super("com.grendelscan.tests.testTypes.BySetCookieTest");
	}

	@Override
    protected String[] getTokens(AbstractHttpTransaction transaction)
    {
		Set<String> cookieNames = new HashSet<String>(1);
		
		for (Cookie cookie: HttpUtils.getSetCookies(transaction))
		{
			cookieNames.add(cookie.getName() + "\n" + cookie.getDomain());
		}
	    return cookieNames.toArray(new String[0]);
    }

	@Override
    protected Set<TestJob> makeTestJobs(AbstractHttpTransaction transaction, TestModule module, String token)
    {
		String cookieName = token.split("\n")[0];
		Set<TestJob> jobs = new HashSet<TestJob>();
		Cookie cookie = new SerializableBasicCookie(HttpUtils.getSetCookie(transaction, cookieName), transaction.getId());
		jobs.add(new BySetCookieTestJob(module.getModuleNumber(), transaction.getId(), cookie, scan));
		return jobs;
   }

}
