package com.grendelscan.categorizers.impl;


import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.grendelscan.categorizers.SingleSetCategorizer;
import com.grendelscan.tests.testJobs.FinalAnalysisTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;

/**
 * 
 * @author David Byrne
 */
public class FinalAnalysisCategorizer extends SingleSetCategorizer 
{

	/** Creates a new instance of AllTransactionsCategorizer */
	public FinalAnalysisCategorizer()
	{
		super("com.grendelscan.tests.testTypes.FinalAnalysisTest");
	}

	public void runAnalysis()
	{
		Map<TestModule, Set<TestJob>> tests = new HashMap<TestModule, Set<TestJob>>();

		for (TestModule module: testModules)
		{
			FinalAnalysisTestJob testJob = new FinalAnalysisTestJob(module.getModuleNumber(), scan);
			addJobToCollection(testJob, module, tests);
		}
		scan.getCategorizerQueue().submitJobs(tests);
	}

}
