package com.grendelscan.categorizers.impl;


import java.util.HashMap;
import java.util.Map;
import java.util.Set;

import com.grendelscan.categorizers.SingleSetCategorizer;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.libraries.SessionIDTesting.SessionIDLocation;
import com.grendelscan.tests.testJobs.InitialAuthenticationTestJob;
import com.grendelscan.tests.testJobs.TestJob;
import com.grendelscan.tests.testModules.TestModule;

/**
 * 
 * @author David Byrne
 */
public class InitialAuthenticationCategorizer extends SingleSetCategorizer
{

	/** Creates a new instance of InitialAuthenticationCategorizer */
	public InitialAuthenticationCategorizer()
	{
		super("com.grendelscan.tests.testTypes.InitialAuthenticationTest");
	}

	public void analyzeAuthentication(AbstractHttpTransaction transaction, SessionIDLocation sessionIDLocation)
	{
		Map<TestModule, Set<TestJob>> tests = new HashMap<TestModule, Set<TestJob>>();
		for (TestModule module: testModules)
		{
			InitialAuthenticationTestJob testJob = new InitialAuthenticationTestJob(module.getModuleNumber(), transaction.getId(), sessionIDLocation, scan);
			addJobToCollection(testJob, module, tests);
		}
		scan.getCategorizerQueue().submitJobs(tests);
	}
}