package com.grendelscan.data;


import java.sql.Connection;
import java.sql.SQLException;

import com.grendelscan.utils.Debug;

public class DatabaseInitializer
{

	public static void createDatabase(Connection databaseConnection)
	{
		createRecordableEventsTable(databaseConnection);
	}
	
	private static void createRecordableEventsTable(Connection databaseConnection)
	{
		String query = 
			"CREATE TABLE RecordableEvents (\n" + 
				"EventID INT GENERATED BY DEFAULT AS IDENTITY (START WITH 1, INCREMENT BY 1) NOT NULL,\n" +
				"Time TIMESTAMP,\n" + 
				"Source VARCHAR(100),\n" + 
				"Severity SMALLINT,\n" + 
				"Title VARCHAR(150),\n" + 
				"BriefDescription CLOB,\n" + 
				"LongDescription CLOB,\n" + 
				"Impact CLOB,\n" + 
				"Recomendations CLOB,\n" + 
				"ReferencesText CLOB,\n" + 
				"URL CLOB,\n" + 
				"PRIMARY KEY (EventID));\n" + "" +
			"CREATE INDEX IDX_RecordableEvents_Severity ON RecordableEvents (Severity);\n" + 
			"CREATE INDEX IDX_RecordableEvents_URL ON RecordableEvents (URL);\n" + 
			"CREATE INDEX IDX_RecordableEvents_Source ON RecordableEvents (Source);\n";
		try
		{
			databaseConnection.createStatement().execute(query);
		}
		catch (SQLException e)
		{
			Debug.errDebug("SQL error when creating ReportableEvent table: " + e.toString(), e);
			System.exit(1);
		}
	}
}
