package com.grendelscan.logging;
import java.util.Set;
public interface Log
{
	/**
	 * logs a message
	 * @param message
	 * @param severityLevel
	 */
	public void log(String message, EventSeverity severityLevel);
	
	/**
	 * Logs a message
	 * @param message
	 * @param severityLevel
	 * @param e The exception that generated the message
	 */
	public void log(String message, EventSeverity severityLevel, Exception e);
	
	/**
	 * Will add or update a LogSubscriber.
	 * @param logSubscriber The subscriber object
	 * @param severities A set of the severity levels that should be reported to this subscriber
	 */
	public void addLogSubscriber(LogSubscriber logSubscriber, Set<EventSeverity> severities);
	
	/**
	 * Removes a log subscriber
	 * @param logSubscriber
	 */
	public void removeLogSubscriber(LogSubscriber logSubscriber);
}
