package com.grendelscan.proxy;

import java.net.Socket;

import org.apache.http.impl.DefaultConnectionReuseStrategy;
import org.apache.http.impl.DefaultHttpResponseFactory;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.CoreConnectionPNames;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpProcessor;
import org.apache.http.protocol.HttpRequestHandlerRegistry;
import org.apache.http.protocol.HttpService;
import org.apache.http.protocol.ResponseConnControl;

import com.grendelscan.GrendelScan;
import com.grendelscan.requester.http.client.CustomHttpClient;
import com.grendelscan.scan.Scan;


public class MiscHttpFactory
{
	public static HttpParams createDefaultHttpParams()
	{
		HttpParams params = new BasicHttpParams();
		params.setIntParameter(CoreConnectionPNames.SO_TIMEOUT, 100000).setIntParameter(
		        CoreConnectionPNames.SOCKET_BUFFER_SIZE, 8 * 1024).setBooleanParameter(
		        CoreConnectionPNames.STALE_CONNECTION_CHECK, false).setBooleanParameter(
		        CoreConnectionPNames.TCP_NODELAY, true).setParameter(CoreProtocolPNames.ORIGIN_SERVER,
		        "Grendel-Scan/" + GrendelScan.version); 
		return params;
	}
	
	
	public static HttpService createHttpServiceProxy(Scan scan, Socket socket, Proxy proxy, CustomHttpClient proxyHttpClient, boolean ssl, int sslPort)
	{
		return createHttpServiceProxy(scan, socket, proxy, proxyHttpClient, ssl, sslPort, createDefaultHttpParams());
	}

	public static HttpService createHttpServiceProxy(Scan scan, Socket socket, Proxy proxy, CustomHttpClient proxyHttpClient, boolean ssl, int sslPort, HttpParams params)
	{
		// Set up the HTTP protocol processor
		BasicHttpProcessor httpproc = new BasicHttpProcessor();
		// httpproc.addInterceptor(new ResponseDate());
		// httpproc.addInterceptor(new ResponseServer());
		// httpproc.addInterceptor(new ResponseContent());
		httpproc.addInterceptor(new ResponseConnControl());
		
		// Set up request handlers
		HttpRequestHandlerRegistry reqistry = new HttpRequestHandlerRegistry();
		reqistry.register("*", new HttpProxyRequestHandler(scan, socket, proxy, proxyHttpClient, ssl, sslPort));
		
		// Set up the HTTP service
		HttpService httpService =
		        new HttpService(httpproc, new DefaultConnectionReuseStrategy(), new DefaultHttpResponseFactory());
		httpService.setParams(params);
		httpService.setHandlerResolver(reqistry);
		
		return httpService;
	}
}
