package com.grendelscan.proxy.authWizardProxy;

import java.net.Socket;

import org.apache.http.impl.DefaultConnectionReuseStrategy;
import org.apache.http.impl.DefaultHttpResponseFactory;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpProcessor;
import org.apache.http.protocol.HttpRequestHandlerRegistry;
import org.apache.http.protocol.HttpService;
import org.apache.http.protocol.ResponseConnControl;

import com.grendelscan.GUI.AuthWizardDialog;
import com.grendelscan.proxy.Proxy;
import com.grendelscan.scan.Scan;

public class AuthWizardProxy extends Proxy
{
	private int bindPort;
	private String bindAddress;
	
	AuthWizardDialog wizardDialog;
	public AuthWizardProxy(AuthWizardDialog wizardDialog, Scan scan, int bindPort, String bindAddress) throws IllegalStateException
	{
		super(scan);
		this.bindAddress = bindAddress;
		this.bindPort = bindPort;
		this.wizardDialog = wizardDialog;
		startProxy();
		if (!this.isRunning())
		{
			throw new IllegalStateException("Proxy failed to start");
		}
	}

	@Override
    protected int getBindPort()
    {
	    return bindPort;
    }

	@Override
    protected String getIPAddress()
    {
	    return bindAddress;
    }

	@Override
    protected int getMaxThreads()
    {
	    return 1;
    }

	@Override
    public HttpService createHttpService(Socket socket, HttpParams params)
    {
		BasicHttpProcessor httpproc = new BasicHttpProcessor();
		httpproc.addInterceptor(new ResponseConnControl());
		
		// Set up request handlers
		HttpRequestHandlerRegistry reqistry = new HttpRequestHandlerRegistry();
		reqistry.register("*", new AuthWizardRequestHandler(scan, socket, this, this.proxyHttpClient, false, 0, wizardDialog, this));
		
		// Set up the HTTP service
		HttpService httpService =
		        new HttpService(httpproc, new DefaultConnectionReuseStrategy(), new DefaultHttpResponseFactory());
		httpService.setParams(params);
		httpService.setHandlerResolver(reqistry);
		
		return httpService;
    }
	
}
