package com.grendelscan.requester;


import java.net.URL;
import java.security.Policy;

import org.cobra_grendel.html.HttpRequest;
import org.cobra_grendel.html.UserAgentContext;

import com.grendelscan.scan.Scan;

/**
 * This is used by HttpTransaction and should not be used by
 * itself unless you really know what you are doing. It may
 * go away in the future.
 * 
 * @author David Byrne
 */
public class CobraUserAgent implements UserAgentContext
{
	private Scan scan;
	private boolean enableScripting;
	
	public CobraUserAgent(Scan scan, boolean enableScripting)
	{
		this.enableScripting = enableScripting;
		this.scan = scan;
	}

	public HttpRequest createHttpRequest()
	{
		HttpRequest request = new CobraHttpRequest(scan);
		return request;
	}

	public String getAppCodeName()
	{
		return "huh?";
	}

	public String getAppMinorVersion()
	{
		return "1";
	}

	public String getAppName()
	{
		return "This is Grendel";
	}

	public String getAppVersion()
	{
		return "0";
	}

	public String getBrowserLanguage()
	{
		return "English";
	}

	public String getCookie(URL arg0)
	{
		// TODO Auto-generated method stub
		return null;
	}

	public String getPlatform()
	{
		// TODO Auto-generated method stub
		return null;
	}

	public int getScriptingOptimizationLevel()
	{
		// TODO Auto-generated method stub
		return 0;
	}

	public Policy getSecurityPolicy()
	{
		// TODO Auto-generated method stub
		return null;
	}

	public String getUserAgent()
	{
		return scan.getScanSettings().getUserAgentString();
	}

	public boolean isCookieEnabled()
	{
		// TODO Auto-generated method stub
		return false;
	}

	public boolean isScriptingEnabled()
	{
		// TODO Auto-generated method stub
		return enableScripting;
	}

	public void setCookie(URL arg0, String arg1)
	{
		// TODO Auto-generated method stub

	}

}
