/*
 * AllowedHosts.java
 * 
 * Created on September 16, 2007, 9:39 AM
 * 
 * To change this template, choose Tools | Template Manager and open the
 * template in the editor.
 */

package com.grendelscan.requester;

import java.util.ArrayList;
import java.util.List;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


/**
 * 
 * @author Administrator
 */
public class UrlFilters
{
	private List<Pattern> blacklists;
	private List<Pattern> whitelists;
	
	/** Creates a new instance of AllowedHosts */
	public UrlFilters()
	{
		whitelists = new ArrayList<Pattern>();
		blacklists = new ArrayList<Pattern>();
	}
	
	public void addUrlBlacklist(Pattern expression)
	{
		blacklists.add(expression);
	}
	
	public void clearUrlBlacklists()
	{
		blacklists = new ArrayList<Pattern>();
	}
	
	public void clearUrlWhitelists()
	{
		whitelists = new ArrayList<Pattern>();
	}
	
	public void addUrlBlacklist(String expression)
	{
		Pattern r = Pattern.compile(expression, Pattern.CASE_INSENSITIVE);
		blacklists.add(r);
	}
	
	public void addUrlWhitelist(Pattern expression)
	{
		whitelists.add(expression);
	}
	
	public void addUrlWhitelist(String expression)
	{
		Pattern r = Pattern.compile(expression, Pattern.CASE_INSENSITIVE);
		whitelists.add(r);
	}
	
	public List<Pattern> getBlacklists()
	{
		return blacklists;
	}
	
	public List<String> getBlacklistsAsString()
	{
		List<String> expressions = new ArrayList<String>();
		for (Pattern pattern: blacklists)
		{
			expressions.add(pattern.pattern());
		}
		return expressions;
	}
	
	public List<Pattern> getWhitelists()
	{
		return whitelists;
	}
	
	public List<String> getWhitelistsAsString()
	{
		List<String> expressions = new ArrayList<String>(whitelists.size());
		for (Pattern pattern: whitelists)
		{
			expressions.add(pattern.pattern());
		}
		return expressions;
	}
	
	public boolean isUriAllowed(String uri)
	{
		boolean isOkay = false;
		Matcher matcher;
		for (Pattern pattern: whitelists)
		{
			matcher = pattern.matcher(uri);
			if (matcher.find())
			{
				isOkay = true;
				break;
			}
		}
		
		if (isOkay)
		{
			for (Pattern pattern: blacklists)
			{
				matcher = pattern.matcher(uri);
				if (matcher.find())
				{
					isOkay = false;
					break;
				}
			}
		}
		
		return isOkay;
	}
}
