/*
 * AuthenticationBundle.java
 *
 * Created on September 13, 2007, 9:16 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.grendelscan.requester.authentication;

import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.scan.Scan;
/**
 *
 * @author Administrator
 */
public abstract class AuthenticationPackage 
{
    protected List<String> sessionIDNames;
    protected Scan scan;
    protected String loggedOutPageText;
    protected Map<String, String> credentials;
    
    
    /** Creates a new instance of AuthenticationBundle */
    public AuthenticationPackage(Scan scan) 
    {
		this.scan = scan;
		sessionIDNames = new ArrayList<String>(1);
		credentials = new HashMap<String, String>(1);
    }
    
    public abstract AbstractHttpTransaction createLoginTransaction(String username);
    public abstract AbstractHttpTransaction createAnyLoginTransaction();
    public abstract List<AbstractHttpTransaction> createLoginTransactions();
 
    public void addCredentialSet(String username, String password)
    {
    	credentials.put(username, password);
    }


	public Map<String, String> getCredentials()
    {
    	return credentials;
    }

	public String getLoggedOutPageText()
    {
    	return loggedOutPageText;
    }

	public void setLoggedOutPageText(String loggedOutPageText)
    {
    	this.loggedOutPageText = loggedOutPageText;
    }

	public List<String> getSessionIDNames()
    {
    	return sessionIDNames;
    }
	
}


