package com.grendelscan.requester.http;

import java.io.IOException;

import org.apache.http.HttpEntity;
import org.apache.http.HttpEntityEnclosingRequest;
import org.apache.http.entity.ByteArrayEntity;

import com.grendelscan.utils.Debug;
import com.grendelscan.utils.HttpUtils;

public class UnvalidatedHttpEntityRequest extends UnvalidatedHttpRequest implements HttpEntityEnclosingRequest
{
	/**
	 * 
	 */
	private static final long serialVersionUID = -3768084680860166736L;
	private byte body[];
	
	public UnvalidatedHttpEntityRequest(String method, String uri, String protocol, int majorProtocolVersion, int minorProtocolVersion,
	        String host, int port, boolean ssl, byte[] body)
	{
		super(method, uri, protocol, majorProtocolVersion, minorProtocolVersion, host, port, ssl);
		this.body = body;
	}
	
	public UnvalidatedHttpEntityRequest(String method, String uri, String host, int port, boolean ssl, byte[] body)
	{
		super(method, uri, host, port, ssl);
		this.body = body;
	}
	
	public boolean expectContinue()
	{
		return false;
	}
	
	public HttpEntity getEntity()
	{
		return new ByteArrayEntity(body);
	}
	
	public void setEntity(HttpEntity entity)
	{
		try
		{
			body = HttpUtils.entityToByteArray(entity, 0);
		}
		catch (IOException e)
		{
			Debug.errDebug("Error setting entity: " + e.toString(), e);
		}
	}
	
	public byte[] getBody()
    {
    	return body;
    }

}
