package com.grendelscan.requester.http.client;

import java.lang.reflect.Field;

import org.apache.http.ConnectionReuseStrategy;
import org.apache.http.client.AuthenticationHandler;
import org.apache.http.client.HttpRequestRetryHandler;
import org.apache.http.client.RedirectHandler;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.routing.HttpRoutePlanner;
import org.apache.http.impl.client.DefaultClientRequestDirector;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.HttpProcessor;
import org.apache.http.protocol.HttpRequestExecutor;

import com.grendelscan.utils.Debug;

public class CustomClientRequestDirector extends DefaultClientRequestDirector
{
	
	public CustomClientRequestDirector(ClientConnectionManager conman, ConnectionReuseStrategy reustrat,
	        HttpRoutePlanner rouplan, HttpProcessor httpProcessor, HttpRequestRetryHandler retryHandler,
	        RedirectHandler redirectHandler, AuthenticationHandler targetAuthHandler,
	        AuthenticationHandler proxyAuthHandler, HttpParams params)
	{
		super(conman, reustrat, rouplan, httpProcessor, retryHandler, redirectHandler, targetAuthHandler,
		        proxyAuthHandler, params);
		
		/* 
		 * I don't like use reflection here, but I need to because the field is final
		 */
		Class c = DefaultClientRequestDirector.class;
		try
        {
	        Field f = c.getDeclaredField("requestExec");
	        f.setAccessible(true);
	        f.set(this, new CustomHttpRequestExecutor());
        }
        catch (Exception e)
        {
        	Debug.errDebug("Major problem: " + e.toString(), e);
        	System.exit(0);
        }
	}
	
}
