package com.grendelscan.requester.http.client;

import java.io.IOException;
import java.util.Date;

import org.apache.derby.impl.sql.compile.CastNode;
import org.apache.http.HttpClientConnection;
import org.apache.http.HttpException;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpRequestExecutor;

import com.grendelscan.requester.http.UnvalidatedHttpRequest;
import com.grendelscan.utils.Debug;

public class CustomHttpRequestExecutor extends HttpRequestExecutor
{

	public CustomHttpRequestExecutor()
    {
	    super();
    }

	@Override
    public HttpResponse execute(HttpRequest request, HttpClientConnection conn, HttpContext context)
            throws IOException, HttpException
    {
		Date start = new Date();
		HttpResponse response = super.execute(request, conn, context);
		Date end = new Date();
		long length = Math.round((end.getTime() - start.getTime())/1000);
//		long msLength = end.getTime() - start.getTime();
		if (length > 15)
		{
			String uri;
			if (request instanceof UnvalidatedHttpRequest)
			{
				uri = ((UnvalidatedHttpRequest) request).getRequestLine().getUri();
			}
			else if (request instanceof HttpUriRequest)
            {
	            uri = ((HttpUriRequest)request).getURI().toASCIIString();
            }
			else
            {
            	uri = "<" + request.getClass().toString() + ">";
            }
			Debug.errDebug("WARNING: Server took " + length + " seconds to process request for " + uri);
		}
		return response;
    }
	
}
