package com.grendelscan.requester.http.client;

import org.apache.http.ConnectionReuseStrategy;
import org.apache.http.client.AuthenticationHandler;
import org.apache.http.client.ClientRequestDirector;
import org.apache.http.client.HttpRequestRetryHandler;
import org.apache.http.client.RedirectHandler;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.routing.HttpRoutePlanner;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpProcessor;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.HttpProcessor;
import org.apache.http.protocol.RequestExpectContinue;
import org.apache.http.protocol.RequestUserAgent;

import com.grendelscan.scan.Scan;

public class RawHttpClient extends CustomHttpClient
{
	
	public RawHttpClient(ClientConnectionManager conman, HttpParams params, HttpContext contextTemplate, Scan scan)
	{
		super(conman, params, contextTemplate, scan);
	}
	
	@Override
	protected ClientRequestDirector createClientRequestDirector(ClientConnectionManager conman,
	        ConnectionReuseStrategy reustrat, HttpRoutePlanner rouplan, HttpProcessor httpProcessor,
	        HttpRequestRetryHandler retryHandler, RedirectHandler redirectHandler,
	        AuthenticationHandler targetAuthHandler, AuthenticationHandler proxyAuthHandler, HttpParams params)
	{
		return new RawClientRequestDirector(conman, reustrat, rouplan, httpProcessor, retryHandler, redirectHandler,
		        targetAuthHandler, proxyAuthHandler, params);
	}
	
	@Override
	protected BasicHttpProcessor createHttpProcessor()
	{
		BasicHttpProcessor httpproc = new BasicHttpProcessor();
		httpproc.addInterceptor(new RequestUserAgent());
		httpproc.addInterceptor(new RequestExpectContinue());
		return httpproc;
	}
	
}
