package com.grendelscan.requester.http.factories;

import java.net.URI;

import org.apache.http.Header;
import org.apache.http.HttpEntity;
import org.apache.http.HttpRequest;
import org.apache.http.client.methods.HttpGet;
import org.apache.http.client.methods.HttpHead;
import org.apache.http.client.methods.HttpOptions;
import org.apache.http.client.methods.HttpPost;
import org.apache.http.client.methods.HttpPut;
import org.apache.http.client.methods.HttpTrace;

public class HttpRequestFactory
{
//	private static Scan scan;
//	
//	
//	public static void initializeLibrary(Scan scan)
//	{
//		HttpRequestFactory.scan = scan;
//	}
	
	/**
	 * 
	 * @param requestLine
	 * @param uri
	 * @param params
	 * @param headers
	 * @param entity Can be null
	 * @return
	 */
	public static HttpRequest makeRequest(String method, URI uri, Header headers[], HttpEntity entity)
	{
		HttpRequest request = null;

		if (method.equals("GET"))
		{
			HttpGet get = new HttpGet();
			get.setURI(uri);
			request = get;
		}
		else if (method.equals("TRACE"))
		{
			HttpTrace trace = new HttpTrace();
			trace.setURI(uri);
			request = trace;
		}
		else if (method.equals("OPTIONS"))
		{
			HttpOptions options = new HttpOptions();
			options.setURI(uri);
			request = options;
		}
		else if (method.equals("HEAD"))
		{
			HttpHead head = new HttpHead();
			head.setURI(uri);
			request = head;
		}
		else if (method.equals("POST"))
		{
			HttpPost post = new HttpPost();
			post.setURI(uri);
			post.setEntity(entity);
			request = post;
		}
		else if (method.equals("PUT"))
		{
			HttpPut put = new HttpPut();
			put.setURI(uri);
			put.setEntity(entity);
			request = put;
		}
		
		if (request != null)
		{
			if (headers != null)
			{
				request.setHeaders(headers);
			}
//			request.setParams(scan.getHttpClient().getParams());
		}

		return request;
	}
}
