package com.grendelscan.requester.http.factories;

import org.apache.http.HttpHost;
import org.apache.http.client.HttpClient;
import org.apache.http.client.params.ClientPNames;
import org.apache.http.conn.params.ConnRoutePNames;
import org.apache.http.impl.client.DefaultHttpClient;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.CoreProtocolPNames;
import org.apache.http.params.HttpParams;

import com.grendelscan.scan.Scan;
import com.grendelscan.scan.ScanSettings;

public class NonScanClientFactory
{
	public static HttpClient getClient(Scan scan)
	{
		HttpParams params = new BasicHttpParams();
		ScanSettings scanSettings = scan.getScanSettings();
		params.setParameter(CoreProtocolPNames.USER_AGENT, scanSettings.getUserAgentString());
		params.setBooleanParameter(ClientPNames.HANDLE_REDIRECTS, true);
		if (scanSettings.getUseUpstreamProxy())
		{
			HttpHost proxy = new HttpHost(scanSettings.getUpstreamProxyAddress(), scanSettings.getUpstreamProxyPort());
			params.setParameter(ConnRoutePNames.DEFAULT_PROXY, proxy);
		}
		HttpClient client = new DefaultHttpClient();
		
		return client;
	}
}
