package com.grendelscan.requester.http.transactions;

import java.io.IOException;
import java.net.URISyntaxException;

import org.apache.http.HttpRequest;
import org.apache.http.util.EntityUtils;

import com.grendelscan.requester.TransactionSource;
import com.grendelscan.requester.http.wrappers.StandardHttpRequestWrapper;
import com.grendelscan.scan.Scan;
import com.grendelscan.utils.*;

public abstract class HttpEntityEnclosingRequestTransaction extends AbstractStandardHttpTransaction
{
	@Override
    public byte[] getRequestBody()
    {
	    return requestWrapper.getRequestPayload().getBody();
    }


	@Override
    public String requestToString()
    {
	    String request =  super.requestToString();
	    request += getSentBody();
	    return request;
    }

	protected String sentBody = "";
	
	public HttpEntityEnclosingRequestTransaction(Scan scan, StandardHttpRequestWrapper requestWrapper, int referer,
            TransactionSource source)
    {
	    super(scan, requestWrapper, referer, source);
    }

	protected transient boolean entitySet = false;
	
	public HttpEntityEnclosingRequestTransaction(Scan scan, HttpRequest request, int referer, TransactionSource source)
	        throws URISyntaxException
	{
		super(scan, request, referer, source);
	}
	
	@Override
	public void updatePayload()
	{
		// Ugly, find a better way of tracking the body
		try
        {
	        sentBody = new String(EntityUtils.toByteArray(requestWrapper.getRequestPayload().toEntity()));
        }
        catch (IOException e)
        {
	        Debug.errDebug("Problem processing payload entity: " + e.toString(), e);
        }
	}

	
	public boolean isEntitySet()
	{
		return entitySet;
	}
	
	
	public void setEntitySet(boolean entitySet)
	{
		this.entitySet = entitySet;
	}
	
	/**
	 * Doesn't copy the response
	 */
	@Override
	protected void copyFields(AbstractStandardHttpTransaction target)
	{
		super.copyFields(target);
	}

	public String getSentBody()
    {
    	return sentBody;
    }
	
//	@Override
//	protected String extractPayload()
//	{
//		ByteArrayOutputStream body = new ByteArrayOutputStream();
//		
//		try
//		{
//			HttpEntity en = requestWrapper.getEntity();
//			if (en != null)
//			{
//				en.writeTo(body);
//			}
//		}
//		catch (IOException e)
//		{
//			Debug.errDebug("Very weird stuff in HttpEntityEnclosingRequestTransaction.initURLRequestPayload: "
//			        + e.toString(), e);
//		}
//		return body.toString();
//	}
}
