package com.grendelscan.requester.http.transactions;

import org.apache.http.conn.HttpHostConnectException;
import java.io.IOException;
import java.util.*;
import java.net.*;
import java.util.regex.Matcher;

import org.apache.http.*;
import org.apache.http.message.*;
import org.apache.http.protocol.*;
import org.apache.http.client.methods.*;
import org.apache.http.entity.ByteArrayEntity;
import com.grendelscan.requester.TransactionSource;
import com.grendelscan.requester.http.*;
import com.grendelscan.requester.http.factories.*;
import com.grendelscan.requester.http.factories.HttpRequestFactory;
import com.grendelscan.requester.http.client.CustomHttpClient;
import com.grendelscan.scan.Scan;
import com.grendelscan.utils.*;
import org.apache.http.Header;
import org.apache.http.HttpException;
import org.apache.http.HttpHost;
import org.apache.http.HttpRequest;
import org.apache.http.HttpResponse;
import org.apache.http.client.methods.HttpUriRequest;
import org.apache.http.client.*;
import org.apache.http.client.protocol.RequestProxyAuthentication;
import org.apache.http.client.protocol.RequestTargetAuthentication;
import org.apache.http.conn.ClientConnectionManager;
import org.apache.http.conn.routing.HttpRoutePlanner;
import org.apache.http.conn.scheme.SchemeRegistry;
import org.apache.http.impl.client.*;
import org.apache.http.impl.conn.*;
import org.apache.http.params.BasicHttpParams;
import org.apache.http.params.HttpParams;
import org.apache.http.protocol.BasicHttpProcessor;
import org.apache.http.protocol.ExecutionContext;
import org.apache.http.protocol.HttpContext;
import org.apache.http.protocol.RequestConnControl;
import org.apache.http.protocol.RequestExpectContinue;
import org.apache.http.protocol.RequestTargetHost;
import org.apache.http.protocol.RequestUserAgent;
import com.grendelscan.requester.http.serializable.*;
import org.apache.http.protocol.SyncBasicHttpContext;

import com.grendelscan.requester.TransactionSource;
import com.grendelscan.requester.http.*;
import com.grendelscan.requester.http.factories.*;
import com.grendelscan.requester.http.factories.HttpRequestFactory;
import com.grendelscan.requester.http.client.CustomHttpClient;
import com.grendelscan.scan.Scan;
import com.grendelscan.utils.*;

public class NonScanHttpTransaction
{
	/**
	 * 
	 */
	private static final long serialVersionUID = 256619227298731217L;
	private byte requestBody[];
	private byte responseBody[];
	
	private HttpUriRequest request;
	private HttpResponse response;
	private URI uri;
	private Scan scan;
	
	
	public NonScanHttpTransaction(Scan scan, String method, String uri, byte body[]) throws URISyntaxException
	{
		this.scan = scan;
		ByteArrayEntity entity = new ByteArrayEntity(body);
		this.uri = UriFactory.makeUri(uri, true);
		request = (HttpUriRequest) HttpRequestFactory.makeRequest(method, this.uri, null, entity);
		this.requestBody = body;
	}
	
	public NonScanHttpTransaction(Scan scan, String method, String uri) throws URISyntaxException
	{
		this.scan = scan;
		this.uri = UriFactory.makeUri(uri, true);
		request = (HttpUriRequest) HttpRequestFactory.makeRequest(method, this.uri, null, null);
	}
	
	public void addRequestHeader(Header header)
	{
		request.addHeader(header);
	}
	
	public void addRequestHeader(String name, String value)
	{
		request.addHeader(name, value);
	}
	
	public void execute(HttpClient client) throws HttpException, IOException
	{
		int retries = 0;
		while (response == null && retries++ <= scan.getScanSettings().getMaxRequestRetries())
		{
	        response = client.execute(request);
	        responseBody = HttpUtils.entityToByteArray(response.getEntity(), 0);
		}
	}
	
	public byte[] getRequestBody()
    {
    	return requestBody;
    }

	public byte[] getResponseBody()
    {
    	return responseBody;
    }

	public HttpResponse getResponse()
    {
    	return response;
    }


}
