/*
 * requesterThread.java
 * 
 * Created on September 10, 2007, 6:29 PM
 * 
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.grendelscan.requester.queue;

import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.scan.*;
import com.grendelscan.scan.abstractQueue.AbstractQueueThread;
import com.grendelscan.scan.abstractQueue.QueueThreadGroup;
import com.grendelscan.scan.abstractQueue.QueueThreadState;
import com.grendelscan.utils.*;
/**
 * 
 * @author Administrator
 */
public class RequesterThread implements Runnable, AbstractQueueThread
{
	private RequesterQueue queue;
	private Scan scan;
	private Thread thread;

    private QueueThreadState threadState;
    
    public QueueThreadState getThreadState()
    {
    	return threadState;
    }

    
	/** Creates a new instance of requesterThread */
	public RequesterThread(int ID, Scan scan, QueueThreadGroup threadGroup)
	{
    	threadState = QueueThreadState.CREATING;
		this.scan = scan;
		thread = new Thread(threadGroup, this, "RequesterThread-" + ID);
		queue = scan.getRequesterQueue();
	}


	public void run()
	{
		while (queue.isRunning() && scan.isRunning())
		{
	    	threadState = QueueThreadState.POLLING;
			try
			{
		    	AbstractHttpTransaction transaction = getNextRequest();
				if ((transaction != null) && queue.isRunning() && scan.isRunning())
				{
					threadState = QueueThreadState.PROCESSING;
					queue.sendRequest(transaction, "Requester thread on behalf of " + transaction.getExecutionSource(), scan.getHttpClient(), true);
					scan.getCategorizerQueue().addTransaction(transaction);
				}
			}
			catch (Exception e) 
			{
				Debug.errDebug("Unhandled exception in " + thread.getName() + ": " + e.toString(), e);
			}
		}
    	threadState = QueueThreadState.TERMINATING;
	}

	/**
	 * This will properly interrupt the thread and tell it to process no other tasks. 
	 * It does not currently have the ability to abort a task already started. 
	 */
	public void interupt()
	{
		thread.interrupt();
	}
	
	public void start()
	{
		thread.start();
	}

	private AbstractHttpTransaction getNextRequest()
	{
		AbstractHttpTransaction request = null;
		while ((request == null) && queue.isRunning() && scan.isRunning())
		{
			if (scan.isRunning())
			{
				request = queue.getNext();
			}
			if ((request == null) && queue.isRunning() && scan.isRunning())
			{
				synchronized(this)
				{
					try
					{
						this.wait(250);
					}
					catch (InterruptedException e)
					{
					}
				}
			}
		}
		return request;
	}


	public String getName()
    {
	    return thread.getName();
    }

}
