package com.grendelscan.scan.abstractQueue;


import java.util.Queue;

public abstract class AbstractScanQueue implements ScanQueue
{
	protected boolean queueLocked = false;
	
	@SuppressWarnings("unchecked")
    protected abstract Queue getQueue();
	
    /**
     * This should only be called if the scan is being terminated
     */
	public void lockQueue()
	{
		queueLocked = true;
	}

	public void emptyQueue()
	{
		while (getQueue().size() > 0 && getQueue().remove() != null);
	}

	public void unlockQueue()
	{
		queueLocked = false;
	}
	
    public int queueLength()
    {
    	return getQueue().size();
    }

    
}
