package com.grendelscan.scan.reporting;


import java.util.ArrayList;
import java.util.Iterator;
import java.util.List;

import com.grendelscan.scan.Scan;
import com.grendelscan.utils.Debug;

/**
 * This class tracks all
 * {@link ReportableEvent reportable events} sent to it and
 * is used to generate the final report for the scan results
 * 
 * @author David Byrne
 * 
 */
public class EventCollector
{

	List <ReportableEvent> events;
	
	private Scan scan;

	/**
	 * 
	 * @param sharedComponents
	 */
	public EventCollector(Scan scan)
	{
		this.scan = scan;
		events = new ArrayList<ReportableEvent>();
	}

	public Iterator<ReportableEvent> iterator()
	{
		return events.iterator();
	}
	
	/**
	 * 
	 * @param event
	 */
	public void addEvent(ReportableEvent event)
	{
		Debug.debug("****** " + event.getSource() + ": " + event.getLongDescription());
		events.add(event);
		
		// This should add something into the database
	}

	
	
	/**
	 * Grabs the next recordset from the table and puts it into a ReportableEvent 
	 * @return Null if no more records
	 */
	/*
	protected ReportableEvent getNextEvent()
	{
		ReportableEvent event = null;
		Timestamp time;
		String source, title, briefDescription, longDescription, recomendations, references, url, impact;
		Clob clob;
		int severity;

		try
		{
			if (moreEvents)
			{
				time = records.getTimestamp(1);
				source = records.getString(2);
				severity = records.getInt(3);
				title = records.getString(4);
				
				/* 
				 * Technically not a good idea to cast like this, but I doubt that someone will
				 * have a writeup longer than Integer.MAX_VALUE 
				*/
	/*
				clob = records.getClob(5);
				briefDescription = clob.getSubString(1, (int) clob.length());
				
				clob = records.getClob(6);
				longDescription = clob.getSubString(1, (int) clob.length());
				
				clob = records.getClob(7);
				impact = clob.getSubString(1, (int) clob.length());
				
				clob = records.getClob(8);
				recomendations = clob.getSubString(1, (int) clob.length());
				
				clob = records.getClob(9);
				references = clob.getSubString(1, (int) clob.length());
				
				clob = records.getClob(10);
				url = clob.getSubString(1, (int) clob.length());

//				event = new ReportableEvent(time, source, severity, url, title, briefDescription, longDescription, impact, recomendations, references);
				moreEvents = records.next();
			}
		}
		catch (SQLException e)
		{
			Debug.errDebug("SQL error in ReportGenerator.getNextEvent(): " + e.toString(), e);
		}
		
		return event;
	}
	
	
	protected void queryEvents()
	{
		String query = "SELECT \n" +
							"Time, Source, Severity, Title, BriefDescription, \n" + 
							"LongDescription, Impact, Recomendations, References, URL \n" +
						"FROM RecordableEvents \n" +
						"WHERE Severity >= ?";
		try
		{
			PreparedStatement statement = scan.getDatabaseConnection().prepareStatement(query);
			statement.setInt(1, reportSettings.getMinSeverity());
			records = statement.executeQuery();
			moreEvents = records.next();
		}
		catch (SQLException e)
		{
			Debug.errDebug("SQL error in ReportGenerator.queryEvents: " + e.toString());
		}
	}
*/	 
}
