package com.grendelscan.scan.reporting;

public enum EventSeverity
{
	INFO(3, "Informational"), 
	LOW(4, "Low"), 
	MEDIUM(5, "Medium"), 
	HIGH(6, "High");
	
	private int value;
	private String fullName;
	private EventSeverity(int value, String name)
    {
		this.value = value;
		this.fullName = name;
    }
	
	public static String[] getAllNames()
	{
		return new String[] {INFO.fullName, LOW.fullName, MEDIUM.fullName, HIGH.fullName};
	}
	
	public static EventSeverity getSeverityByName(String name)
	{
		EventSeverity severity = null;
		if (name.equalsIgnoreCase(INFO.fullName))
		{
			severity = INFO;
		}
		else if (name.equalsIgnoreCase(LOW.fullName))
		{
			severity = LOW;
		}
		else if (name.equalsIgnoreCase(MEDIUM.fullName))
		{
			severity = MEDIUM;
		}
		else if (name.equalsIgnoreCase(HIGH.fullName))
		{
			severity = HIGH;
		}
		
		return severity;
	}
	
	/**
	 * Returns greater than zero if target is higher severity, zero if 
	 * it is equal, or less than zero if target is less severe.  
	 * @param target
	 * @return
	 */
	public int compare(EventSeverity target)
	{
		return target.value - value;
	}

	public String getFullName()
    {
    	return fullName;
    }
}
