/*
 * Module00001.java
 *
 * Created on September 15, 2007, 10:49 PM
 *
 * To change this template, choose Tools | Template Manager
 * and open the template in the editor.
 */

package com.grendelscan.tests.testModules;

import java.net.URISyntaxException;
import java.util.regex.Matcher;
import java.util.regex.Pattern;

import com.grendelscan.requester.TransactionSource;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.requester.http.transactions.HttpGetTransaction;
import com.grendelscan.tests.testTypes.ByHttpResponseCodeTest;
import com.grendelscan.utils.*;
/**
 *
 * @author Administrator
 */
public class Module0001 extends TestModule implements ByHttpResponseCodeTest
{
	
	public String[] getResponseCodes()
    {
	    return new String[] {"200"};
    }

	private static Pattern urlPattern;
	public TestModuleGUIPath getGUIDisplayPath()
	{
		return TestModuleGUIPath.SPIDER;
	}
    
    public int getModuleNumber()
        {return 1;}
    
    public String getName()
        {return "URL-Regex";}
    
    public String getLongName()
        {return getName();}
    
    public String getDescription()
    {
    	return "Searches all responses for simple, full URLs using a regex. " + 
				"Enable this module ONLY if you are familiar with the application. " +
				"For example, if there is a link that deletes content, this module " +
				"won't know that it's dangerous. The risk can be mitigated by " +
				"using the URL blacklist feature. Note that the HTTP standard " +
				"states that GET should only be used for requests that will not " +
				"modify data. That doesn't mean that all applications comply.";
    }
    
    
    public void testByHttpResponseCode(int transactionID)
    {
    	AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(transactionID);
    	if (!MimeUtils.isWebMimeType(transaction.getResponseMimeType()))
    	{
    		return;
    	}
        String response = transaction.getResponseBodyAsString();
        Matcher matcher = urlPattern.matcher(response);
        
        while(matcher.find() && scan.isRunning())
        {
        	try
        	{
        		String url = StringUtils.decodeHtml(matcher.group(1));
	        	HttpGetTransaction request = new HttpGetTransaction(scan, url, transaction.getId(), TransactionSource.SPIDER);
	            request.setReferer(transaction);
	           	scan.getRequesterQueue().addSpiderRequest(request, false, "Module 1");
        	}
        	catch (URISyntaxException e) 
			{
        		Debug.errDebug("Bad URI syntax in Module0001 (" + matcher.group() + "): " + e.toString());
			}
        }
    }
    
    public void initialize()
    {
        urlPattern = Pattern.compile(
                "(https?://[\\-a-z0-9.]+(?::\\d+)?(?:/[^\\x00-\\x20\\x7f\"#<>'\\\\]+))",        		
            Pattern.CASE_INSENSITIVE | Pattern.MULTILINE );

    }

	@Override
    public boolean isExperimental()
    {
	    return false;
    }
    
}
