package com.grendelscan.tests.testModules;

import com.grendelscan.requester.authentication.AuthenticationPackage;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.libraries.SessionIDTesting.SessionID;
import com.grendelscan.tests.libraries.SessionIDTesting.SessionIDLocation;
import com.grendelscan.tests.testTypes.ByAuthenticationPackageTest;

public class Module0012 extends TestModule implements ByAuthenticationPackageTest
{
	private boolean sessionIDsIntialized = false;
	@Override
	public String getDescription()
	{
		return "Simple module to handle the authentication packages. And look for session IDs." +
				"It will request them and send the results off for sessionID testing " +
				"and spidering";
	}

	@Override
	public TestModuleGUIPath getGUIDisplayPath()
	{
		return TestModuleGUIPath.HIDDEN;
	}

	@Override
	public int getModuleNumber()
	{
		return 12;
	}

	@Override
	public String getName()
	{
		
		return "AuthPackageHandler";
	}

	@Override
	public void initialize()
	{

	}

	public void testAuthenticationPackage(AuthenticationPackage authenticationPackage)
	{
		if (!scan.isRunning())
		{
			return;
		}

		if (!sessionIDsIntialized)
		{
			sessionIDsIntialized = true;
			AbstractHttpTransaction loginTransactionNoTesting = authenticationPackage.createAnyLoginTransaction();
			loginTransactionNoTesting.setFollowRedirects(false);
			loginTransactionNoTesting.execute("Module " + this.getModuleNumber(), false);
			
			// If cookies were set, look for session IDs, but only once
			if(loginTransactionNoTesting.getResponseHeaders("Set-Cookie").length > 0)
			{
				SessionID.seedSessionIDDatabase(loginTransactionNoTesting, "Module " + this.getModuleNumber());
			}
			
			SessionIDLocation sessionIDLocation = SessionID.findSessionIDLocation(loginTransactionNoTesting);
			scan.getCategorizers().getInitialAuthenticationCategorizer().analyzeAuthentication(loginTransactionNoTesting, sessionIDLocation);
		}
		
		scan.getRequesterQueue().addRequests(authenticationPackage.createLoginTransactions(), "Module " + this.getModuleNumber());
	}

	@Override
    public boolean alwaysEnabled()
    {
	    return true;
    }

	@Override
    public boolean hidden()
    {
	    return true;
    }

	@Override
    public int[] getPrerequisites()
    {
//	    return new int[] {23};
	    return new int[] {};
    }

	@Override
    public boolean isExperimental()
    {
	    return false;
    }

}
