package com.grendelscan.tests.testModules;


import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.libraries.nikto.Nikto;
import com.grendelscan.tests.testTypes.ByFileTest;

public class Module0016 extends TestModule implements ByFileTest
{

	@Override
	public String getDescription()
	{
		return "Records \"Server\" and \"X-Powered-By\" header values in the Nikto library"; 
	}

	@Override
	public TestModuleGUIPath getGUIDisplayPath()
	{
		return TestModuleGUIPath.HIDDEN;
	}

	@Override
	public int getModuleNumber()
	{
		return 16;
	}

	@Override
    public boolean hidden()
    {
	    return true;
    }

	@Override
	public String getName()
	{
		return "\"Server\" and \"X-Powered-By\" header recording";
	}

	@Override
	public void initialize()
	{

	}

	public String[] getResponseHeaders()
	{
		String [] headers = {"Server", "X-Powered-By"};
		return headers;
	}

	public void testByFile(int transactionID)
    {
		if (!scan.isRunning())
		{
			return;
		}
    	AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(transactionID);
		Nikto.addServerHeader(transaction);
    }

	@Override
    public boolean isExperimental()
    {
	    return false;
    }

}
