/**
 * Module0019.java
 * Created by: David Byrne
 * Created on: Jan 15, 2008
 */
package com.grendelscan.tests.testModules;

import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.scan.ScanPhase;
import com.grendelscan.tests.testTypes.ByDirectoryTest;
/**
 * @author David Byrne
 *
 */
public class Module0019 extends TestModule implements ByDirectoryTest
{
	private boolean useAutomatic;
	private boolean testAllDirectories;
	
	/**
	 * 
	 */
	public Module0019()
	{
		
	}

	
	public boolean alwaysEnabled()
	{
		return false;
	}
	
	@Override
	public String getDescription()
	{
		return "Checks for logical 404 messages for every new directory.";
	}

	@Override
	public TestModuleGUIPath getGUIDisplayPath()
	{
		return TestModuleGUIPath.HIDDEN;
	}

	@Override
	public int getModuleNumber()
	{
		return 19;
	}

	@Override
	public String getName()
	{
		return "404 directory tester";
	}

	/* (non-Javadoc)
	 * @see grendel.tests.testModules.TestModule#initialize()
	 */
	@Override
	public void initialize()
	{
		useAutomatic = scan.getScanSettings().getUseAutomaticResponseCodeOverrides();
		testAllDirectories = scan.getScanSettings().getTestAllDirectoriesForResponseCodeOverrides();
	}

	/* (non-Javadoc)
	 * @see grendel.tests.testTypes.ByDirectoryTest#testByDirectory(grendel.requester.http.AbstractHttpTransaction)
	 */
	public void testByDirectory(int transactionID, String directory)
	{
		if (!scan.isRunning())
		{
			return;
		}
    	AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(transactionID);
		if (useAutomatic && (scan.getScanPhase() == ScanPhase.INITIALIZATION || (!directory.equals("/") && testAllDirectories)))
		{
			String uri = transaction.getHostUri().replaceFirst("/$", "") + directory;
			scan.getResponseCodeOverrides().generateAllAutomaticOverrides(uri);
		}
	}

	@Override
    public boolean hidden()
    {
	    return true;
    }


	@Override
    public boolean isExperimental()
    {
	    return false;
    }

}
