package com.grendelscan.tests.testModules;

import com.grendelscan.requester.TransactionSource;
import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
import com.grendelscan.tests.libraries.TokenTesting.TokenTesting;
import com.grendelscan.tests.testTypes.ByHttpQueryParameterTest;

public class Module0020 extends TestModule implements ByHttpQueryParameterTest
{
	
	@Override
	public String getDescription()
	{
		return "Sends a random token into each query parameter. Not very useful on its own, "
		        + "but it helps track output & output validation (XSS, etc).";
	}
	
	@Override
	public TestModuleGUIPath getGUIDisplayPath()
	{
		return TestModuleGUIPath.HIDDEN;
	}
	
	@Override
	public int getModuleNumber()
	{
		return 20;
	}
	
	@Override
	public String getName()
	{
		return "Token submitter";
	}
	
	@Override
	public boolean hidden()
	{
		return true;
	}
	
	@Override
	public void initialize()
	{
		
	}
	
	public void testByQueryParameter(int transactionID, String parameterName)
	{
		if (!scan.isRunning())
		{
			return;
		}
    	AbstractHttpTransaction transaction = scan.getTransactionRecord().getTransaction(transactionID);
		AbstractHttpTransaction testTransaction = transaction.clone(TransactionSource.TEST);
		String token = TokenTesting.generateToken();
		testTransaction.replaceQueryParameter(parameterName, token);
		TokenTesting.recordTokenTest(token, testTransaction);
		scan.getRequesterQueue().addRequest(testTransaction, "Module 20");
	}

	@Override
    public boolean isExperimental()
    {
	    return false;
    }
}
