//package com.grendelscan.tests.testModules;
//import java.net.URISyntaxException;
//import java.util.regex.Matcher;
//import java.util.regex.Pattern;
//
//import com.grendelscan.requester.TransactionSource;
//import com.grendelscan.requester.authentication.AuthenticationPackage;
//import com.grendelscan.requester.http.factories.HttpTransactionFactory;
//import com.grendelscan.requester.http.transactions.AbstractHttpTransaction;
//import com.grendelscan.tests.testTypes.ByAuthenticationPackageTest;
//import com.grendelscan.utils.Debug;
//import com.grendelscan.utils.HttpTransactionUtils;
//import com.grendelscan.utils.StringUtils;
//
//public class Module0023 extends TestModule implements ByAuthenticationPackageTest
//{
//	private int loggedOutCompareThreshold = 85;
//	@Override
//	public String getDescription()
//	{
//		return "If logged out detection is enabled, builds a profile " +
//				"of what a logged out session looks like.";
//	}
//	
//	@Override
//	public TestModuleGUIPath getGUIDisplayPath()
//	{
//		return TestModuleGUIPath.HIDDEN;
//	}
//	
//	@Override
//	public int getModuleNumber()
//	{
//		return 23;
//	}
//	
//	@Override
//	public String getName()
//	{
//		return "Logged out profile builder";
//	}
//	
//	@Override
//	public void initialize()
//	{
//	}
//	
//	public void testAuthenticationPackage(AuthenticationPackage authenticationPackage)
//	{
//		if (scan.getScanSettings().isUseLoggedOutDetection())
//		{
//			getErrorPageText(authenticationPackage);
//		}
//	}
//
//
//	private void getErrorPageText(AuthenticationPackage authenticationPackage)
//	{
//		AbstractHttpTransaction loginTransaction = authenticationPackage.createAnyLoginTransaction();
//		loginTransaction.execute("Module 23", false);
//		for (String stateNames: loginTransaction.getSessionStates().keySet())
//		{
//			authenticationPackage.getSessionIDNames().add(stateNames);
//		}
//
//		String text = null;
//		String logoutUri = scan.getScanSettings().getLogoutUri();
//		if (logoutUri != null && !logoutUri.equals(""))
//		{
//			try
//            {
//	            AbstractHttpTransaction nonAuthTransaction = HttpTransactionFactory.createTransaction(scan, "GET", logoutUri, loginTransaction.getId(), TransactionSource.AUTHENTICATION);
//	            nonAuthTransaction.execute("Module 23", false);
//	            text = nonAuthTransaction.getResponseTextNodes();
//            }
//            catch (URISyntaxException e)
//            {
//            	Debug.errDebug("Problem with logout URI: " + e.toString(), e);
//            }
//		}
//
//		if (text == null && loginTransaction.getRedirectRequestTransactionID() > 0)
//		{
//			AbstractHttpTransaction nonAuthTransaction = loginTransaction.getReferer().clone(TransactionSource.AUTHENTICATION);
//			nonAuthTransaction.removeAllAuthentication();
//			nonAuthTransaction.execute("Module 23", false);
//			text = nonAuthTransaction.getResponseTextNodes();
//		}
//
//		if (text == null)
//		{
//			Pattern p = Pattern.compile("href\\s*=\\s*['\"]?((?:/|" + loginTransaction.getHostUri() + ")[\\s'\"]+)", Pattern.CASE_INSENSITIVE);
//			Matcher m = p.matcher(loginTransaction.getResponseBodyAsString());
//			while (m.find())
//			{
//				text = checkLoggedOutSuitibility(loginTransaction, m.group(1)); 
//				if (text != null || !scan.isRunning())
//				{
//					break;
//				}
//			}
//		}
//		authenticationPackage.setLoggedOutPageText(text);
//	}
//	
//	private String checkLoggedOutSuitibility(AbstractHttpTransaction referingTransaction, String uri)
//	{
//		String text = null;
//		try
//        {
//			// Get two samples of the authenticated request
//	        AbstractHttpTransaction testAuthTransaction1 = HttpTransactionFactory.createTransaction(scan, "GET", uri, referingTransaction.getId(), TransactionSource.AUTHENTICATION);
//	        testAuthTransaction1.execute("Module 23", false);
//			if (!scan.isRunning())
//			{
//				return text;
//			}
//	        AbstractHttpTransaction testAuthTransaction2 = HttpTransactionFactory.createTransaction(scan, "GET", uri, referingTransaction.getId(), TransactionSource.AUTHENTICATION);
//	        testAuthTransaction2.execute("Module 23", false);
//			if (!scan.isRunning())
//			{
//				return text;
//			}
//
//	        // If there is page stability...
////	        if (StringUtils.scoreStringDifferenceIgnoreCase(testAuthTransaction1.getResponseTextNodes(), testAuthTransaction2.getResponseTextNodes(), 100) > loggedOutCompareThreshold)
//    		if (HttpTransactionUtils.scoreResponseMatch(testAuthTransaction1, testAuthTransaction2, 100) > loggedOutCompareThreshold)
//	        {
//		        // Get the same url, but without the cookies, etc
//		        AbstractHttpTransaction testNonAuthTransaction = HttpTransactionFactory.createTransaction(scan, "GET", uri, 0, TransactionSource.AUTHENTICATION);
//		        // Get rid of any session states. This should only be params, since cookies won't propigate without a referer
//		        testNonAuthTransaction.removeAllAuthentication();
//		        testNonAuthTransaction.execute("Module 23", false);
//		        
//		        /*
//		         *  If the two transactions are significantly different, assume that one is an error 
//		         *  message because of no session ID provided.
//		         */
//
////		        if (StringUtils.scoreStringDifferenceIgnoreCase(testAuthTransaction1.getResponseTextNodes(), testNonAuthTransaction.getResponseTextNodes(), 100) < loggedOutCompareThreshold)
//				if (HttpTransactionUtils.scoreResponseMatch(testAuthTransaction1, testNonAuthTransaction, 100) < loggedOutCompareThreshold)
//		        {
//		        	text = testNonAuthTransaction.getResponseTextNodes();
//		        }
//	        }
//        }
//        catch (URISyntaxException e)
//        {
//        	// An invalid URI was provided. Just ignore it and continue
//        }
//
//        return text;
//	}
//	
//	@Override
//    public boolean alwaysEnabled()
//    {
//	    return true;
//    }
//
//	@Override
//    public boolean hidden()
//    {
//	    return true;
//    }
//
//	@Override
//    public boolean isExperimental()
//    {
//	    return true;
//    }
//
//	
//}
