/*
 * TestModule.java
 * 
 * Created on September 15, 2007, 9:01 PM
 * 
 * To change this template, choose Tools | Template Manager and open the
 * template in the editor.
 */

package com.grendelscan.tests.testModules;


import java.util.ArrayList;
import java.util.List;

import org.w3c.dom.html2.HTMLElement;

import com.grendelscan.requester.authentication.AuthenticationPackage;
import com.grendelscan.scan.Scan;
import com.grendelscan.tests.libraries.TokenTesting.TokenContextType;
import com.grendelscan.tests.testModules.settings.ConfigurationOption;

/**
 * 
 * @author Administrator
 */
public abstract class TestModule
{
//	public abstract boolean isSessionSensative();
	protected List<ConfigurationOption> configurationOptions;

	public TestModule()
	{
		configurationOptions = new ArrayList<ConfigurationOption>();
	}
	
	protected Scan scan;

	public boolean alwaysEnabled()
	{
		return false;
	}

	public List<ConfigurationOption> getConfigurationOptions()
	{
		return configurationOptions;
	}

	public abstract String getDescription();

	public abstract TestModuleGUIPath getGUIDisplayPath();

	public abstract int getModuleNumber();

	public abstract String getName();

	public int[] getPrerequisites()
	{
		return new int[0];
	}

	public  int[] getSoftPrerequisites()
	{
		return new int[0];
	}


	public boolean hidden()
	{
		return false;
	}

	public abstract void initialize();

	public boolean runInPrimaryPhase()
	{
		return true;
	}

	public boolean runInRecrawlPhase()
	{
		return false;
	}

	/**
	 * Called when the scan is complete. This lets modules report on things
	 * they've been storing up.
	 */
	public void scanIsComplete()
	{

	}

	/**
	 * @param sharedComponents
	 *            the sharedComponents to set
	 */
	public void setScan(Scan scan)
	{
		this.scan = scan;
	}

	public abstract boolean isExperimental();
	
	public String getExperimentalText()
	{
		return "";
	}
	
	
}
