package com.grendelscan.tests.testModules.settings;

import java.util.ArrayList;
import java.util.List;

public class MultiSelectOptionGroup extends ConfigurationOption implements OptionGroup
{
	List<SelectableOption> options;
	
	public MultiSelectOptionGroup(String name, String helpText)
	{
		super(name, helpText);
		options = new ArrayList<SelectableOption>();
	}
	
	public void addOption(String name, boolean defaultValue, String helpText)
	{
		SelectableOption option = new SelectableOption(name, defaultValue, helpText);
		options.add(option);
	}
	
	public void addOption(SelectableOption option)
	{
		options.add(option);
	}
	
	public List<SelectableOption> getAllOptions()
	{
		return options;
	}
}
