package com.grendelscan.tests.testModules.settings;

import java.util.ArrayList;
import java.util.List;

public class SingleSelectOptionGroup extends ConfigurationOption implements OptionGroup
{
	List<SelectableOption> options;
	SelectableOption selectedOption;
	
	public SingleSelectOptionGroup(String name, String helpText)
	{
		super(name, helpText);
		options = new ArrayList<SelectableOption>();
	}
	    
	public void addOption(String name, String helpText)
	{
		SelectableOption option = new SelectableOption(name, false, helpText);
		options.add(option);
	}
	
	public void addOption(SelectableOption option)
	{
		options.add(option);
	}

	public SelectableOption getSelectedOption()
    {
    	return selectedOption;
    }

	public void setSelectedOption(SelectableOption selectedOption)
    {
		if (options.contains(selectedOption))
		{
			this.selectedOption = selectedOption;
		}
    }

	public List<SelectableOption> getAllOptions()
	{
		return options;
	}
}
