package com.grendelscan.utils;

import java.util.*;

public class HttpTransactionMatchCriteriaWeights
{
	private int responseCode = 50;
	private int locationHeader = 50;
	private int mimeType = 50;
	private int setCookieName = 50;
	private int textNodes = 50;
	private Map<String, Integer> tagCounts;
	
	public int getResponseCode()
    {
    	return responseCode;
    }

	public void setResponseCode(int responseCode)
    {
    	this.responseCode = responseCode;
    }

	public int getLocationHeader()
    {
    	return locationHeader;
    }

	public void setLocationHeader(int locationHeader)
    {
    	this.locationHeader = locationHeader;
    }

	public int getMimeType()
    {
    	return mimeType;
    }

	public void setMimeType(int mimeType)
    {
    	this.mimeType = mimeType;
    }

	public int getSetCookieName()
    {
    	return setCookieName;
    }

	public void setSetCookieName(int cookieName)
    {
    	this.setCookieName = cookieName;
    }

	public int getTextNodes()
    {
    	return textNodes;
    }

	public void setTextNodes(int textNodes)
    {
    	this.textNodes = textNodes;
    }

	public Map<String, Integer> getTagCounts()
    {
    	return tagCounts;
    }

	public HttpTransactionMatchCriteriaWeights()
	{
		tagCounts = Collections.synchronizedMap(new HashMap<String, Integer>(1));
		initDefaults();
	}
	
	private void initDefaults()
	{
		// These can only subtract score up to their weight
		locationHeader = 50;
		setCookieName = 50;
		mimeType = 50;
		
		// These can add or subtract up to their weight
		responseCode = 50;
		
		// These can only add score up to their weight
		textNodes = 50;
		tagCounts.put("APPLET", 50);
		tagCounts.put("OBJECT", 50);
		tagCounts.put("EMBED", 50);
		tagCounts.put("A", 10);
		tagCounts.put("LINK", 10);
		tagCounts.put("IMG", 10);
		tagCounts.put("TABLE", 20);
	}
	
	public int getMaxScore()
	{
		int score = 0;
		score += textNodes;
		score += responseCode;
		score += textNodes;
		for (Integer value: tagCounts.values())
		{
			score += value;
		}
		return score;
	}
	
}
