package org.cobra_grendel.html.domimpl;

import org.w3c.dom.Document;
import org.w3c.dom.html2.HTMLFormElement;
import org.w3c.dom.html2.HTMLObjectElement;

public class HTMLObjectElementImpl extends HTMLAbstractUIElement implements HTMLObjectElement
{
	public HTMLObjectElementImpl(String name)
	{
		super(name);
	}
	
	public String getAlign()
	{
		return getAttribute("align");
	}
	
	public String getAlt()
	{
		return getAttribute("alt");
	}
	
	public String getArchive()
	{
		return getAttribute("archive");
	}
	
	public String getBorder()
	{
		return getAttribute("border");
	}
	
	public String getCode()
	{
		return getAttribute("code");
	}
	
	public String getCodeBase()
	{
		return getAttribute("codebase");
	}
	
	public String getCodeType()
	{
		return getAttribute("codetype");
	}
	
	public Document getContentDocument()
	{
		return getOwnerDocument();
	}
	
	public String getData()
	{
		return getAttribute("data");
	}
	
	public boolean getDeclare()
	{
		return "declare".equalsIgnoreCase(getAttribute("declare"));
	}
	
	public HTMLFormElement getForm()
	{
		return (HTMLFormElement) getAncestorForJavaClass(HTMLFormElement.class);
	}
	
	public String getHeight()
	{
		return getAttribute("height");
	}
	
	public int getHspace()
	{
		try
		{
			return Integer.parseInt(getAttribute("hspace"));
		}
		catch (Exception err)
		{
			return 0;
		}
	}
	
	public String getName()
	{
		return getAttribute("name");
	}
	
	public String getObject()
	{
		return getAttribute("object");
	}
	
	public String getStandby()
	{
		return getAttribute("standby");
	}
	
	public int getTabIndex()
	{
		try
		{
			return Integer.parseInt(getAttribute("tabindex"));
		}
		catch (Exception err)
		{
			return 0;
		}
	}
	
	public String getType()
	{
		return getAttribute("type");
	}
	
	public String getUseMap()
	{
		return getAttribute("usemap");
	}
	
	public int getVspace()
	{
		try
		{
			return Integer.parseInt(getAttribute("vspace"));
		}
		catch (Exception err)
		{
			return 0;
		}
	}
	
	public String getWidth()
	{
		return getAttribute("width");
	}
	
	public void setAlign(String align)
	{
		setAttribute("align", align);
	}
	
	public void setAlt(String alt)
	{
		setAttribute("alt", alt);
	}
	
	public void setArchive(String archive)
	{
		setAttribute("archive", archive);
	}
	
	public void setBorder(String border)
	{
		setAttribute("border", border);
	}
	
	public void setCode(String code)
	{
		setAttribute("code", code);
	}
	
	public void setCodeBase(String codeBase)
	{
		setAttribute("codebase", codeBase);
	}
	
	public void setCodeType(String codeType)
	{
		setAttribute("codetype", codeType);
	}
	
	public void setData(String data)
	{
		setAttribute("data", data);
	}
	
	public void setDeclare(boolean declare)
	{
		setAttribute("declare", declare ? "declare" : null);
	}
	
	public void setHeight(String height)
	{
		setAttribute("height", height);
	}
	
	public void setHspace(int hspace)
	{
		setAttribute("hspace", String.valueOf(hspace));
	}
	
	public void setName(String name)
	{
		setAttribute("name", name);
	}
	
	public void setObject(String object)
	{
		setAttribute("object", object);
	}
	
	public void setStandby(String standby)
	{
		setAttribute("standby", standby);
	}
	
	public void setTabIndex(int tabIndex)
	{
		setAttribute("tabindex", String.valueOf(tabIndex));
	}
	
	public void setType(String type)
	{
		setAttribute("type", type);
	}
	
	public void setUseMap(String useMap)
	{
		setAttribute("usemap", useMap);
	}
	
	public void setVspace(int vspace)
	{
		setAttribute("vspace", String.valueOf(vspace));
	}
	
	public void setWidth(String width)
	{
		setAttribute("width", width);
	}
}
