package org.cobra_grendel.html.domimpl;

import org.w3c.dom.html2.HTMLFormElement;
import org.w3c.dom.html2.HTMLOptionElement;
import org.w3c.dom.html2.HTMLSelectElement;

public class HTMLOptionElementImpl extends HTMLElementImpl implements HTMLOptionElement
{
	public HTMLOptionElementImpl(String name)
	{
		super(name, true);
	}
	
	public boolean getDefaultSelected()
	{
		return getAttributeAsBoolean("selected");
	}
	
	public boolean getDisabled()
	{
		return false;
	}
	
	public HTMLFormElement getForm()
	{
		return getForm();
	}
	
	public int getIndex()
	{
		Object parent = getParentNode();
		if (parent instanceof HTMLSelectElement)
		{
			HTMLOptionsCollectionImpl options = (HTMLOptionsCollectionImpl) ((HTMLSelectElement) parent).getOptions();
			return options.indexOf(this);
		}
		else
		{
			return -1;
		}
	}
	
	public String getLabel()
	{
		return getAttribute("label");
	}
	
	public boolean getSelected()
	{
		Object parent = getParentNode();
		if (parent instanceof HTMLSelectElement)
		{
			return ((HTMLSelectElement) parent).getSelectedIndex() == getIndex();
		}
		else
		{
			return false;
		}
	}
	
	public String getText()
	{
		return getRawInnerText(false);
	}
	
	public String getValue()
	{
		return getAttribute("value");
	}
	
	public void setDefaultSelected(boolean defaultSelected)
	{
		setAttribute("selected", defaultSelected ? "selected" : null);
	}
	
	public void setDisabled(boolean disabled)
	{
		// TODO Unsupported
	}
	
	public void setLabel(String label)
	{
		setAttribute("label", label);
	}
	
	public void setSelected(boolean selected)
	{
		Object parent = getParentNode();
		if (parent instanceof HTMLSelectElement)
		{
			if (selected)
			{
				((HTMLSelectElement) parent).setSelectedIndex(getIndex());
			}
			else
			{
				((HTMLSelectElement) parent).setSelectedIndex(-1);
			}
		}
	}
	
	public void setValue(String value)
	{
		setAttribute("value", value);
	}
}
