/*
 * GNU LESSER GENERAL PUBLIC LICENSE Copyright (C) 2006 The Lobo Project
 * 
 * This library is free software; you can redistribute it and/or modify it under
 * the terms of the GNU Lesser General Public License as published by the Free
 * Software Foundation; either version 2.1 of the License, or (at your option)
 * any later version.
 * 
 * This library is distributed in the hope that it will be useful, but WITHOUT
 * ANY WARRANTY; without even the implied warranty of MERCHANTABILITY or FITNESS
 * FOR A PARTICULAR PURPOSE. See the GNU Lesser General Public License for more
 * details.
 * 
 * You should have received a copy of the GNU Lesser General Public License
 * along with this library; if not, write to the Free Software Foundation, Inc.,
 * 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA
 * 
 * Contact info: xamjadmin@users.sourceforge.net
 */
/*
 * Created on Dec 4, 2005
 */
package org.cobra_grendel.html.domimpl;

// import org.cobra_grendel.html.style.*;
import org.w3c.dom.html2.HTMLTableCellElement;

public class HTMLTableCellElementImpl extends HTMLAbstractUIElement implements HTMLTableCellElement
{
	public HTMLTableCellElementImpl(String name)
	{
		super(name);
	}
	
	public String getAbbr()
	{
		return getAttribute("abbr");
	}
	
	public String getAlign()
	{
		return getAttribute("align");
	}
	
	public String getAxis()
	{
		return getAttribute("axis");
	}
	
	public String getBgColor()
	{
		return getAttribute("bgcolor");
	}
	
	public int getCellIndex()
	{
		// TODO Cell index in row
		return 0;
	}
	
	public String getCh()
	{
		return getAttribute("ch");
	}
	
	public String getChOff()
	{
		return getAttribute("choff");
	}
	
	public int getColSpan()
	{
		String colSpanText = getAttribute("colspan");
		if (colSpanText == null)
		{
			return 1;
		}
		else
		{
			try
			{
				return Integer.parseInt(colSpanText);
			}
			catch (NumberFormatException nfe)
			{
				return 1;
			}
		}
	}
	
	public String getHeaders()
	{
		return getAttribute("headers");
	}
	
	public String getHeight()
	{
		return getAttribute("height");
	}
	
	public boolean getNoWrap()
	{
		return "nowrap".equalsIgnoreCase(getAttribute("nowrap"));
	}
	
	public int getRowSpan()
	{
		String rowSpanText = getAttribute("rowspan");
		if (rowSpanText == null)
		{
			return 1;
		}
		else
		{
			try
			{
				return Integer.parseInt(rowSpanText);
			}
			catch (NumberFormatException nfe)
			{
				return 1;
			}
		}
	}
	
	public String getScope()
	{
		return getAttribute("scope");
	}
	
	public String getVAlign()
	{
		return getAttribute("valign");
	}
	
	public String getWidth()
	{
		return getAttribute("width");
	}
	
	public void setAbbr(String abbr)
	{
		setAttribute("abbr", abbr);
	}
	
	public void setAlign(String align)
	{
		setAttribute("align", align);
	}
	
	public void setAxis(String axis)
	{
		setAttribute("axis", axis);
	}
	
	public void setBgColor(String bgColor)
	{
		setAttribute("bgcolor", bgColor);
	}
	
	public void setCh(String ch)
	{
		setAttribute("ch", ch);
	}
	
	public void setChOff(String chOff)
	{
		setAttribute("choff", chOff);
	}
	
	public void setColSpan(int colSpan)
	{
		setAttribute("colspan", String.valueOf(colSpan));
	}
	
	public void setHeaders(String headers)
	{
		setAttribute("headers", headers);
	}
	
	public void setHeight(String height)
	{
		setAttribute("height", height);
	}
	
	public void setNoWrap(boolean noWrap)
	{
		setAttribute("nowrap", noWrap ? "nowrap" : null);
	}
	
	public void setRowSpan(int rowSpan)
	{
		setAttribute("rowspan", String.valueOf(rowSpan));
	}
	
	public void setScope(String scope)
	{
		setAttribute("scope", scope);
	}
	
	public void setVAlign(String vAlign)
	{
		setAttribute("valign", vAlign);
	}
	
	public void setWidth(String width)
	{
		setAttribute("width", width);
	}
	
	// protected RenderState createRenderState(RenderState prevRenderState) {
	// return new TableCellRenderState(prevRenderState, this);
	// }
}
